<?php

/**
 * Project form base class.
 *
 * @package    form
 * @version    SVN: $Id: sfDoctrineFormBaseTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
abstract class BaseFormDoctrine extends sfFormDoctrine
{
  public function setup()
  {
  }

  public function useFields(array $fields = array(), $ordered = true)
  {
    $hidden = array();

    foreach ($this->widgetSchema->getFields() as $name => $field)
    {
      if ($field->getOption('hidden'))
      {
        $hidden[] = $name;
      }
      else if (!in_array($name, $fields))
      {
        unset($this[$name]);
      }
    }

    if ($ordered)
    {
      $this->widgetSchema->setPositions(array_merge($fields, $hidden));
    }
  }

  public function addCSRFProtection($secret = null)
  {
      parent::addCSRFProtection($secret);
      if (array_key_exists(self::$CSRFFieldName, $this->getValidatorSchema())) {
          $this->getValidator(self::$CSRFFieldName)->setMessage('csrf_attack', 'This session has expired. Please return to the home page and try again.');
      }
  }
}
