<?php

class LTRSearchForm extends BaseForm
{
    public function configure(){
        $this->setWidgets([
            'vehicle_type' => new sfWidgetFormChoice([
                'choices' => $this->getVehicleTypes()
            ]),
            'budget' => new sfWidgetFormChoice([
                'choices' => $this->getBudgets()
            ]),
            'location' => new sfWidgetFormChoice([
                'choices' => $this->getLocations()
            ]),
        ]);
    }

    private function getVehicleTypes(){

        $sortedCategories = [
            'Standard car' => 'Standard car',
            '4WD/Ute' => '4WD/Ute',
            'Electric/Hybrid' => 'Electric/Hybrid',
            'Van' => 'Van',
            'Other' => 'Other',
        ];
        $types = [];
        foreach ($this->getOption('rentals', []) as $rental) {
            $category = $rental->getCategory();
            $types[$category] = $category;
        }
        asort($types);

        if (isset($types['Other'])) {
            $v = $types['Other'];
            unset($types['Other']);
            $types['Other'] = $v;
        }

        $types = array_intersect_key($sortedCategories, $types);

        return ['' => 'Any vehicle']+ $types;
    }

    private function getBudgets(){
        return ['' => 'Any price', 'asc' => 'Low to high price', 'desc' => 'High to low price'];
    }

    private function getLocations(){
        $locations = ['' => 'Any location'];
        foreach ($this->getOption('rentals', []) as $rental) {
            foreach ($rental->get('RentalPickup') as $pickup) {
                $name = trim(str_replace(['Airport', 'City'], '', $pickup->get('Locations')->get('name')));
                $locations[$name] = $name;
            }
        }

        asort($locations);

        return $locations;
    }
}