<?php

class RequestAcceptForm extends BaseForm
{
    public function configure()
    {
        if ($this->getOption('user')->mustCreditAccount($this->getOption('price', 0))) {
            $credits = VirtualCurrency::retrieveCreditsByCountryId($this->getOption('country'));
            $choices = array();
            foreach ($credits as $credit) {
                if ($credit->get('credit') >= abs($this->getOption('user')->get('account_balance'))) {
                    $choices[$credit->get('id')] = $credit->getPriceDetailed();
                }
            }
            $this->widgetSchema['credits'] = new sfWidgetFormChoice(array(
                'choices' => $choices,
                'expanded' => true
            ));

            $this->validatorSchema['credits'] = new sfValidatorChoice(array(
                'choices' => array_keys($choices)
            ));

            $this->setDefault('credits', key($choices));
        }

        $this->widgetSchema->setNameFormat('confirm[%s]');
    }
}
