<?php

class RequestNoShowForm extends BaseForm
{
    public function configure()
    {
        $this->widgetSchema['comment'] = new sfWidgetFormTextarea();
        $this->validatorSchema['comment'] = new sfValidatorString(array('required' => true));

        $this->widgetSchema['internal_comment'] = new sfWidgetFormTextarea();
        $this->validatorSchema['internal_comment'] = new sfValidatorString(array('required' => true, 'min_length' => 10));


        $this->widgetSchema->setLabels(array(
            'comment' => 'Public (displayed to the driver) * required',
            'internal_comment' => 'Comments'
        ));

        $this->widgetSchema->setNameFormat('request[%s]');

        $formatter = $this->getWidgetSchema()->getFormFormatter();
        $formatter->setErrorListFormatInARow('<div class="alert-box alert">%errors%</div>');
        $formatter->setErrorRowFormatInARow('%error% ');
    }
}
