<?php

class RequestRateForm extends BaseForm
{
    private static $choices = array(
        -1 => 'Negative',
        0  => 'Neutral',
        1  => 'Positive'
    );

    public function configure()
    {
        $this->widgetSchema['driver_rate'] = new sfWidgetFormChoice(array(
            'choices' => self::$choices,
            'expanded' => true,
            'renderer_options' => array('formatter' => array($this, 'formatRates')),
        ));
        $this->widgetSchema->setLabel('driver_rate', 'Confirm the driver successfully relocated your vehicle and provide feedback');
        $this->widgetSchema['comment'] = new sfWidgetFormTextarea();
        $this->widgetSchema['internal_comment'] = new sfWidgetFormTextarea();

        $this->validatorSchema['comment'] = new sfValidatorString(array('required' => false));
        $this->validatorSchema['internal_comment'] = new sfValidatorString(array('required' => false));

        $this->validatorSchema['driver_rate'] = new sfValidatorChoice(array(
            'choices' => array_keys(self::$choices),
        ));

        $this->widgetSchema->setNameFormat('request[%s]');
    }

    public function formatRates($widget, $inputs)
    {
        $rows = array();
        foreach ($inputs as $input)
        {
          $rows[] = $widget->renderContentTag('div', $input['input'].$this->getOption('label_separator').$input['label'], array('class' => 'four columns'));
        }

        return $widget->renderContentTag('div', implode($this->getOption('separator'), $rows), array('class' => 'row text-center'));
    }
}
