<?php

/**
 */

use Transfercar\Mailchimp\MailchimpApi;

class SignUpNewsletterForm extends BaseForm
{
    public function __construct($defaults = array(), $options = array(), $CSRFSecret = null)
    {
      //disable CSRF
      parent::__construct($defaults, $options, false);
    }

    public function configure()
    {
    	// Define form fields
        $this->setWidgets(array(
            'email' => new sfWidgetFormInput(array(), array('type' => 'email'))
        ));

        $this->widgetSchema->setNameFormat('newsletter[%s]');

        $this->setValidators(array(
            'email' => new sfValidatorEmail(array(), array(
                'required' => 'This field is required',
                'invalid' => 'This is not valid e-mail address',
            )),
        ));

        $formatter = $this->getWidgetSchema()->getFormFormatter();

        $formatter->setErrorListFormatInARow('<small>%errors%</small>');
        $formatter->setErrorRowFormatInARow('%error% ');
    }

    public function save()
    {
      $registerNewsletter_data = $this->getValues();
      $domain = $this->getOption('domain');

      $key  = $this->getOption('key');

      //Add user to Mailchimp Web service
      $mc = new MailchimpApi();
      $mc->subscribe($key, $this->getValue('email'), '', '');
    }
}
