<?php

/**
 * Form for changing user mobile phone number
 *
 * @package transfercar
 * @subpackage form
 */

class SmsChangeForm extends BaseForm
{
    public function configure()
    {
        // Field list definition
        $this->setWidgets(array(
            'new' => new sfWidgetFormInput(array(), array('class' => 'form-control'))
        ));

        // Labels
        $this->widgetSchema->setLabels(array(
            'new' => 'New mobile phone number:'
        ));

        $this->widgetSchema->setNameFormat('mobile_change[%s]');

        $messages = array('invalid' => 'Invalid value');

        // Validators
        $this->setValidators(array(
          'new' => new sfValidatorRegex(array(
              'pattern' => '/^\+?\d{6,15}$/',
          ), array(
              'invalid' => 'Invalid phone number %value%.'
          ))
        ));

        $formatter = $this->getWidgetSchema()->getFormFormatter();
        $formatter->setErrorListFormatInARow('<small>%errors%</small>');
        $formatter->setErrorRowFormatInARow('%error% ');
    }

    public function save($user)
    {
      $user->set('mobile_phone', $this->getValue('new'));
      $user->set('sms_number_confirmed', false);
      $user->set('sms_number', null);
      $user->save();

      $this->sendConfirmationSms($user);
    }

    public function sendConfirmationSms($user)
    {
      tcUserSmsEvent::sendSmsCode($user, true);
    }
}
