<?php

/**
 * Form for changing user password
 *
 * @package transfercar
 * @subpackage form
 */

class changePasswordForm extends transfercarForm
{
    public function configure()
    {
        // Field list definition
        $this->setWidgets(array(
                'current' => new sfWidgetFormInputPassword(),
                'new' => new sfWidgetFormInputPassword(),
                'confirm' => new sfWidgetFormInputPassword()
            ));

        // Labels
        $this->widgetSchema->setLabels(array(
                'current' => 'Current password:',
                'new' => 'New:',
                'confirm' => 'Confirm:'
            ));

        $this->widgetSchema->setNameFormat('password[%s]');

        $messages = array(
            'invalid' => 'Invalid value',
            'min_length' => 'Password is too short');

        // Validators
        $this->setValidators(array(
                'current' => new myValidatorUserPassword(),
                'new' => new sfValidatorString(array('min_length' => 6), $messages),
                'confirm' => new sfValidatorString(array('min_length' => 6), $messages)
            ));

        $this->validatorSchema->setPostValidator(
            new sfValidatorSchemaCompare('new', '==', 'confirm',
                array('throw_global_error' => true),
                array('invalid' => 'Passwords did not match to each other')
            ));

    }
}
