<?php

/**
 * AdListingRoute form.
 *
 * @package    form
 * @subpackage AdListingRoute
 * @version    SVN: $Id: sfPropelFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class AdListingRouteForm extends BaseAdListingRouteForm
{
    public function configure()
    {
        $this->useFields(array('pickup_location_id', 'dropoff_location_id'));

        $locations = Doctrine::getTable('LocationNode')->findNestedByCountry($this->getOption('country'));

        $this->widgetSchema['pickup_location_id'] = new sfWidgetFormSelect(array(
          'choices' => array_merge(array('' => ''), $locations)
        ));

        $this->widgetSchema['dropoff_location_id'] = new sfWidgetFormSelect(array(
          'choices' => array_merge(array('' => ''), $locations)
        ));

        $this->mergePostValidator(new sfValidatorSchemaCompare(
          'pickup_location_id', 'not_equal', 'dropoff_location_id', array(), array(
            'invalid' => 'Pickup and dropoff must be different'
          )
        ));
    }
}