<?php

/**
 * Advertiser form.
 *
 * @package    form
 * @subpackage Advertiser
 * @version    SVN: $Id: sfPropelFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class AdvertiserForm extends BaseAdvertiserForm
{
  public function configure()
  {
    unset(
        $this['id'],
        $this['password'],
        $this['created_at'],
        $this['updated_at'],
        $this['notes']
    );

    $offsets = array_replace(array(0 => 'new'), $this->getObject()->get('seasonal_offsets') ?: array());

    $form = new BaseForm();
    foreach ($offsets as $key => $value) {
      $form->embedForm($key, new SeasonalOffsetForm(is_array($value) ? $value : array()));
    }

    $this->embedForm('seasonal_offsets', $form);

    $this->validatorSchema['contact_email'] = new sfValidatorEmail(array(), array('invalid' => 'Please enter a valid email address'));
    $formatter = $this->getWidgetSchema()->getFormFormatter();
    $formatter->setErrorListFormatInARow('%errors%');
    $formatter->setErrorRowFormatInARow('<div>%error%</div> ');
  }


  public function bind(array $taintedValues = null, array $taintedFiles = null)
  {
    $form = new BaseForm();

    foreach ($taintedValues['seasonal_offsets'] as $key => $value)
    {
      if (!isset($this['seasonal_offsets'][$name]))
      {
        $form->embedForm((string) $key, new SeasonalOffsetForm());
      }
    }

    $this->embedForm('seasonal_offsets', $form);

    parent::bind($taintedValues, $taintedFiles);
  }
}

class SeasonalOffsetForm extends BaseForm
{
  public function configure()
  {
    $choices = $choices;
    for ($i = 1; $i <= 20; $i++)
    {
      $choices[$i] = '+'.$i.' days';
    }

    $this->setWidgets(array(
      'from_date' => new sfWidgetFormInput(),
      'to_date'   => new sfWidgetFormInput(),
      'offset'    => new sfWidgetFormSelect(array('choices' => $choices)),
    ));

    $this->setValidators(array(
      'from_date' => new sfValidatorPass(),
      'to_date'   => new sfValidatorPass(),
      'offset'    => new sfValidatorChoice(array('choices' => range(1, 20), 'required' => false))
    ));
  }
}