<?php

/**
 * DriverReport form.
 *
 * @package    form
 * @subpackage DriverReport
 * @version    SVN: $Id: sfPropelFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class DriverReportForm extends BaseDriverReportForm
{
  public function configure()
  {
    unset($this['driver_id'],$this['owner_id'], $this['created_at'], $this['updated_at']);

    $this->widgetSchema['comment'] = new sfWidgetFormTextarea();
    $this->validatorSchema['comment']->setOption('required', true);

    $formatter = $this->getWidgetSchema()->getFormFormatter();
    $formatter->setErrorListFormatInARow('<small class="error">%errors%</small>');
    $formatter->setErrorRowFormatInARow('%error% ');
  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $reportReason = $this->getObject()->get('Reason');
    $driver = $this->getObject()->get('Driver');
    if ($reportReason->get('is_tc_ban')) {
      $driver->set('user_status', 'blocked');
      $driver->save($con);
    }
    $roBan = new RoBan();
    $roBan->set('Driver', $driver);
    $roBan->set('Ro', $this->getObject()->get('Owner'));
    $roBan->save($con);
  }


  public function renderHiddenFields()
  {
      $output = '';
      foreach ($this->getFormFieldSchema() as $name => $field)
      {
          if ($field->isHidden())
          {
              $output .= $field->render();
          }
      }

      return $output;
  }
}