<?php

use Transfercar\Mandrill\TcMandrill;

/**
 * Payments form.
 *
 * @package    form
 * @subpackage Payments
 * @version    SVN: $Id: sfPropelFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class PaymentsForm extends BasePaymentsForm
{
  public function configure()
  {
    unset(
        $this['id'],
        $this['type'],
        $this['is_new_type_payment'],
        $this['date'],
        $this['amount'],
        $this['national_currency_amount'],
        $this['user_id'],
        $this['status'],
        $this['assigned_record_id'],
        $this['country_id']
    );
  }

  public function refund($request)
  {
    $payment = new Payments();
    $payment->type = 'manual';
    $payment->date= date('Y-m-d H:i:s', time());
    $payment->amount = $this->getOption('amount');
    $payment->user_id = $this->getOption('owner_id');
    $payment->status = Payments::STATUS_ACCEPTED;
    $payment->description = $this->getValue('description');
    $payment->is_new_type_payment = "yes";
    $payment->save();

    $request->addInternalStatus(
        Request::INTERNAL_STATUS_REFUNDED,
        $this->getValue('description')
    );

    $request->save();

    $this->sendRefundNotification($request);
  }

  public function norefund($request)
  {
    $request->addInternalStatus(
        Request::INTERNAL_STATUS_NOT_REFUNDED,
        $this->getValue('description')
    );

    $request->save();

    $this->sendNoRefundNotification($request);
  }

  public function sendRefundNotification($request)
  {
    $this->sendNotification('refund-approuved', $request, Request::INTERNAL_STATUS_REFUNDED);
  }

  public function sendNoRefundNotification($request)
  {
    $this->sendNotification('refund-not-approuved', $request, Request::INTERNAL_STATUS_NOT_REFUNDED);
  }

  private function sendNotification($tpl_name, $request, $status)
  {
    $domain = $request->getCountryDomain();

    $manager = $request->get('Listing')->getManager();
    $email_opt_link = '';
    $template_data = array(
        'manager_full_name' => $manager->getFullName(),
        'driver_full_name'  => $request->get('Driver')->getFullName(),
        'tcid'              => $request->getIncrementedId(),
        'credits'           => $request->get('Listing')->getTotalPrice($request),
        'email_opt_link'    => $email_opt_link,
        'email_opt_link_real' => $email_opt_link,
        'message'           => $request->getInternalComment($status)
    );

    $mandrill = new TcMandrill();
    $mandrill->sendTemplate(
        'refund-approuved' == $tpl_name ? 'Credits refunded for listing {{TCID}}' : 'Credits not refunded for listing {{TCID}}',
        $manager->getEmailToParams(),
        $template_data,
        $tpl_name
    );
  }
}