<?php

/**
 * RelocationReview form.
 *
 * @package    form
 * @subpackage RelocationReview
 * @version    SVN: $Id: sfPropelFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class RelocationReviewForm extends BaseRelocationReviewForm
{
  public function configure()
  {
    $this->useFields(array('ro_score', 'ro_review', 'tc_score', 'tc_review'));

    $this->widgetSchema['ro_review'] = new sfWidgetFormTextarea();
    $this->widgetSchema['tc_review'] = new sfWidgetFormTextarea();

    $ratings = range(1,5);
    $ratings = array_combine($ratings, $ratings);
    $widget = new sfWidgetFormChoice(array(
      'choices' => $ratings,
      'expanded' => true,
      'renderer_options' => array(
        'formatter' => function($widget, $inputs) {
          $rows = array();
          foreach (array_reverse($inputs) as $input)
          {
            $rows[] = str_replace('<input ', '<input class="rating-input"', $input['input']).
                      str_replace('<label ', '<label class="rating-star fui-star-2"', $input['label']);
          }

          return $widget->renderContentTag('span', implode($widget->getOption('separator'), $rows), array('class' => 'rating'));
        })
    ));

    $this->widgetSchema['ro_score']  = $widget;
    $this->widgetSchema['tc_score']  = $widget;

    $this->validatorSchema['ro_review']->setOption('required', false);
    $this->validatorSchema['tc_review']->setOption('required', false);
  }
}