<?php

/**
 * SearchBeacon form.
 *
 * @package    form
 * @subpackage SearchBeacon
 * @version    SVN: $Id: sfPropelFormTemplate.php 6174 2007-11-27 06:22:40Z fabien $
 */
class SearchBeaconForm extends BaseSearchBeaconForm
{
    public function __construct($object = null, $options = array(), $CSRFSecret = null)
    {
        parent::__construct($object, $options, false);
    }

    public function configure()
    {
        $this->useFields(array('pickup', 'dropoff', 'pickup_date', 'nb_listings', 'nb_sponsored_ads'));
        $this->validatorSchema->setOption('allow_extra_fields', true);

        $this->validatorSchema['pickup'] = new sfValidatorAnd(array(
            $this->validatorSchema['pickup'],
            new sfValidatorCallback(array('callback' => array($this, 'cleanZero')))
        ), array('required' => false));

        $this->validatorSchema['dropoff'] = new sfValidatorAnd(array(
            $this->validatorSchema['dropoff'],
            new sfValidatorCallback(array('callback' => array($this, 'cleanZero')))
        ), array('required' => false));

        $this->validatorSchema['pickup_date'] = new sfValidatorAnd(array(
            $this->validatorSchema['pickup_date'],
            new sfValidatorCallback(array('callback' => array($this, 'cleanZero')))
        ), array('required' => false));
    }

    public function updateObject()
    {
        $object = parent::updateObject();
        $object->set('country_id', Doctrine::getTable('LocationCountry')->findOneByDomain($this->getOption('domain')));
    }

    public function cleanZero($validator, $value)
    {
        if ($value == '0' or $value == '1970-01-01') {
            return null;
        }

        return $value;
    }
}
