<?php

/**
 * AdListing form base class.
 *
 * @package    form
 * @subpackage ad_listing
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 8508 2008-04-17 17:39:15Z fabien $
 */
class BaseAdListingForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                      => new sfWidgetFormInputHidden(),
      'advertiser_id'           => new sfWidgetFormDoctrineSelect(array('model' => 'Advertiser', 'add_empty' => false)),
      'reference'               => new sfWidgetFormInput(),
      'status'                  => new sfWidgetFormInput(),
      'vehicle_type_id'         => new sfWidgetFormDoctrineSelect(array('model' => 'VehicleType', 'add_empty' => false)),
      'image'                   => new sfWidgetFormInput(),
      'transmission_type'       => new sfWidgetFormInput(),
      'travellers'              => new sfWidgetFormInput(),
      'price'                   => new sfWidgetFormInput(),
      'destination_url'         => new sfWidgetFormInput(),
      'url_parameters_defaults' => new sfWidgetFormInput(),
      'nb_clicks'               => new sfWidgetFormInput(),
      'nb_views'                => new sfWidgetFormInput(),
      'notes'                   => new sfWidgetFormInput(),
      'country_id'              => new sfWidgetFormDoctrineSelect(array('model' => 'LocationCountry', 'add_empty' => false)),
      'created_at'              => new sfWidgetFormDateTime(),
      'updated_at'              => new sfWidgetFormDateTime(),
      'ad_listing_routes_list'  => new sfWidgetFormDoctrineSelectMany(array('model' => 'AdListingRoute')),
    ));

    $this->setValidators(array(
      'id'                      => new sfValidatorDoctrineChoice(array('model' => 'AdListing', 'column' => 'id', 'required' => false)),
      'advertiser_id'           => new sfValidatorDoctrineChoice(array('model' => 'Advertiser')),
      'reference'               => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'status'                  => new sfValidatorNumber(),
      'vehicle_type_id'         => new sfValidatorDoctrineChoice(array('model' => 'VehicleType')),
      'image'                   => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'transmission_type'       => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'travellers'              => new sfValidatorNumber(array('required' => false)),
      'price'                   => new sfValidatorNumber(array('required' => false)),
      'destination_url'         => new sfValidatorString(array('max_length' => 512)),
      'url_parameters_defaults' => new sfValidatorPass(array('required' => false)),
      'nb_clicks'               => new sfValidatorNumber(),
      'nb_views'                => new sfValidatorNumber(),
      'notes'                   => new sfValidatorString(array('max_length' => 2147483647, 'required' => false)),
      'country_id'              => new sfValidatorDoctrineChoice(array('model' => 'LocationCountry')),
      'created_at'              => new sfValidatorDateTime(array('required' => false)),
      'updated_at'              => new sfValidatorDateTime(array('required' => false)),
      'ad_listing_routes_list'  => new sfValidatorDoctrineChoiceMany(array('model' => 'AdListingRoute', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('ad_listing[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'AdListing';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['ad_listing_routes_list']))
    {
      $values = array();
      foreach ($this->object->Routes as $obj)
      {
        $values[] = current($obj->identifier());
      }

      $this->setDefault('ad_listing_routes_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveAdListingRoutesList($con);
  }

  public function saveAdListingRoutesList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['ad_listing_routes_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $q = Doctrine_Query::create()
          ->delete()
          ->from('AdListingRoutes r')
          ->where('r.ad_listing_id = ?', current($this->object->identifier()))
          ->execute();

    $values = $this->getValue('ad_listing_routes_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new AdListingRoutes();
        $obj->ad_listing_id = current($this->object->identifier());
        $obj->ad_listing_route_id = $value;
        $obj->save();
      }
    }
  }

}