<?php

/**
 * AdListingRoute form base class.
 *
 * @package    form
 * @subpackage ad_listing_route
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 8508 2008-04-17 17:39:15Z fabien $
 */
class BaseAdListingRouteForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                     => new sfWidgetFormInputHidden(),
      'pickup_location_id'     => new sfWidgetFormDoctrineSelect(array('model' => 'LocationNode', 'add_empty' => false)),
      'dropoff_location_id'    => new sfWidgetFormDoctrineSelect(array('model' => 'LocationNode', 'add_empty' => false)),
      'created_at'             => new sfWidgetFormDateTime(),
      'updated_at'             => new sfWidgetFormDateTime(),
      'ad_listing_routes_list' => new sfWidgetFormDoctrineSelectMany(array('model' => 'AdListing')),
    ));

    $this->setValidators(array(
      'id'                     => new sfValidatorDoctrineChoice(array('model' => 'AdListingRoute', 'column' => 'id', 'required' => false)),
      'pickup_location_id'     => new sfValidatorDoctrineChoice(array('model' => 'LocationNode')),
      'dropoff_location_id'    => new sfValidatorDoctrineChoice(array('model' => 'LocationNode')),
      'created_at'             => new sfValidatorDateTime(array('required' => false)),
      'updated_at'             => new sfValidatorDateTime(array('required' => false)),
      'ad_listing_routes_list' => new sfValidatorDoctrineChoiceMany(array('model' => 'AdListing', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('ad_listing_route[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'AdListingRoute';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['ad_listing_routes_list']))
    {
      $values = array();
      foreach ($this->object->AdListings as $obj)
      {
        $values[] = current($obj->identifier());
      }

      $this->setDefault('ad_listing_routes_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveAdListingRoutesList($con);
  }

  public function saveAdListingRoutesList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['ad_listing_routes_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $q = Doctrine_Query::create()
          ->delete()
          ->from('AdListingRoutes r')
          ->where('r.ad_listing_route_id = ?', current($this->object->identifier()))
          ->execute();

    $values = $this->getValue('ad_listing_routes_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new AdListingRoutes();
        $obj->ad_listing_route_id = current($this->object->identifier());
        $obj->ad_listing_id = $value;
        $obj->save();
      }
    }
  }

}