<?php

/**
 * LocationCountry form base class.
 *
 * @package    form
 * @subpackage location_country
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 8508 2008-04-17 17:39:15Z fabien $
 */
class BaseLocationCountryForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                              => new sfWidgetFormInputHidden(),
      'name'                            => new sfWidgetFormInput(),
      'domain'                          => new sfWidgetFormInput(),
      'owner_contact_country_list'      => new sfWidgetFormDoctrineSelectMany(array('model' => 'OwnerContact')),
      'owner_vehicle_type_country_list' => new sfWidgetFormDoctrineSelectMany(array('model' => 'OwnerVehicleType')),
    ));

    $this->setValidators(array(
      'id'                              => new sfValidatorDoctrineChoice(array('model' => 'LocationCountry', 'column' => 'id', 'required' => false)),
      'name'                            => new sfValidatorString(array('max_length' => 128, 'required' => false)),
      'domain'                          => new sfValidatorString(array('max_length' => 10, 'required' => false)),
      'owner_contact_country_list'      => new sfValidatorDoctrineChoiceMany(array('model' => 'OwnerContact', 'required' => false)),
      'owner_vehicle_type_country_list' => new sfValidatorDoctrineChoiceMany(array('model' => 'OwnerVehicleType', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('location_country[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'LocationCountry';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['owner_contact_country_list']))
    {
      $values = array();
      foreach ($this->object->OwnerContact as $obj)
      {
        $values[] = current($obj->identifier());
      }

      $this->setDefault('owner_contact_country_list', $values);
    }

    if (isset($this->widgetSchema['owner_vehicle_type_country_list']))
    {
      $values = array();
      foreach ($this->object->OwnerVehicleType as $obj)
      {
        $values[] = current($obj->identifier());
      }

      $this->setDefault('owner_vehicle_type_country_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveOwnerContactCountryList($con);
    $this->saveOwnerVehicleTypeCountryList($con);
  }

  public function saveOwnerContactCountryList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['owner_contact_country_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $q = Doctrine_Query::create()
          ->delete()
          ->from('OwnerContactCountry r')
          ->where('r.country_id = ?', current($this->object->identifier()))
          ->execute();

    $values = $this->getValue('owner_contact_country_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new OwnerContactCountry();
        $obj->country_id = current($this->object->identifier());
        $obj->owner_contact_id = $value;
        $obj->save();
      }
    }
  }

  public function saveOwnerVehicleTypeCountryList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['owner_vehicle_type_country_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $q = Doctrine_Query::create()
          ->delete()
          ->from('OwnerVehicleTypeCountry r')
          ->where('r.country_id = ?', current($this->object->identifier()))
          ->execute();

    $values = $this->getValue('owner_vehicle_type_country_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new OwnerVehicleTypeCountry();
        $obj->country_id = current($this->object->identifier());
        $obj->owner_vehicle_type_id = $value;
        $obj->save();
      }
    }
  }

}