<?php

/**
 * LocationDeparture form base class.
 *
 * @package    form
 * @subpackage location_departure
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 8508 2008-04-17 17:39:15Z fabien $
 */
class BaseLocationDepartureForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                       => new sfWidgetFormInputHidden(),
      'name'                     => new sfWidgetFormInput(),
      'country_id'               => new sfWidgetFormDoctrineSelect(array('model' => 'LocationCountry', 'add_empty' => true)),
      'location_departures_list' => new sfWidgetFormDoctrineSelectMany(array('model' => 'Locations')),
    ));

    $this->setValidators(array(
      'id'                       => new sfValidatorDoctrineChoice(array('model' => 'LocationDeparture', 'column' => 'id', 'required' => false)),
      'name'                     => new sfValidatorString(array('max_length' => 128, 'required' => false)),
      'country_id'               => new sfValidatorDoctrineChoice(array('model' => 'LocationCountry', 'required' => false)),
      'location_departures_list' => new sfValidatorDoctrineChoiceMany(array('model' => 'Locations', 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('location_departure[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'LocationDeparture';
  }

  public function updateDefaultsFromObject()
  {
    parent::updateDefaultsFromObject();

    if (isset($this->widgetSchema['location_departures_list']))
    {
      $values = array();
      foreach ($this->object->Locations as $obj)
      {
        $values[] = current($obj->identifier());
      }

      $this->setDefault('location_departures_list', $values);
    }

  }

  protected function doSave($con = null)
  {
    parent::doSave($con);

    $this->saveLocationDeparturesList($con);
  }

  public function saveLocationDeparturesList($con = null)
  {
    if (!$this->isValid())
    {
      throw $this->getErrorSchema();
    }

    if (!isset($this->widgetSchema['location_departures_list']))
    {
      // somebody has unset this widget
      return;
    }

    if (is_null($con))
    {
      $con = $this->getConnection();
    }

    $q = Doctrine_Query::create()
          ->delete()
          ->from('LocationDepartures r')
          ->where('r.departure_id = ?', current($this->object->identifier()))
          ->execute();

    $values = $this->getValue('location_departures_list');
    if (is_array($values))
    {
      foreach ($values as $value)
      {
        $obj = new LocationDepartures();
        $obj->departure_id = current($this->object->identifier());
        $obj->location_id = $value;
        $obj->save();
      }
    }
  }

}