<?php

/**
 * User form base class.
 *
 * @package    form
 * @subpackage user
 * @version    SVN: $Id: sfDoctrineFormGeneratedTemplate.php 8508 2008-04-17 17:39:15Z fabien $
 */
class BaseUserForm extends BaseFormDoctrine
{
  public function setup()
  {
    $this->setWidgets(array(
      'id'                           => new sfWidgetFormInputHidden(),
      'email'                        => new sfWidgetFormInput(),
      'new_email'                    => new sfWidgetFormInput(),
      'new_email_confirm'            => new sfWidgetFormInput(),
      'username'                     => new sfWidgetFormInput(),
      'when_registered'              => new sfWidgetFormDateTime(),
      'source_information'           => new sfWidgetFormInput(),
      'firstname'                    => new sfWidgetFormInput(),
      'lastname'                     => new sfWidgetFormInput(),
      'date_of_birth'                => new sfWidgetFormDate(),
      'company'                      => new sfWidgetFormInput(),
      'contact_phone'                => new sfWidgetFormInput(),
      'mobile_phone'                 => new sfWidgetFormInput(),
      'address_line1'                => new sfWidgetFormInput(),
      'address_line2'                => new sfWidgetFormInput(),
      'suburb'                       => new sfWidgetFormInput(),
      'city'                         => new sfWidgetFormInput(),
      'postcode'                     => new sfWidgetFormInput(),
      'license'                      => new sfWidgetFormInput(),
      'country'                      => new sfWidgetFormInput(),
      'country_domain_id'            => new sfWidgetFormDoctrineSelect(array('model' => 'LocationCountry', 'add_empty' => true)),
      'reference_code'               => new sfWidgetFormInput(),
      'password'                     => new sfWidgetFormInput(),
      'account_balance'              => new sfWidgetFormInput(),
      'last_login'                   => new sfWidgetFormDateTime(),
      'is_owner'                     => new sfWidgetFormInput(),
      'user_status'                  => new sfWidgetFormInput(),
      'average_rating'               => new sfWidgetFormInput(),
      'activation_code'              => new sfWidgetFormInput(),
      'email_notify_format'          => new sfWidgetFormInput(),
      'email_newsletter'             => new sfWidgetFormInputCheckbox(),
      'email_country_newsletter'     => new sfWidgetFormInput(),
      'email_notify_new_req'         => new sfWidgetFormInputCheckbox(),
      'email_notify_update_req'      => new sfWidgetFormInputCheckbox(),
      'email_notify_new_reloc'       => new sfWidgetFormInput(),
      'email_country_new_reloc'      => new sfWidgetFormInput(),
      'email_notify_type_freq'       => new sfWidgetFormInput(),
      'sms_number'                   => new sfWidgetFormInput(),
      'sms_number_confirmed'         => new sfWidgetFormInputCheckbox(),
      'sms_notify_update_req'        => new sfWidgetFormInputCheckbox(),
      'sms_notify_new_reloc'         => new sfWidgetFormInput(),
      'emails_softbounced'           => new sfWidgetFormInput(),
      'is_hardbounced'               => new sfWidgetFormInputCheckbox(),
      'contact_updated_at'           => new sfWidgetFormDateTime(),
      'total_relocations'            => new sfWidgetFormInput(),
      'website'                      => new sfWidgetFormInput(),
      'logo'                         => new sfWidgetFormInput(),
      'description'                  => new sfWidgetFormInput(),
      'driver_request_instructions'  => new sfWidgetFormInput(),
      'driver_accepted_instructions' => new sfWidgetFormInput(),
      'payment_cc'                   => new sfWidgetFormInputCheckbox(),
      'average_response_time'        => new sfWidgetFormInput(),
      'response_rate'                => new sfWidgetFormInput(),
      'nb_no_show'                   => new sfWidgetFormInput(),
      'nb_late_cancellations'        => new sfWidgetFormInput(),
      'request_email_option'         => new sfWidgetFormInput(),
      'request_email_option_value'   => new sfWidgetFormInput(),
      'accepted_request_notify'      => new sfWidgetFormInputCheckbox(),
      'relo_price_per_day'           => new sfWidgetFormInput(),
      'closed_in_week_end'           => new sfWidgetFormInputCheckbox(),
      'week_end_closing_time'        => new sfWidgetFormTime(),
      'week_end_opening_time'        => new sfWidgetFormTime(),
      'timezone'                     => new sfWidgetFormInput(),
      'license_type'                 => new sfWidgetFormInput(),
      'ro_review_notify'             => new sfWidgetFormInputCheckbox(),
      'require_bond'                 => new sfWidgetFormInputCheckbox(),
      'bond_amounts'                 => new sfWidgetFormInput(),
      'boost_ranking'                => new sfWidgetFormInputCheckbox(),
      'allow_debit_card'             => new sfWidgetFormInputCheckbox(),
      'debit_card_text'              => new sfWidgetFormInput(),
    ));

    $this->setValidators(array(
      'id'                           => new sfValidatorDoctrineChoice(array('model' => 'User', 'column' => 'id', 'required' => false)),
      'email'                        => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'new_email'                    => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'new_email_confirm'            => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'username'                     => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'when_registered'              => new sfValidatorDateTime(array('required' => false)),
      'source_information'           => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'firstname'                    => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'lastname'                     => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'date_of_birth'                => new sfValidatorDate(array('required' => false)),
      'company'                      => new sfValidatorString(array('max_length' => 128, 'required' => false)),
      'contact_phone'                => new sfValidatorString(array('max_length' => 32, 'required' => false)),
      'mobile_phone'                 => new sfValidatorString(array('max_length' => 32, 'required' => false)),
      'address_line1'                => new sfValidatorString(array('max_length' => 128, 'required' => false)),
      'address_line2'                => new sfValidatorString(array('max_length' => 128, 'required' => false)),
      'suburb'                       => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'city'                         => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'postcode'                     => new sfValidatorString(array('max_length' => 16, 'required' => false)),
      'license'                      => new sfValidatorString(array('max_length' => 2, 'required' => false)),
      'country'                      => new sfValidatorString(array('max_length' => 2, 'required' => false)),
      'country_domain_id'            => new sfValidatorDoctrineChoice(array('model' => 'LocationCountry', 'required' => false)),
      'reference_code'               => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'password'                     => new sfValidatorString(array('max_length' => 128, 'required' => false)),
      'account_balance'              => new sfValidatorNumber(array('required' => false)),
      'last_login'                   => new sfValidatorDateTime(array('required' => false)),
      'is_owner'                     => new sfValidatorPass(array('required' => false)),
      'user_status'                  => new sfValidatorPass(array('required' => false)),
      'average_rating'               => new sfValidatorNumber(array('required' => false)),
      'activation_code'              => new sfValidatorString(array('max_length' => 64, 'required' => false)),
      'email_notify_format'          => new sfValidatorPass(array('required' => false)),
      'email_newsletter'             => new sfValidatorBoolean(array('required' => false)),
      'email_country_newsletter'     => new sfValidatorString(array('max_length' => 8, 'required' => false)),
      'email_notify_new_req'         => new sfValidatorBoolean(array('required' => false)),
      'email_notify_update_req'      => new sfValidatorBoolean(array('required' => false)),
      'email_notify_new_reloc'       => new sfValidatorPass(array('required' => false)),
      'email_country_new_reloc'      => new sfValidatorString(array('max_length' => 8, 'required' => false)),
      'email_notify_type_freq'       => new sfValidatorPass(array('required' => false)),
      'sms_number'                   => new sfValidatorString(array('max_length' => 32, 'required' => false)),
      'sms_number_confirmed'         => new sfValidatorBoolean(array('required' => false)),
      'sms_notify_update_req'        => new sfValidatorBoolean(array('required' => false)),
      'sms_notify_new_reloc'         => new sfValidatorPass(array('required' => false)),
      'emails_softbounced'           => new sfValidatorNumber(array('required' => false)),
      'is_hardbounced'               => new sfValidatorBoolean(array('required' => false)),
      'contact_updated_at'           => new sfValidatorDateTime(array('required' => false)),
      'total_relocations'            => new sfValidatorNumber(array('required' => false)),
      'website'                      => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'logo'                         => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'description'                  => new sfValidatorString(array('max_length' => 2147483647, 'required' => false)),
      'driver_request_instructions'  => new sfValidatorString(array('max_length' => 2147483647, 'required' => false)),
      'driver_accepted_instructions' => new sfValidatorString(array('max_length' => 2147483647, 'required' => false)),
      'payment_cc'                   => new sfValidatorBoolean(array('required' => false)),
      'average_response_time'        => new sfValidatorNumber(array('required' => false)),
      'response_rate'                => new sfValidatorNumber(array('required' => false)),
      'nb_no_show'                   => new sfValidatorNumber(array('required' => false)),
      'nb_late_cancellations'        => new sfValidatorNumber(array('required' => false)),
      'request_email_option'         => new sfValidatorString(array('max_length' => 20, 'required' => false)),
      'request_email_option_value'   => new sfValidatorString(array('max_length' => 255, 'required' => false)),
      'accepted_request_notify'      => new sfValidatorBoolean(array('required' => false)),
      'relo_price_per_day'           => new sfValidatorNumber(array('required' => false)),
      'closed_in_week_end'           => new sfValidatorBoolean(array('required' => false)),
      'week_end_closing_time'        => new sfValidatorTime(array('required' => false)),
      'week_end_opening_time'        => new sfValidatorTime(array('required' => false)),
      'timezone'                     => new sfValidatorPass(array('required' => false)),
      'license_type'                 => new sfValidatorPass(array('required' => false)),
      'ro_review_notify'             => new sfValidatorBoolean(array('required' => false)),
      'require_bond'                 => new sfValidatorBoolean(array('required' => false)),
      'bond_amounts'                 => new sfValidatorNumber(array('required' => false)),
      'boost_ranking'                => new sfValidatorBoolean(array('required' => false)),
      'allow_debit_card'             => new sfValidatorBoolean(array('required' => false)),
      'debit_card_text'              => new sfValidatorString(array('max_length' => 1024, 'required' => false)),
    ));

    $this->widgetSchema->setNameFormat('user[%s]');

    $this->errorSchema = new sfValidatorErrorSchema($this->validatorSchema);

    parent::setup();
  }

  public function getModelName()
  {
    return 'User';
  }

}