<?php

use Transfercar\Mandrill\TcMandrill;

/**
 * Form for changing user e-mail
 *
 * @package transfercar
 * @subpackage form
 */

class emailChangeForm extends BaseForm
{
    public function configure()
    {
        // Field list definition
        $this->setWidgets(array(
            'new' => new sfWidgetFormInput(array(), array('class' => 'form-control'))
        ));

        // Labels
        $this->widgetSchema->setLabels(array(
            'new' => 'New e-mail:'
        ));

        $this->widgetSchema->setNameFormat('email_change[%s]');

        $messages = array('invalid' => 'Invalid value');

        // Validators
        $this->setValidators(array(
            'new' => new myValidatorJoinEmail()
		));
    }

    public function sendConfirmationEmail($user)
    {
      $isActive = $template = $user->get('user_status') === 'active';
      // Save new e-mail in temp column and send to this
      // e-mail activation code
      if ($this->isValid())
      {
        $user->set($isActive ? 'new_email' : 'email', $this->getValue('new'));
        $user->set($isActive ? 'new_email_confirm' : 'activation_code', mt_rand(100000, 999999));
        $user->save();
      }

      // Prepare confimation e-mail
      $domain = LocationCountry::retreiveDomainById($user->country_domain_id);
      $site = sfConfig::get('app_domain_' . $domain);

      $code = $user->id.'.'.($user->get($isActive ? 'new_email_confirm' : 'activation_code')); // 12.32432434

      $url = $isActive ? 'user/confirmEmail' : 'home/activateAccount';

      $controller = sfContext::getInstance()->getController();
      $request    = sfContext::getInstance()->getRequest();

      $redirect = str_replace(':80', '', $request->getParameter('referer', $controller->genUrl('@homepage')));

      $params = $user->getEmailToParams();

      $template_data = array(
         'username'  => $user->username,
         'firstname' => $user->firstname,
         'lastname'  => $user->lastname,
         'when_registered' => $user->when_registered,
         'email_opt_link'  => 'https://' . $site . '/emailUnsubscribe/email/'.($user->new_email ?: $params['email']),
         'email_opt_link_real'  => 'https://' . $site . '/emailUnsubscribe/email/'.($user->new_email ?: $params['email']),
         'activation_code' => $user->get($isActive ? 'new_email_confirm' : 'activation_code'),
         'activation_link_label' => 'Confirm your email address',
         'link'      => $controller->genUrl($url.'?code=' . $code, true).'?redirect='.$redirect
      );


      $params['email'] = $user->new_email ?: $params['email'];

      $mandrill = new TcMandrill();
      $mandrill->sendTemplate(
          $isActive ? 'Confirm your new e-mail on Transfercar' : 'Welcome to Transfercar',
          $params,
          $template_data,
          $isActive ? 'confirm-email' : 'activation-code'
      );
    }
}
