<?php
/*
 * Form which displays single field for e-mail address
 */
class popupJoinEmailForm extends BaseForm
{
    public function configure()
    {
        // Field list definition
        $this->setWidgets(array(
                'join_email' => new sfWidgetFormInput()
            ));
            
        // Labels
        $this->widgetSchema->setLabels(array(
                'join_email' => 'Your e-mail:'
            ));
            
        // Validators
        $this->setValidators(array(
            'join_email' => new myValidatorJoinEmail()));
        
        $this->validatorSchema->addMessage('invalid',
            'E-mail address is invalid');
    }
    
    // Render form
    public function render($attributes = array())
    {
        sfLoader::loadHelpers(array('Form'));
        
        $result = '<div class="popup_left">';
        $result .= label_for('join_email', $this->widgetSchema->getLabel('join_email'));
        $result .= '</div>';
        $result .= '<div class="popup_right">';
        $result .= input_tag('join_email');
        $result .= '</div>';
        
        $result .= $this->widgetSchema->renderField(self::$CSRFFieldName,
            $this->getCSRFToken(self::$CSRFSecret));
        
        
        return $result;
    }
}
?>
