<?php

/**
 * Sign in in popup window
 *
 * @package transfercar
 * @subpackage form
 */

class popupSignInForm extends BaseForm
{
    public function __construct($defaults = array(), $options = array(), $CSRFSecret = null)
    {
        // disable CSRF
        parent::__construct($defaults, $options, false);
    }

    public function configure()
    {
        // Fields definition
        $this->setWidgets(array(
            'user'    => new sfWidgetFormInput(),
            'password'   => new sfWidgetFormInputPassword(),
        ));
        $this->widgetSchema->setNameFormat('login[%s]');

        // Set the Labels for specific fields

        $this->widgetSchema->setLabels(array(
            'user' => 'Username:',
            'password' => 'Password:'
        ));

        // Use Validators to check if the data are correct
        $this->setValidators(array(
            'user' => new sfValidatorString(),
            'password' => new sfValidatorString()
        ));

        $this->mergePostValidator(new myValidatorSignIn());

        $formatter = $this->getWidgetSchema()->getFormFormatter();
        $formatter->setErrorListFormatInARow('<small>%errors%</small>');
        $formatter->setErrorRowFormatInARow('%error% ');
    }
}
