<?php

/**
 * Base form class for most all Transfercar forms
 * (layout implementation)
 */

class transfercarForm extends BaseForm
{
    public function render($attributes = array())
    {
        sfLoader::loadHelpers(array('Form'));

        $result = '';

        $values = array_merge($this->defaults, $this->taintedValues);

        $error_count = (count($this->errorSchema) > 0);
        $named_errors = $this->errorSchema->getNamedErrors();

        $fields = $this->widgetSchema->getPositions();

        // Render each field
        foreach($fields as $name){
            if($name !== self::$CSRFFieldName){
                $type = $this->widgetSchema[$name]->getOption('type');
                $result .= '<div class="formrow clearfix">';

                if($type == 'checkbox'){

                    $result .= '<div class="form_tl_checkbox">';
                    $result .= $this->widgetSchema->renderField($name, @$values[$name]);
                    $result .= '</div>';
                    $result .= '<div class="form_vl_checkboxlabel">';
                    $result .= label_for($name, $this->widgetSchema->getLabel($name));
                    $result .= '</div>';
                    $result .= '<div class="form_e"></div>'; // We need this div on AJAX validation

                } else {

                    $result .= '<div class="form_tl">';
                    $result .= label_for($name, $this->widgetSchema->getLabel($name));
                    $result .= '</div>';
                    $class_name = 'form_vl';
                    $has_error = ($error_count > 0 && isset($named_errors[$name]));
                    if($has_error){
                        $class_name .= ' error';
                    }
                    $result .= '<div class="'.$class_name.'">';
                    $result .= $this->widgetSchema->renderField($name, @$values[$name]);
                    $result .= '</div>';
                    if($has_error){
                        $result .= '<div class="form_e">'.$named_errors[$name].'</div>';
                    } else {
                        $result .= '<div class="form_e"></div>'; // We need this div on AJAX validation
                    }

                } // if it is checkbox

                $result .= '</div>'; // formrow
            }
        }

        $result .= $this->widgetSchema->renderField(self::$CSRFFieldName,
            $this->getCSRFToken(self::$CSRFSecret));

        $global_errors = $this->getGlobalErrors();

        if(count($global_errors) > 0){
            $result .= '<div>';
            foreach($global_errors as $error){
                $result .= '<p class="error">'.$error.'</p>';
            }
            $result .= '</div>';
        }

        return $result;
    }

	/**
	 * For custom rendered forms
	 */
	public function renderCSRF()
	{
		return $this->widgetSchema->renderField(self::$CSRFFieldName,
            $this->getCSRFToken(self::$CSRFSecret));
	}
}
