<?php

function tc_head_element_tag($cmsPageHeadElement)
{
    $cmsPageHeadElement = $cmsPageHeadElement instanceof sfOutputEscaper ? $cmsPageHeadElement->getRawValue() : $cmsPageHeadElement;
    return tc_get_head_element_tag_for($cmsPageHeadElement->get('type'), $cmsPageHeadElement->getId(), $cmsPageHeadElement->toArray(false));
}

function tc_get_head_element_tag_for($type, $id = 'new_%s', $defaults = array())
{
    $form = new AdminCmsPageHeadElementForm($defaults, array('type' => $type, 'id' => $id), false);

    $form = $form->render();

    $name = isset($defaults['name']) ? $defaults['name'] : $type;
    $name = 'meta_image' == $type ? 'og:image' : $name;
    $label = strpos($id, 'new') === 0 ? 'New '.$name.' tag' : $type;
    $label = !in_array($type, array('hreflang', 'title')) ? $label : $type.' tag';
    $label = isset($defaults['properties']['name']) && !in_array($type, array('hreflang', 'title')) ? $defaults['properties']['name'] : $label;


    if ($type == 'meta_image' && isset($defaults['properties']['content']) && $defaults['properties']['content'])
    {
        $form .= content_tag('div', link_to('Preview: '.image_tag($defaults['properties']['content'], array('style' => 'max-width:80px;max-height:50px')), $defaults['properties']['content'], array('target' => '_blank')), array('style' => 'clear:both'));
    }

    return '<div class="form-row"><label>'.$label.'</label><div class="content">'.$form.'</div></div>';
}

function tc_get_header_tag($cmsPageElement)
{
    switch ($cmsPageElement->get('type')) {
        case 'meta':
            // returns nothing for metas, handled by sfWebResponse
            return;

        case 'link':
            return tag('link', $cmsPageElement->get('properties'));

        case 'hreflang':
            return tag('link', array_merge(array('rel' => 'alternate'), $cmsPageElement->get('properties')));

        case 'meta_image':
            return tag('meta', array_merge(array('name' => $cmsPageElement->get('name')), $cmsPageElement->get('properties')));
    }
}