<?php

function link_to_pause($listing)
{
    $message = sprintf(
        'Are you sure you want to pause listing %s?<br/>The listing will no longer be displayed on the website',
        $listing->get('id')
    );
    return link_to('<i class="fa fa-pause"></i> Pause', 'listing/pause?id='.$listing->get('id'), array(
        'class' => 'reveal-confirm',
        'reveal-message' => $message,
        'reveal-button-title' => 'Pause listing',
        'reveal-confirm-title' => 'Pause Listing '.$listing->getId()
    ));
}

function link_to_rate($listing, $label = 'Rate driver', $icon = 'fa-circle fa fa-green')
{
    return link_to('<i class="'.$icon.'"></i> '.__($label), 'listing/rate?id='.$listing->getId(), array('class' => 'reveal-ajax'));
}

function link_to_confirm_booking($listing)
{
    return link_to('<i class="fa-circle fa fa-green"></i> '.__('Edit booking reference'), 'listing/confirm?id='.$listing->getId(), array('class' => 'reveal-ajax', 'data-reveal-width' => '60'));
}

function link_to_delete($listing)
{
    switch($listing->getStatusName()) {
        case 'DroppedOff':
            return link_to_rate($listing, __('Delete'), 'fa fa-trash-o');
        case 'Requested':
            $message = sprintf(
                'Are you sure you want to remove listing %s?<br/>Your %s request(s) will be declined.<br/>You will not be able to undo this action.',
                $listing->get('id'),
                $listing->get('Requests')->count()
            );
            $title = 'Remove and decline requests';
            break;
        default:
            $message = sprintf(
                'Are you sure you want to remove listing %s?<br/> You will not be able to undo this action.',
                $listing->get('id')
            );
            $title = 'Remove listing';
    }

    return link_to('<i class="fa fa-trash-o"></i> '.__('Delete'), 'listing/delete?id='.$listing->get('id'), array(
        'class' => 'reveal-confirm',
        'reveal-message' => $message,
        'reveal-button-title' => $title,
        'reveal-confirm-title' => 'Remove Listing '.$listing->getId()
    ));
}


function link_to_copy($listing)
{
    return link_to('<i class="fa fa-files-o"></i> '.__('Copy'), 'listing/copy?id='.$listing->getId());
}

function link_to_edit($listing)
{
    return link_to('<i class="fa fa-pencil-square-o"></i> '.__('Edit'), 'listing/copy?id='.$listing->getId());
}

function link_to_cancel($listing)
{
    return link_to('<i class="fa fa-ban"></i> '.__('We cancelled'), 'listing/cancel?id='.$listing->getId(), array('class' => 'reveal-ajax'));
}

function link_to_driver_cancelled($listing)
{
    return link_to('<i class="fa fa-circle fa fa-red"></i> '.__('Driver cancelled'), 'listing/driverCancelled?id='.$listing->getId(), array('class' => 'reveal-ajax'));
}

function link_to_noshow($listing)
{
    return link_to('<i class="fa fa-ban"></i> '.__('Driver didn\'t show'), 'listing/noshow?id='.$listing->getId(), array('class' => 'reveal-ajax'));
}

function link_to_relist($listing)
{
    return link_to('<i class="fa fa-circle-o"></i> '.__('List again'), 'listing/copy?id='.$listing->getId());
}
