<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class CMSMenu extends BaseCMSMenu
{
    public function __toString()
    {
        $prefix = '';
        if ($count = $this->countParents()) {
            $prefix = ' '.str_repeat('--', $count).' ';
        }
        return $prefix.strtoupper($this->get('domain')). ' - ' . $this->get('name');
    }

    public function move($dir)
    {
        if ($parent = $this->get('Parent'))
        {
            $children = $parent->getChildrenByPosition();
            $idx = array_search($this, $children);
            $siblingIdx = $idx + $dir;

            if (isset($children[$siblingIdx]))
            {
                $pos = $this->get('position');
                $this->set('position', $children[$siblingIdx]->get('position'));
                $children[$siblingIdx]->set('position', $pos);
                $children[$siblingIdx]->save();
                $this->save();
            }
        }
    }

    public function getChildrenByPosition()
    {
        $children = $this->get('Children')->getData();
        usort($children, array($this, 'sortChildren'));

        return $children;
    }

    private function sortChildren($a, $b)
    {
        return $a->get('position') < $b->get('position') ? -1 : 1;
    }

    public function countParents()
    {
        $count = 0;
        $menu = $this;
        while (($menu = $menu->get('Parent')) && $menu->exists())
        {
            $count++;
        }

        return $count;
    }

    public function preSave($event)
    {
        $object = $event->getInvoker();

        if (!$object->get('domain') && $object->get('parent_id'))
        {
            $parent = $object->get('Parent');
            $object->set('domain', $parent->get('domain'));
        }

        if (!$object->get('position') && !$object->exists() && $object->get('parent_id'))
        {
            $siblings = $object->get('Parent')->get('Children');

            $position = $siblings->search($object);
            $object->set('position', $position === false ? count($siblings) : $position);
        }
    }

    public function postSave($event)
    {
        $object = $event->getInvoker();

        self::getEventDispatcher()->notify(new sfEvent($object, 'cms_menu.updated'));
    }

    public function preDelete($event)
    {
        $object = $event->getInvoker();
        $position = $object->get('position');

        $children = $object->getChildrenByPosition();
        $idx = array_search($object, $children);

        for ($i = $idx + 1; $i < count($children); $i++)
        {
            $children[$i]->set('position', $children[$i]->get('position') - 1);
            $children[$i]->save();
        }
    }

    public function isInInternalMenu($internal_name)
    {
        if ($this->get('internal_name') == $internal_name)
        {
            return $this;
        }

        if ($this->get('parent_id'))
        {
            return $this->get('Parent')->isInInternalMenu($internal_name);
        }
    }

    public function getMenuParentId()
    {
        return null;
    }

    public function getLink()
    {
        if ($this->get('page_id'))
        {
            return $this->get('Page')->getFullUrl();
        }

        return $this->get('url');
    }
}