<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class CMSMenuTable extends Doctrine_Table
{
    public static function getTypes()
    {
        return array(
            'external' => 'External',
            'internal' => 'Internal',
            'page'     => 'Page'
        );
    }

    public static function getInternalRoutes()
    {
        return array(
            '@signup' => '/register',
            '@login'  => '/login',
            '@browse_listing' => '/browseall',
            '@myTransfercar' => '/mytransfercar',
        );
    }

    public function getItemsByInternalName($domain, $name)
    {
        return $this->createQuery('m')
            ->innerJoin('m.Parent mp')
            ->leftJoin('m.Page pa')
            ->where('mp.domain = ?', $domain)
            ->addWhere('mp.internal_name = ?', $name)
            ->orderBy('m.position')
            ->execute();
    }

    public function findAllNested($id = null)
    {
        $query = $this->createQuery('m')
            ->orderBy('m.domain, m.name');

        if ($id) {
            $query->where('m.parent_id = ?', $id);
        } else {

            $query->where('parent_id is null');
        }

        $menus = $query->execute();

        $nestedMenus = array();
        foreach ($menus as $menu)
        {
            $nestedMenus[] = $menu;
            $nestedMenus = array_merge($nestedMenus, $this->findAllNested($menu->get('id')));
        }

        return $nestedMenus;
    }

    public function findMainMenus()
    {
        return $this->createQuery('m')
            ->orderBy('m.domain, m.name')
            ->where('parent_id is null')
            ->execute();
    }

    public function findSideMenus()
    {
        return $this->createQuery('m')
            ->orderBy('m.domain, m.name')
            ->where('parent_id is null')
            ->addWhere('m.internal_name = ?', 'side_menu')
            ->execute();
    }
}