<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class CMSPage extends BaseCMSPage
{
    private $oldUrl;

    public function getCleanTitle()
    {
        $title = str_replace('&nbsp;', '', $this->get('title'));
        return trim(strip_tags($title));
    }

    public function preUpdate($event)
    {
        $page = $event->getInvoker();

        $modified = $page->getModified();

        if ($page->oldUrl)
        {
            $redirect = new CMSPageRedirect();
            $redirect->set('url', $page->oldUrl);
            $redirect->set('Page', $page);
            $page->oldUrl = null;
            $redirect->save();
        }
    }

    public function setUrl($v)
    {

        $type = $this->_table->getTypeOf('url');
        if ($this->exists() && $this->_isValueModified($type, $this->get('url'), $v))
        {
            $this->oldUrl = $this->getFullUrl();

        }

        return parent::rawSet('url', $v);
    }

    public function setCmsPageTypeId($v)
    {
        // Doctrine will affect a CmsPageType when hydrating the object.
        // In that case, we simply ignore it
        if ($this->exists() && !$v instanceof CmsPageType) {
            $type = $this->_table->getTypeOf('cms_page_type_id');
            if ($this->_isValueModified($type, $this->get('cms_page_type_id'), $v))
            {
                $this->oldUrl = $this->getFullUrl();
            }
        }

        parent::rawSet('cms_page_type_id', $v);
    }

    public function getFullUrl()
    {
        return str_replace('//', '/', $this->get('Type')->get('directory').$this->get('url'));
    }

    public function getMenu($internal_name)
    {
        foreach ($this->get('Menus') as $menu)
        {
            $internal_menu = $menu->isInInternalMenu($internal_name);
            if ($internal_menu)
            {
                return $internal_menu;
            }
        }
    }

    public function getParents()
    {
        return array(); //todo
    }

    public function getMenuParentId()
    {
        return null;
    }

    public function getMapOption($key)
    {
        return isset($this->map_data[$key]) ? $this->map_data[$key] : 0;
    }

    public function getMapUrl()
    {
        if (isset($this->map_data['lat']) && $this->map_data['lat'])
        {
            return sprintf("https://maps.googleapis.com/maps/api/staticmap?markers=%s&amp;zoom=%s&amp;size=240x240&amp;sensor=false",
                $this->map_data['lat'].','.$this->map_data['lon'],
                $this->map_data['zoom']
            );
        }

        return false;
    }

    public function getMissingMetaElements()
    {
        $elements = explode(',', $this->get('Type')->get('default_meta_tags'));
        $elements = array_map('trim', $elements);

        $currentTypes = array();

        foreach ($this->get('HeadElements') as $headElement)
        {
            $currentTypes[] = $headElement->getProperty('name');
        }

        return array_diff($elements, $currentTypes);
    }

    public function setParentId($v)
    {
        return parent::rawSet('parent_id', $v ? null : (int) $v);
    }
}