<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class CMSPageTable extends Doctrine_Table
{
    public function findPage($domain, $url)
    {
        return $this->createQuery('c')
            ->innerJoin('c.Type t')
            ->leftJoin('c.HeadElements h')
            ->where('c.domain = ?', $domain)
            ->addWhere('REPLACE(CONCAT(COALESCE(t.directory, \'\'), c.url), \'//\', \'/\') = ?', $url)
            ->addWhere('c.is_published = ?', true)
            ->limit(1)
            ->fetchOne();
    }

    public function findMainPages($domain)
    {
        return $this->createQuery('c')
            ->innerJoin('c.Type t')
            ->where('c.parent_id is null')
            ->addWhere('c.domain = ?', $domain)
            ->orderBy('c.name')
            ->execute();
    }

    public function findAllByName()
    {
        return $this->createQuery('c')
            ->orderBy('c.name')
            ->execute();
    }



    public function findRelated($object)
    {
        if ($object instanceof Listing)
        {
            return $this->findForListing($object);
        }
        elseif ($object instanceof CMSPage)
        {
            return $this->findForCmsPage($object);
        }


        throw new Exception("Unsupported object type");

    }

    public function findForCmsPage($page)
    {
        $options = $page->get('block_vehicles_options');

        $or = array();
        $params = array();

        foreach (array('fromLocations', 'toLocations') as $key)
        {
            if (isset($options[$key]) && is_array($options[$key]))
            {
                foreach ($options[$key] as $locationId)
                {
                    list($query, $queryParams) = $this->buildRelatedPageQuery($locationId, $locationId);
                    $or[] = $query;
                    $params = array_merge($params, $queryParams);
                }
            }
        }

        if (empty($or))
        {
            return array();
        }

        $query = implode(' OR ', $or);

        return Doctrine::getTable('CMSPage')
          ->createQuery('c')
          ->where($query, $params)
          ->addWhere('c.id != ?', $page->getId())
          ->limit(10)

          ->execute();

    }

    public function findForListing($listing)
    {
        list($query, $params) = $this->buildRelatedPageQuery(
            $listing->get('pickup_location_id'),
            $listing->get('dropoff_location_id')
        );

        return Doctrine::getTable('CMSPage')
          ->createQuery('c')
          ->where($query, $params)
          ->execute();
    }

    private function buildRelatedPageQuery($pickup_location_id, $dropoff_location_id)
    {
        return array('(c.block_vehicles_options like ? or c.block_vehicles_options like ?)', array(
            sprintf('%%"fromLocations";%%"%s"%%}%%', $pickup_location_id),
            sprintf('%%"toLocations";%%"%s"%%}%%', $dropoff_location_id)
        ));
    }

    public function getWidget($content)
    {
        $start = strpos($content, '<!-- MCE -->');
        $end = strpos($content, '<!-- /MCE -->');

        return substr($content, $start + 12, $end - $start);
    }
}