<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class CreditCard extends BaseCreditCard
{
    /**
     * Return information about credit card.
     * Returned text is in format MasterCard - ****3423
     *
     * @return string
     */
    public function card_description()
    {
        return $this->get('number');
    }

    /* @deprecated */
    public function getCardTypeName()
    {
        return;
    }


    /**
     * Get list of all user credit cards stored in DB
     * Cards with '#' sign are only for temporarily use
     * and will not be saved
     *
     * @return array
     */
    public static function user_cards_list()
    {
        $user = sfContext::getInstance()->getUser()->getAttribute('profile');
        $country = $user->getCountryDomainId();

        $select = Doctrine_Query::create()
            ->from('CreditCard')
            ->where('owner_id = ?', $user->getOwnerId())
            ->addWhere('holder_name like ?', 'src_%');
        if ($country != 1) { // NOT NZ
        	//$select->addWhere('card_type != -3');//!=AmericanExpress
        }

        $cards = $select->execute();

        $result = array();
        foreach($cards as $card){
            $result[$card->id] = $card->card_description();
        }
        return $result;
    }

    public static function get_available_card_list()
    {
    	$card_types = sfConfig::get('sf_payment_card_types_names');
    	$country = sfContext::getInstance()->getUser()->getCountry();

        if ($country != '1')
        {
            unset($card_types[array_search('AmericanExpress', $card_types)]);
        }

    	return $card_types;
	}


}
