<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class EmailWaitroom extends BaseEmailWaitroom
{
    /*
     * Types of possible e-mails
     */
    const EMAIL_TYPE_NEWSLETTER = 1;
    const EMAIL_TYPE_NEW_REQUEST = 2;
    const EMAIL_TYPE_REQUEST_UPDATE = 3;
    const EMAIL_TYPE_NEW_LISTING = 4;
    const EMAIL_TYPE_OTHER = 999;
    
    /**
     * Set data (subject and message) using template from DB
     * @param string $template_name Name of the template to use
     * @param array() $template_data Data for the template
     */
    public function setDataFromTemplate($template_name, $template_data = array())
    {
        if(!is_array($template_data)){
            $template_data = array($template_data);
        }
        
        $template = Doctrine_Query::create()
            ->from('EmailTemplate')->where('name = ?', $template_name)
            ->fetchOne();
            
        if(!is_object($template)){
            throw new Exception('Cannot find template '.$template_name.' in database.');
        }
        
        // Set data for template
        $subject = $template->subject;
        $content = $template->content;
        
        foreach($template_data as $key => $value){
            $text = '###'.$key.'###';
            $subject = str_replace($text, $value, $subject);
            $content = str_replace($text, $value, $content);
        }
        
        $d = $this->email_data;
        $d['subject'] = $subject;
        $d['body'] = $content;
        $this->email_data = $d;
        
        return;
    }
    
    /**
     * Run mailer script as background server process when e-mail will be saved
     * 
     * @param Doctrine_Connection $conn Doctrine Connection identifier
     */
    public function save(Doctrine_Connection $conn = null)
    {
        parent::save($conn);
        
        // Find directory where batch scripts are placed
        $batch_dir = sfConfig::get('sf_root_dir').'/batch/';
        $runner_name = $batch_dir.'run_script.sh';
        $mailer_name = $batch_dir.'mailer.php';
        // Execute shell script, which will call mailer script as background process
        system($runner_name.' '.$mailer_name);
    }
}
