<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class Enquiry extends BaseEnquiry
{
	const STATUS_PENDING = 0;
	const STATUS_ACCEPTED = 1;
	const STATUS_DECLINED = 2;
	const STATUS_CANCELED_BY_DRIVER = 3;

	public function getNbDays()
	{
		$pickup = new DateTime($this->get('pickup_date'));
    	$dropoff = new DateTime($this->get('dropoff_date'));
    	$diff = $dropoff->diff($pickup);
    	$nbdays = 0;

    	if ($pickup <= $dropoff) {
            $extraDay = $this->get('Rental')->get('OwnerVehicleType')->get('rental_type') == 'day' ? 1 : 0;
            $diff = $dropoff->diff($pickup);
            $nbdays = $diff->days + $extraDay;
        }

    	return $nbdays;
	}

	public function isStatus($status)
	{
		return $this->get('status') == $status;
	}

	public function accept($price)
	{
	  $fee = $this->get('price') * 0.1;//10% fee
	  // process payment using RO credits
      $payment = new Payments();
      $payment->type = 'manual';
      $payment->date = date('Y-m-d', time());
      $payment->amount = -$fee;
      $payment->user_id = $this->get('Rental')->get('Owner')->getId();
      $payment->status = Payments::STATUS_ACCEPTED;
      $payment->assigned_record_id = -$this->get('Rental')->getId();
      $payment->country_id = $this->get('OwnerBranch')->get('country_id');
      $payment->is_new_type_payment = "yes";
      $payment->save();

      $this->enquiry->setStatus(Enquiry::STATUS_ACCEPTED);
      $this->enquiry->save();
	}

	public function getCountryDomain()
	{
		return $this->get('OwnerBranch')->get('Country')->get('domain');
	}
}