<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class LocationCategory extends BaseLocationCategory
{
    public function __toString()
    {
        return (string) $this->get('description');
    }

 /**
 * function checking is category can be deleted
 * @param category id
 * @return boolean true if category can be deleted false if cant
 */

 public static function can_delete($category_id)
 {
		//getting category from db
		$query = Doctrine_Query::create()
					->from('LocationCategory lc')
					->leftJoin('lc.Locations lcl')
					->leftJoin('lcl.ListingFrom')
					->leftJoin('lcl.ListingTo')
					->where('lc.id = ?', $category_id);

		 $result = $query->execute();

		 //if any count of ListingForm > 0 or count ListingTo > 0 category cant be deleted
		  foreach( $result[0]->Locations as $location)
          if (count($location->ListingFrom) > 0 || count($location->ListingTo) > 0) return false;

	return true;

 }

	public static function getAllIndexedById()
	{
		$query = Doctrine_Query::create()
			->from("LocationCategory")
			->orderBy("description ASC");

		$tmp = $query->execute()->toArray();
		$res = array();

		if (is_array($tmp) && count($tmp) > 0){
			foreach ($tmp as $item){
				$res[$item['id']] = $item;
			}
		}

		return $res;
	}

    public function postInsert($event)
    {
        $node = Doctrine::getTable('LocationNode')->createNode('category', $event->getInvoker());
        $ancestor = Doctrine::getTable('LocationNode')->findByTypeAndId('country', $this->get('country_id'));
        Doctrine::getTable('LocationNodeAncestor')->createNode($node, $ancestor);
    }

    public function postUpdate($event)
    {
        Doctrine::getTable('LocationNode')->updateNode('category', $event->getInvoker());
    }


    public function preDelete($event)
    {
        $node = Doctrine::getTable('LocationNode')->findByTypeAndId('category', $event->getInvoker()->get('id'));
        $node && $node->delete();
    }
}
