<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class LocationDeparture extends BaseLocationDeparture
{
    public function __toString()
    {
        return (string) $this->get('name');
    }

    /**
     * Get an array for departure location drop-down list
     * in format departure_id => "departure_name" for current country
     *
     * @param int $id_country - $id current country
     */
	public static function departureList($id_country, $name = null)
    {
        $query = Doctrine_Query::create()
            ->from('LocationDeparture l')
            ->orderBy('l.name ASC')
            ->where('l.country_id=?', $id_country);

        if ($name)
        {
            $query->addWhere('l.name like ?', '%'.$name.'%');
        }

        $departures = $query->execute();

        $result = array();
        foreach($departures as $departure)
        {
            $result[$departure->id] = $departure->name;
        }

        return $result;
    }

	public static function getAll($id_country = null)
	{
		if (!is_null($id_country))
        {
			$query = Doctrine_Query::create()
				->from("LocationDeparture l")
				->orderBy("l.name ASC")
				->where('l.country_id=?', $id_country);
		}
        else
        {
			$query = Doctrine_Query::create()
				->from("LocationDeparture l")
				->orderBy("l.name ASC");
		}

		return $query->execute()->toArray();
	}

    public function postInsert($event)
    {
        $node = Doctrine::getTable('LocationNode')->createNode('departure', $event->getInvoker());
        $ancestor = Doctrine::getTable('LocationNode')->findByTypeAndId('country', $this->get('country_id'));
        Doctrine::getTable('LocationNodeAncestor')->createNode($node, $ancestor);
    }

    public function postUpdate($event)
    {
        Doctrine::getTable('LocationNode')->updateNode('departure', $event->getInvoker());
    }

    public function preDelete($event)
    {
        $node = Doctrine::getTable('LocationNode')->findByTypeAndId('departure', $event->getInvoker()->get('id'));
        $node && $node->delete();
    }

    public function getLocationNode()
    {
        return Doctrine::getTable('LocationNode')->findByTypeAndId('departure', $event->getInvoker()->get('id'));
    }

}