<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class LocationDistancesTable extends Doctrine_Table
{
    public function findMatchingTrip($from, $to)
    {
        if (strpos($from, '_') !== false) {
            list($prefix, $id) = explode('_', $from);

            if ('tc' === $prefix) {
                $from = $id;
            } else {
                $branch = Doctrine::getTable('OwnerBranch')->find($id);
                $from = $branch->get('NearestLocation')->get('id');
            }
        }

        if (strpos($to, '_') !== false) {
            list($prefix, $id) = explode('_', $to);
            if ('tc' === $prefix) {
                $to = $id;
            } else {
                $branch = Doctrine::getTable('OwnerBranch')->find($id);
                $to = $branch->get('NearestLocation')->get('id');
            }
        }

        return $this->createQuery('d')
            ->where('
                (d.location_from_id = ? and d.location_to_id = ?)
                OR (d.location_from_id = ? and d.location_to_id = ?)', array($from, $to, $to, $from))
            ->limit(1)
            ->fetchOne();
    }

    public function findFilteredLocations($id_country)
    {
        $locations = $this->createQuery('d')
            ->innerJoin('d.PickupLocation pl')
            ->innerJoin('d.DropoffLocation dl')
            ->innerJoin('pl.Category c')
            ->where('c.country_id = ?', $id_country)
            ->addWhere('pl.name not like ?', '%airport')
            ->addWhere('dl.name not like ?', '%airport')
            ->orderBy('pl.name')
            ->execute();

        return $locations;
    }
}