<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class LocationNode extends BaseLocationNode
{
    public function getChildrenOfType($type)
    {
        return Doctrine::getTable('LocationNode')
            ->createQuery('ln')
            ->innerJoin('ln.Ancestors lna')
            ->where('lna.node_ancestor_id = ?', $this->getId())
            ->whereIn('ln.type', is_array($type) ? $type : array($type))
            ->orderBy('ln.name')
            ->execute();
    }

    public function getParentOfType($type)
    {
        return Doctrine::getTable('LocationNode')
            ->createQuery('ln')
            ->innerJoin('ln.Descendants lna')
            ->where('lna.node_id = ?', $this->getId())
            ->addWhere('ln.type = ?', $type)
            ->orderBy('ln.name')
            ->fetchOne();
    }


    public function getParentsOfType($type)
    {
        return Doctrine::getTable('LocationNode')
            ->createQuery('ln')
            ->innerJoin('ln.Descendants lna')
            ->where('lna.node_id = ?', $this->getId())
            ->addWhere('ln.type = ?', $type)
            ->orderBy('ln.name')
            ->execute();
    }

    public function getNameWithCountry()
    {
        $name = $this->get('name');

        if ($country = $this->getParentOfType('country'))
        {
            $name .= ', '.$country->get('name');
        }

        return $name;
    }

    public function setName($v)
    {
        if (!$this->get('slug'))
        {
            $this->set('slug', $v);
        }

        parent::rawSet('name', $v);
    }

    public function getDeparture()
    {
        if ($this->get('type') == 'departure'){
            return $this;
        }

        return $this->getParentOfType('departure');
    }

    public function setSlug($v)
    {
        switch ($this->get('type')) {
            default:
            case 'location':
                $type = '';
                break;

            case 'category':
                $parent = $this->getParentOfType('country');
                $type   = $parent && $parent->get('name') == 'New Zealand' ? 'region:' : 'state:';
                break;

            case 'country':
                $type = 'country:';
                break;

            case 'departure':
                $type = 'custom:';
                break;
        }

        $v = $type.Doctrine_Inflector::urlize($v);
        parent::rawSet('slug', $v);
    }

    public function toElasticaArray()
    {
        return array(
            'name' => $this->get('name'),
            'slug' => $this->get('slug')
        );
    }
}