<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class LocationNodeTable extends Doctrine_Table
{
    public function createNode($type, $object)
    {
        $node = new LocationNode();
        $node->set('type', $type);
        $node->set('type_id', $object->getId());
        $node->set('name', (string) $object);
        $node->save();

        return $node;
    }

    public function updateNode($type, $object)
    {
        $node = $this->findByTypeAndId($type, $object->getId());
        $node->set('name', (string) $object);
        $node->save();

        return $node;
    }

    public function findByTypeAndId($type, $id)
    {
        $query = $this->createQuery()
            ->where('type = ?', $type)
            ->addWhere('type_id = ?', $id)
            ->limit(1);

        $location = $query->fetchOne();
        $query->free();

        return $location;
    }

    public function findNestedByCountry($id, $keyColumn = 'id', $default = false)
    {
        $cache = new sfFileCache(array(
            'cache_dir' => sfConfig::get('sf_cache_dir')
        ));

        $key = __CLASS__.'.___location_node_nested_by_country_'.$id.'_'.$keyColumn.'_'.intval($default);

        $id = $default ? -$id : $id;

        if (!($data = $cache->get($key))) {
            
            switch ($id) {
                 case 1: // NZ
                    $data = [
                        'Popular cities' => [
                            'custom:auckland' => 'Auckland',
                            'custom:christchurch' => 'Christchurch',
                            'custom:dunedin' => 'Dunedin',
                            'custom:greymouth' => 'Greymouth',
                            'custom:nelson' => 'Nelson',
                            'custom:dunedin' => 'Dunedin',
                            'custom:picton' => 'Picton',
                            'custom:queenstown' => 'Queenstown',
                            'custom:wellington' => 'Wellington',
                        ], 
                        'Regions' => [
                            'region:auckland' => 'Auckland',
                            'region:bay-of-plenty' => 'Bay of Plenty',
                            'region:canterbury' => 'Canterbury',
                            'region:gisborne' => 'Gisborne',
                            'region:hawkes-bay' => 'Hawke\'s Bay',
                            'region:manawatu' => 'Manawatū-Whanganui',
                            'region:marlborough' => 'Marlborough',
                            'region:nelson' => 'Nelson',
                            'region:northland' => 'Northland',
                            'region:otago' => 'Otago',
                            'region:southland' => 'Southland',
                            'region:taranaki' => 'Taranaki',
                            'region:tasman' => 'Tasman',
                            'region:waikato' => 'Waikato',
                            'region:wellington' => 'Wellington',
                            'region:west-coast' => 'West Coast'
                        ]
                    ];
                    break;
                case 2: // AU

                    $data = [
                        'Popular' => [
                            'custom:any'     => 'Any location',
                            'adelaide'  => 'Adelaide',
                            'custom:alice-springs'  => 'Alice Springs',
                            'custom:brisbane'  => 'Brisbane',
                            'custom:broome'  => 'Broome',
                            'custom:cairns'  => 'Cairns',
                            'custom:canberra'  => 'Canberra',
                            'custom:darwin'  => 'Darwin',
                            'custom:hobart'  => 'Hobart',
                            'custom:melbourne'  => 'Melbourne', 
                            'custom:perth'  => 'Perth',
                            'custom:sydney'  => 'Sydney',
                        ],
                        'Territories' => [
                            'region:any'      => 'Any location',
                            'region:australian-capital-territory' => 'Australian Capital Territory',
                            'region:new-south-wales' => 'New South Wales',
                            'region:nothern-territory' => 'Northern Territory',
                            'region:queensland' => 'Queensland',
                            'region:south-australia' => 'South Australia',
                            'region:tasmania' => 'Tasmania',
                            'region:victoria' => 'Victoria',
                            'region:western-australia' => 'Western Australia'
                        ]
                    ];
                    break;
                default:
                    $data = $this->getDefaultNestedByCountry(abs($id), $keyColumn);
            }

            $cache->set($key, serialize($data));

            return $data;
        }

        return unserialize($data);

    }

    private function getDefaultNestedByCountry($id, $keyColumn) {
        $node = $this->findByTypeAndId('country', $id);

        $children = $node->getChildrenOfType(array('category', 'departure'));

        $categories = array_filter($children->getData(), function($child) {
            return $child->get('type') == 'category';
        });

        $departures = array_filter($children->getData(), function($child) {
            return $child->get('type') == 'departure';
        });

        $locations = [];

        foreach ($categories as $category) {
            $locations[$category->get('name')] = array(
                $category->get($keyColumn) => 'Any from '. $category->get('name')
            );

            $locations[$category->get('name')] = array_replace(
                $locations[$category->get('name')],
                $this->toKeyValue($category->getChildrenOfType('location'), $keyColumn, 'name')
            );
        }

        $data = array_replace(array(
            'Popular' => $this->toKeyValue($departures, $keyColumn, 'name'),
        ), $locations);

        return $data;
    }

    private function toKeyValue($objects, $key, $value)
    {
        $data = [];

        foreach ($objects as $object)
        {
            $data[$object->get($key)] = $object->get($value);
        }

        return $data;
    }
}
