<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class LocationsTable extends Doctrine_Table
{
    public function findAllByCountry()
    {
        return $this->createQuery()
            ->orderBy('name asc')
            ->execute();
    }

    public function findNestedByCategory($country = null, $prefix = '', $keyMethod = 'getId')
    {
        $categories = Doctrine::getTable('LocationCategory')->findAllWithLocations($country);
        $locations = array();

        foreach ($categories as $category)
        {
            $locations[$category->get('description')] = array();

            foreach ($category->get('Locations') as $location)
            {
                $locations[$category->get('description')][$prefix.$location->$keyMethod()] = $location->get('name');
            }
        }

        return $locations;
    }

    /**
     * static alias for @findNestedByCategory, use by admin-generator
     */
    public static function findNestedLocationsByCategory($prefix = '')
    {
        return Doctrine::getTable('Locations')->findNestedByCategory(null, '', 'getCountryAndPk');
    }

    public function findFromBranchOrId($from)
    {
        if (strpos($from, '_') !== false) {
            list($prefix, $id) = explode('_', $from);

            if ('tc' === $prefix) {
                $from = $id;
            } else {
                $branch = Doctrine::getTable('OwnerBranch')->find($id);
                $from = $branch->get('NearestLocation')->get('id');
            }
        }

        return $this->find($from);
    }
}
