<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class NotificationUserTable extends Doctrine_Table
{
    public function findAccountByEmail($email)
    {
        $user = Doctrine::getTable('User')->findOneByEmail($email);
        $account = false;

        if (!$user)
        {
            $account = $this->findOneByEmail($email);
        }
        else
        {
            $account = $user->get('NotificationAccount')->getFirst();
        }

        if (!$account)
        {
            $account = new NotificationUser();
            $account->set('User', $user ?: null);
            $account->set('email', $user ? null : $email);
        }

        return $account;
    }

    public function createAccount($user)
    {
        $account = $this->findOneByEmail($user->get('email'));


        if ($user->get('email_notify_new_reloc') === 'none')
        {
            // remove the account if the user did not registered to notifications
            $account && $account->delete();
            return;
        }

        $account = $account ?: new NotificationUser();
        $account->set('User', $user);
        $account->set('email', null);
        $account->save();
    }

    /**
     * find route subscribers from the given pickup and dropoff locations
     *
     * Users can subscribe to routes using "popular" locations as well as standard locations.
     * If the user choose a popular location (i.e. Auckland to CHC), we need to find all the routes
     * matching those popular locations. That's why we look for all the descendants of each route.
     */
    public function findSubscribers(Locations $from, Locations $to, $from_date, $to_date)
    {
        $pickup  = Doctrine::getTable('LocationNode')->findByTypeAndId('location', $from->getId());
        $dropoff = Doctrine::getTable('LocationNode')->findByTypeAndId('location', $to->getId());
        $country_id = $from->get('Category')->get('country_id');

        $query = $this->createQuery('nu')
            ->leftJoin('nu.NotifyRoutes nr')
            ->leftJoin('nr.LocationFrom lf')
            ->leftJoin('nr.LocationTo lt')
            ->leftJoin('lf.Descendants lfa')
            ->leftJoin('lt.Descendants lta')
            ->leftJoin('nu.User u')
            ->addWhere('nu.country_id = ?', $country_id)
            ->addWhere('(u.user_status is null or u.user_status=1)')
            ->addWhere('(u.email_notify_new_reloc is null or u.email_notify_new_reloc != ?)', 'none')
            ->addWhere('(nr.location_from_id is null or lfa.node_id = ? or lfa.node_ancestor_id = ?)', array($pickup->getId(), $pickup->getId()))
            ->addWhere('(nr.location_to_id is null or lta.node_id = ? or lta.node_ancestor_id = ?)', array($dropoff->getId(), $dropoff->getId()))
            ->addWhere('(nr.date_from is null or (nr.date_from >= ? and nr.date_from < ?))', array($from_date, $to_date))
            ->addWhere('(nr.date_to is null or (nr.date_to >= ? and nr.date_to < ?))', array($from_date, $to_date))
        ;
        
        $users = $query->execute();
        $pickup->free(true);
        $dropoff->free(true);
        $query->free();

        return $users;
    }
}