<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class OwnerUser extends BaseOwnerUser
{
    public function __toString()
    {
        return $this->getFullName();
    }

    public function getCompany()
    {
        return $this->get('Owner')->get('company');
    }

    public function mustCreditAccount($limit = 0)
    {
        return $this->get('Owner')->mustCreditAccount($limit);
    }

    public function canCreateAirportRelocs()
    {
        return $this->get('Owner')->canCreateAirportRelocs();
    }

    /**
     * Overrides the default behavior to encrypt the password using bcrypt
     */
    public function setPassword($password)
    {
        parent::rawSet('password', $this->crypt($password));
    }

    public function renewRememberMeKey()
    {
        $privateKey = $this->generateRandomKey();
        parent::rawSet('remember_me_key', $this->crypt($privateKey));

        return $privateKey;
    }

    public function generateRandomKey($algorithm = 'whirlpool')
    {
        return hash($algorithm, uniqid(mt_rand(), true));
    }

    public function checkRememberMeCookie($privateKey)
    {
        return crypt($privateKey, $this->get('remember_me_key')) == $this->get('remember_me_key');
    }

    private function crypt($key)
    {
        $salt = sprintf('$2a$%02d$', 12);
        $salt .= $this->generateRandomKey();

        return crypt($key, $salt);
    }

    public function checkPassword($password)
    {
        return crypt($password, $this->get('password')) == $this->get('password');
    }

    public function getFullName()
    {
        return $this->get('firstname'). ' ' . $this->get('lastname');
    }

    public function getAccountBalance()
    {
        return $this->get('Owner')->get('account_balance');
    }

    public function getCountryDomainId()
    {
        return $this->get('Owner')->get('country_domain_id');
    }

    public function getCountryDomain()
    {
        return $this->get('Owner')->get('Country')->get('domain');
    }

    public function getEmailToParams()
    {
        return array(
            'email'  => $this->get('email'),
            'name'   => $this->getFullName(),
            'format' => 'html',
            'id'     => $this->get('owner_id')
        );
    }
}