<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class OwnerVehicleTypeTable extends Doctrine_Table
{
    public static function getRentalTypes()
    {
        return array(
            'day'   => 'Calendar Day',
            'night' => '24 hour cycle'
        );
    }
    public static function getTransmissionTypes()
    {
        return array(
            'automatic' => 'Automatic',
            'manual'    => 'Manual',
            'varies'    => 'Automatic or Manual'
        );
    }

    public static function getFuelTypes()
    {
        $names = array(
            'petrol'   => 'Petrol',
            'diesel'   => 'Diesel',
            'LPG'      => 'LPG',
            'electric' => 'Electric',
            'hybrid'   => 'Hybrid',
            'varies'   => 'Fuel or Diesel'
        );

        if ($_SERVER['TRANSFER_CAR_COUNTRY'] === 'us') {
            $names['petrol'] = 'Gas - non Diesel';
            $names['varies'] = 'Gas or Diesel';
        }

        return $names;
    }

    public function __toString()
    {
        return $this->get('description');
    }

    public function getTypesList($user, $country = null)
    {
        $id = $user->getOwnerId();

        $query = $this
            ->createQuery('v')
            ->select('id, internal_name, name')
            ->innerJoin('v.Country c')
            ->where('owner_id = ?', $id);

        if ($country)
        {
            $query->addWhere('c.id = ?', $country);
        }

        $rows = $query->execute(array(), Doctrine::FETCH_ARRAY);

        $list = array();

        foreach ($rows as $row)
        {
            $list[$row['id']] = sprintf('%s (%s)', $row['name'], $row['internal_name']);
        }

        return $list;
    }
}