<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class Payments extends BasePayments
{
	/// Possible payment states
	/// This values are corelated with credit card transaction states
	const STATUS_NEW = 0; // new payment, yet no processed
	const STATUS_ACCEPTED = 1; // payment was accepted
	const STATUS_REJECTED = 2; // payment was rejected e.g. by payment gate


	/**
	 * Get detailed info about payment type. Used in backend app.
	 *
	 * @return string Payment type details
	 */
	public function type_details()
	{
	    if($this->type == 'cc'){
	        return 'Credit Card';
	    }

		if($this->type == 'conversion'){
	        return 'Currency conversion';
	    }

		if($this->type == 'charge_expire'){
	        return 'Expired credits';
	    }

	    // type == 'manual'
	    // if amount < 0 and assigned record id < 0 - fee for reloc accept
	    if($this->amount < 0 && $this->assigned_record_id < 0){
	        return 'Reloc '.(-$this->assigned_record_id);
	    }

	    // Other manual
	    if($this->description){
	        return 'Manual ('.$this->description.')';
	    } else {
	        return 'Manual';
	    }
	}

	public function getFormatAmount($is_inverse = false, $column = "")
	{
		$format_amount = "";
		$amount = ($is_inverse == true) ? -$this->amount : $this->amount;
		return $this->formatAmount($amount, $column);
	}

	public function formatAmount($amount, $column = "")
	{
		if ($this->is_new_type_payment == 'no' || $this->type == "cxonversion" && $this->amount < 0)
        {
        	$format_amount =  sfConfig::get("sf_currency_old") . $amount;
        }else
        {
        	$format_amount = $amount . " " . sfConfig::get("sf_currency_new");
        }

        return $format_amount;
	}

	public function getRelocDetails()
	{
		if($this->assigned_record_id){
			if ($listing = $this->getListing()) {
				$vehicle = $listing->getVehicle();
				$pickup = $listing->getPickLocation();
				$dropoff = $listing->getDropLocation();

				return sprintf('%s: %s - %s', $vehicle, $pickup, $dropoff);
			}
		}
	}

	protected static $cache;

	public function getListing()
	{
		if (!self::$cache) {
			self::$cache = new Doctrine_Cache_Array();
		}

		return Doctrine::getTable('Listing')->createQuery()
			->where('id = ?', abs($this->assigned_record_id))
			->innerJoin('Listing.Owner o')
			->innerJoin('Listing.Requests r')
			->useResultCache(self::$cache)
			->fetchOne();
	}

	public function getDomain()
	{
		return $this->get('Country')->get('domain');
	}

}
