<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class RelocationReviewTable extends Doctrine_Table
{
    public function findForROQuery($ro)
    {
        return $this->createQuery('r')
            ->innerJoin('r.Request req')
            ->innerJoin('req.Listing l')
            ->innerJoin('req.Driver d')
            ->where('l.owner_id = ?', $ro->getId())
            ->addWhere('r.status != ?', RelocationReview::STATUS_DELETED)
            ->orderBy('r.created_at desc');
    }

    public function findTcReviewsQuery()
    {
        return $this->createQuery('r')
            ->innerJoin('r.Request req')
            ->innerJoin('req.Listing l')
            ->innerJoin('req.Driver d')
            ->orderBy('r.created_at desc')
        ;
    }

    public function findNbReviewsForRO($ro)
    {
        return $this->findForROQuery($ro)
            ->addWhere('length(r.ro_review) > 0')
            ->count();
    }

    public function findNbRatingsForRO($ro)
    {
        return $this->findForROQuery($ro)
            ->count();
    }

    public function findNbTcReviews()
    {
        return $this->findTcReviewsQuery()
            ->addWhere('length(r.tc_review) > 0')
            ->count();
    }

    public function findNbTcRatings()
    {
        return $this->createQuery('r')
            ->innerJoin('r.Request req')
            ->innerJoin('req.Listing l')
            ->innerJoin('req.Driver d')
            ->count();
    }

    public function getTcRating()
    {
        $data = $this->createQuery()
            ->select('AVG(tc_score) as rating')
            ->execute(array(), Doctrine::FETCH_ARRAY);

        return $data[0]['rating'];
    }

    public function getNbReviews($ro)
    {
        return $this->findForROQuery($ro)
            ->addWhere('length(ro_review) > 0')
            ->count();
    }


    public function getRoRating($ro)
    {
        $data = $this->createQuery('r')
            ->select('AVG(ro_score) as rating')
            ->innerJoin('r.Request req')
            ->innerJoin('req.Listing l')
            ->where('l.owner_id = ?', $ro->getId())
            ->execute(array(), Doctrine::FETCH_ARRAY);

        return $data[0]['rating'];
    }
}