<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class Rental extends BaseRental
{
	const STATUS_NEW = 0;
	#TODO
	public function isBooked(){
		return false;
	}

	public function getManager()
	{
		return $this->get('ListedBy')->getFullName();
	}

	public function getCountryDomain(){
		return 'nz';
	}

	public function getNbRequests()
	{
		$count = 0;
		foreach ($this->get('Enquiries') as $enquiry) {
			if ($enquiry->isStatus(Enquiry::STATUS_PENDING)) {
				$count++;
			}
		}

		return $count;
	}

	public function getSlug()
	{
		$name = $this->get('OwnerVehicleType')->get('name');
		$slug = Doctrine_Inflector::urlize($name);
		$slug .= '-'.$this->getId();

		return $slug;
	}

	public function getStatusName()
	{
		if ($this->getNbRequests()) {
			return 'Requested';
		}

		return 'Listed';
	}

	public function getMinMonthlyPrice()
	{
		if (count($this->get('rates'))) {
			$minPrice = false;
			foreach ($this->get('rates') as $rate) {
				$minPrice = $minPrice === false || $rate['monthly_rate'] < $minPrice ? $rate['monthly_rate'] : $minPrice;
 			}

 			return $minPrice;
		}

		return $this->get('monthly_rental_price');
	}


	public function getMinWeeklyPrice()
	{
		if (count($this->get('rates'))) {
			$minPrice = false;
			foreach ($this->get('rates') as $rate) {
				$minPrice = $minPrice === false || $rate['weekly_rate'] < $minPrice ? $rate['weekly_rate'] : $minPrice;
 			}

 			return $minPrice;
		}

		return $this->get('weekly_rental_price');
	}

	public function getMinDailyPrice()
	{
		if (count($this->get('rates'))) {
			$minPrice = false;
			foreach ($this->get('rates') as $rate) {
				$minPrice = $minPrice === false || $rate['daily_rate'] < $minPrice ? $rate['daily_rate'] : $minPrice;
 			}

 			return $minPrice;
		}

		return $this->get('daily_rental_price');
	}

	public function getNewRequestContact($request)
    {
      $option = $this->get('Owner')->get('request_email_option');

      switch ($option) {
        default:
        case 'listing_manager':
          $contact = $this->get('ListedBy');
          break;

        case 'branch_contact':
          $contact = $request->get('OwnerBranch')->get('Contact');

          if (!$contact || !$contact->exists())
          {
            $contact = $this->get('Owner')->getDefaultContact();
          }
          break;

        case 'manager':
        case 'contact':
          list($type, $id) = explode(':', $this->get('Owner')->get('request_email_option_value'));

          $table = 'manager' == $type ? 'OwnerUser' : 'OwnerContact';

          $contact = Doctrine::getTable($table)->find($id);
          break;
      }

      return $contact;
    }

    public static function getCategoriesDescriptions()
    {
    	return [
    		'budget' => 'Lorem ipsum dolor sit amet, consectetur adipiscing elit.',
    		'luxury' => 'Praesent viverra quis tortor quis efficitur.',
    		'flexible' => 'Sed a rhoncus nisi.',
    		'business' => 'Cras rutrum dolor eu nunc commodo laoreet.'
    	];
    }

    /**
     * Standard cars: sedan, suv etc

High to low price
low to high price


right arrow on dropdown: too much on the right

     * */
    public function getCategory()
    {
    	$ownerVehicleType = $this->get('OwnerVehicleType');
    	$vehicleType = $ownerVehicleType->get('VehicleType');

    	if ($ownerVehicleType->get('fuel_type') == 'electric' || $ownerVehicleType->get('fuel_type') == 'hybrid') {
    		return 'Electric/Hybrid';
    	}

    	if (stripos($vehicleType->get('description'), 'ute')!==false || stripos($vehicleType->get('description'), '4x4')!==false) {
    		return '4WD/Ute';
    	}

    	if (stripos($vehicleType->get('description'), 'van')!==false || stripos($vehicleType->get('description'), 'motorhome')!==false) {
    		return 'Van';
    	}


    	if (in_array(strtolower($vehicleType->getCleanName()), ['suv', 'sedan', 'hatchback'])!==false) {
    		return 'Standard car';
    	}

    	return 'Other';
    }


    public static function getCategories()
    {
    	return [
    		'budget' => 'Budget',
    		'luxury' => 'Luxury',
    		'flexible' => 'Flexible',
    		'business' => 'Business'
    	];
    }
}