<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class RequestTable extends Doctrine_Table
{
    private function getDistance($dropoff, $pickup)
    {
        $lat1 = floatval($dropoff->get('lat'));
        $lat2 = floatval($pickup->get('lat'));

        $lon1 = floatval($dropoff->get('lon'));
        $lon2 = floatval($pickup->get('lon'));

        return sqrt(pow(110.56*($lat2 - $lat1), 2) + pow(84.8*($lon2 - $lon1), 2));
    }

    public function getNbRequests($user, $startDate, $endDate, $statuses = null)
    {
        $query = $this
            ->createQuery('r')
            ->innerJoin('r.Listing l')
            ->where('l.owner_id = ?', $user->getId())
            ->addWhere('r.created_at between ? and ?', array($startDate, $endDate));

        if ($statuses) {
            $query->whereIn('r.status', $statuses);
        }

        return $query->count();
    }

    public function hasRecentBookingFrom($location)
    {
        $count = $this
            ->createQuery('r')
            ->innerJoin('r.AcceptedListing l')
            ->where('l.pickup_location_id = ?', $location->getId())
            ->addWhere('r.when_accepted >= ?', date('Y-m-d H:i:s', strtotime('-1 day')))
            ->count();
        return $count > 0;
    }
}
