<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class VehicleType extends BaseVehicleType
{
    public function __toString()
    {
        return (string) $this->get('description');
    }

    public function getInternalName()
    {
        return $this->get('description');
    }

    public function getRentalType()
    {
        return 'day';
    }

    public function getIdAndCountry()
    {
        return $this->get('id').'-'.$this->get('country_id');
    }

    // Get vehicle types list
    public static function typeList($country = null)
    {
        $result = array();

        $query = Doctrine_Query::create()
            ->from('VehicleType vt')
            ->where('vt.is_active=1')
            ->orderBy('description ASC')
        ;
        if ($country)
        {
            $query->addWhere('vt.country_id = ?', $country);
        }

        $types = $query->execute();

        foreach($types as $type){
            $result[$type->id] = $type->description;
        }

        return $result;
    }

    public function getTransmissionName()
    {
        $names = OwnerVehicleTypeTable::getTransmissionTypes();

        return isset($names[$this->get('transmission_type')]) ? $names[$this->get('transmission_type')] : 'varies';
    }

    public function getFuelName()
    {
        return 'varies';
    }

    /**
     * Get path for the icon representing the car
     *
     * @return string Icon path
     */
    public function icon_path($absolute = false)
    {
        // Convert vehicle name to corresponding icon filename
        $name = $this->getImageName();

        return '/images/vehicles/'.$name;
    }

    public function getImageName()
    {
        $name = $this->getCleanName();
        // Convert all characters to lower case and remove special characters
        $name = strtolower($name);
        $name = preg_replace('/[^a-z0-9]/', '_', $name);
        $name .= '.gif';

        foreach (array('suv', 'van', 'compact', 'truck', 'rv', 'convertible') as $key) {
                if (strpos($name, $key) !== false) {
                    $name = $key.'.gif';
                }
        }

        return $name;
    }

    public function getCleanName()
    {
        $name = $this->description;
        if(strpos($name, ' (') !== false){
            $pos = strpos($name, ' (');
            $name = substr($name, 0, $pos);
        }

        return $name;
    }

    public function getName()
    {
        return $this->getCleanName();
    }

    public function getImagesPaths()
    {
        return array($this->icon_path());
    }
}
