<?php
/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
class VehicleTypeTable extends Doctrine_Table
{
    public function findAllSorted($country = null)
    {
        $query = $this->createQuery()
            ->orderBy('description ASC');

        if ($country)
        {
            $query->addWhere('country_id = ?', $country);
        }

        return $query->execute();
    }

    public function findAllNestedByCountry()
    {
        $countries = Doctrine::getTable('LocationCountry')
            ->createQuery('c')
            ->innerJoin('c.VehicleType v')
            ->orderBy('c.name, v.description')
            ->execute();

        $data = array();

        foreach ($countries as $country) {
            $data[$country->get('name')] = array();

            foreach ($country->get('VehicleType') as $vehicle) {
                $data[$country->get('name')][$vehicle->getId()]= $vehicle->get('description');
            }
        }

        return $data;
    }

    public function getCategories($country = null)
    {
        $categories = array();
        $vehicles = $this->findAllSorted($country);

        foreach ($vehicles as $vehicle) {
            $name = preg_replace('/ \(\d+(-\d+)?[-+ ]+(\w+)\)$/', '', $vehicle->get('description'));
            $name = preg_replace('/^(RV|SUV)( .*)$/', '\\1', $name);

            if (!isset($categories[$name])) {
                $categories[$name] = $vehicle->getId();
            } else {
                $categories[$name] .= '|'.$vehicle->getId();
            }
        }

        return array_flip($categories);
    }
}
