<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
abstract class BaseRental extends Transfercar\Doctrine\tcDoctrineRecord
{
  public function setTableDefinition()
  {
    $this->setTableName('rental');
    $this->hasColumn('id', 'integer', null, array('type' => 'integer', 'primary' => true, 'autoincrement' => true));
    $this->hasColumn('owner_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('date_available_from', 'date', null, array('type' => 'date'));
    $this->hasColumn('status', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('price', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('daily_rental_price', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('weekly_rental_price', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('monthly_rental_price', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('extra_day_rental_price', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('daily_insurance_rate', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('weekly_insurance_rate', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('monthly_insurance_rate', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('rates', 'array', null, array('type' => 'array'));
    $this->hasColumn('excess', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('reduced_excess', 'decimal', 6, array('type' => 'decimal', 'scale' => 2, 'length' => '6'));
    $this->hasColumn('vehicle_type_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('owner_vehicle_type_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('comment', 'string', null, array('type' => 'string'));
    $this->hasColumn('tyres_included', 'boolean', null, array('type' => 'boolean', 'default' => false));
    $this->hasColumn('roadside_assistance_included', 'boolean', null, array('type' => 'boolean', 'default' => false));
    $this->hasColumn('maintenance_included', 'boolean', null, array('type' => 'boolean', 'default' => false));
    $this->hasColumn('created_at', 'date', null, array('type' => 'date'));
    $this->hasColumn('updated_at', 'date', null, array('type' => 'date'));
    $this->hasColumn('terms_id', 'integer', 4, array('type' => 'integer', 'unsigned' => 1, 'length' => '4'));
    $this->hasColumn('listed_by', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('updated_by', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('accepted_enquiry_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('admin_id', 'integer', null, array('type' => 'integer'));
  }

  public function setUp()
  {
    $this->hasOne('User as Owner', array('local' => 'owner_id',
                                         'foreign' => 'id',
                                         'onDelete' => 'CASCADE'));

    $this->hasOne('OwnerUser as ListedBy', array('local' => 'listed_by',
                                                 'foreign' => 'id',
                                                 'onDelete' => 'SET NULL'));

    $this->hasOne('OwnerUser as UpdatedByManager', array('local' => 'updated_by',
                                                         'foreign' => 'id',
                                                         'onDelete' => 'SET NULL'));

    $this->hasOne('OwnerVehicleType', array('local' => 'owner_vehicle_type_id',
                                            'foreign' => 'id',
                                            'onDelete' => 'SET NULL'));

    $this->hasOne('VehicleType', array('local' => 'vehicle_type_id',
                                       'foreign' => 'id',
                                       'onDelete' => 'SET NULL'));

    $this->hasMany('Enquiry as Enquiries', array('local' => 'id',
                                                 'foreign' => 'rental_id'));

    $this->hasOne('Terms', array('local' => 'terms_id',
                                 'foreign' => 'id',
                                 'onDelete' => 'SET NULL'));

    $this->hasOne('AdminUser', array('local' => 'admin_id',
                                     'foreign' => 'id'));

    $this->hasMany('RentalPickup', array('local' => 'id',
                                         'foreign' => 'rental_id'));
  }
}