<?php

/**
 * This class has been auto-generated by the Doctrine ORM Framework
 */
abstract class BaseRequest extends Transfercar\Doctrine\tcDoctrineRecord
{
  public function setTableDefinition()
  {
    $this->setTableName('request');
    $this->hasColumn('id', 'integer', null, array('type' => 'integer', 'primary' => true, 'autoincrement' => true));
    $this->hasColumn('driver_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('status', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('deleted', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('listing_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('pickup_date', 'timestamp', null, array('type' => 'timestamp'));
    $this->hasColumn('nb_free_days', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('nb_paid_days', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('drop_off_date', 'timestamp', null, array('type' => 'timestamp'));
    $this->hasColumn('pickup_time', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('dropoff_time', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('rating_comment', 'string', 128, array('type' => 'string', 'length' => '128'));
    $this->hasColumn('internal_rating_comment', 'string', 255, array('type' => 'string', 'length' => '255'));
    $this->hasColumn('rating', 'integer', 1, array('type' => 'integer', 'length' => '1'));
    $this->hasColumn('rating_at', 'timestamp', null, array('type' => 'timestamp'));
    $this->hasColumn('when_accepted', 'timestamp', null, array('type' => 'timestamp'));
    $this->hasColumn('created_at', 'timestamp', null, array('type' => 'timestamp'));
    $this->hasColumn('no_show_fee', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('no_show_fee_amount', 'float', 6, array('type' => 'float', 'length' => '6'));
    $this->hasColumn('credit_card_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('cancelled_at', 'timestamp', null, array('type' => 'timestamp'));
    $this->hasColumn('cancellation_reason_id', 'integer', null, array('type' => 'integer'));
    $this->hasColumn('cancellation_document', 'string', 255, array('type' => 'string', 'length' => '255'));
    $this->hasColumn('is_late_cancel', 'boolean', null, array('type' => 'boolean'));
    $this->hasColumn('listing_data', 'array', null, array('type' => 'array'));
    $this->hasColumn('internal_status', 'integer', 1, array('type' => 'integer', 'length' => '1'));
    $this->hasColumn('internal_comments', 'array', null, array('type' => 'array', 'length' => ''));
    $this->hasColumn('driver_cancel_comment', 'string', null, array('type' => 'string', 'length' => ''));
    $this->hasColumn('is_withdrawn', 'boolean', null, array('type' => 'boolean'));
    $this->hasColumn('is_resubmit', 'boolean', null, array('type' => 'boolean', 'default' => false));
    $this->hasColumn('booking_type', 'string', 255, array('type' => 'string', 'length' => '255'));
  }

  public function setUp()
  {
    $this->hasOne('User as Driver', array('local' => 'driver_id',
                                          'foreign' => 'id',
                                          'onDelete' => 'CASCADE'));

    $this->hasOne('Listing', array('local' => 'listing_id',
                                   'foreign' => 'id',
                                   'onDelete' => 'CASCADE'));

    $this->hasOne('CreditCard', array('local' => 'credit_card_id',
                                      'foreign' => 'id',
                                      'onDelete' => 'SET NULL'));

    $this->hasMany('RequestComment as Comments', array('local' => 'id',
                                                       'foreign' => 'request_id',
                                                       'onDelete' => 'CASCADE'));

    $this->hasOne('OwnerBranch as AlternativeDropoff', array('local' => 'alternative_dropoff_id',
                                                             'foreign' => 'id'));

    $this->hasMany('Listing as AcceptedListing', array('local' => 'id',
                                                       'foreign' => 'accepted_request_id'));

    $this->hasOne('RelocationReview as Review', array('local' => 'id',
                                                      'foreign' => 'request_id'));

    $this->hasOne('CancellationReason', array('local' => 'cancellation_reason_id',
                                              'foreign' => 'id'));
  }
}
