<?php

class Flo2CashRefundHandler
{
    public static function processRefund($user)
    {
        $transaction = Doctrine::getTable('CCTransaction')
          ->createQuery('cct')
          ->innerJoin('cct.Payment p')
          ->where('p.user_id = ?', $user->get('id'))
          ->addWhere('cct.status = ?', CCTransaction::STATUS_ACCEPTED)
          ->addWhere('p.is_new_type_payment = 1')
          ->orderBy('cct.id DESC')
          ->limit(1)
          ->fetchOne();

        if (!$transaction)
        {
          return false;
        }

        $log = unserialize(current($transaction->get('communication_log')))->transactionresult;

        $InputVariables = array(
          'Username' => sfConfig::get('sf_payment_username'),
          'Password' => sfConfig::get('sf_payment_password'),
          'OriginalTransactionId' => (string) $log->TransactionId,
          'Amount' => (string) $log->Amount,
          'Reference' => 'Transfercar Refund',
          'Particular' => 'Testing Refund'
        );

        $PaymentService = new SoapClient(sfConfig::get('sf_payment_url_new'));

        $result = $PaymentService->ProcessRefund($InputVariables);

        $transaction->set('status', CCTransaction::STATUS_REFUNDED);
        $transaction->save();

        return $log;
    }
}