<?php

class fixlistingcreditsTask extends sfBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'fix-listing-credits';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [fix-listing-credits|INFO] task does things.
Call it with:

  [php symfony fix-listing-credits|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'propel');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

//     $listings = Doctrine::getTable('Listing')
//       ->createQuery()
//       ->addWhere('status = 0')
//       ->addWhere('price is null')
//       ->execute();

//     $this->logSection('listings', 'Correcting prices '.count($listings));
//     foreach ($listings as $listing) {
//       $oldPrice = $listing->get('price');
//       $newPrice = Doctrine::getTable('Prices')->getPriceFor(
//         $listing->get('pickup_location_id'),
//         $listing->get('dropoff_location_id'),
//         $listing->get('vehicle_type_id')
//       );

//       $listing->set('price', $newPrice);
//       $listing->save();

//       foreach ($listing->get('ChildrenListings') as $child) {
//         $child->set('price', $newPrice);
//         $child->save();
//       }

//       $this->log(sprintf('TCID: %s, %s, old: %s, new: %s', $listing->getId(), $listing->get('created_at'), $oldPrice, $newPrice));
//     }
// return;
    $ros = Doctrine::getTable('User')
      ->createQuery()
      ->addWhere('is_owner = ?', true)
      // ->addWhere('payment_cc = ?', true)
      ->addWhere('id = ?', 39162)
      ->execute();

    foreach ($ros as $ro) {
      $payments = Doctrine::getTable('Payments')
      ->createQuery()
      ->addWhere('date >= ?', '2018-10-01')
      ->addWhere('date < ?', '2018-10-02')
      ->addWhere('user_id = ?', $ro->getId())
      ->orderBy('id asc')
      ->execute();

      if (count($payments) <= 2) {
        continue;
      }
      $this->logSection('ro', $ro->get('company').': '.count($payments));
      foreach ($payments as $payment) {
        if ($payment->get('description') == 'Credit conversion, previous balance') {
          break;
        }

        if ($payment->get('type') == 'manual' && $payment->amount < 0 && $payment->get('assigned_record_id') < 0) {
          

          switch ($payment->amount) {
            case "-65":
              $newAmount = -12;
              break;
            
            case 72:
              $newAmount = 18;
              break;
            case 598:
              $newAmount = 120;
              break;
            default:
              $newAmount = 'TBD';
              break;
          }
          $this->log(sprintf('amount: %s, new: %s', $payment->amount, $newAmount));

          if ($newAmount != 'TBD') {
            $payment->set('amount', $newAmount);
            $payment->save();
          }
        }
      }
    }
    return;

    $payments = Doctrine::getTable('Payments')
      ->createQuery()
      ->addWhere('type = ?', 'cc')
      ->addWhere('date >= ?', '2018-10-01')
      ->addWhere('amount > ?', 0)
      ->addWhere('national_currency_amount is not null')
      ->addWhere('description is null')
      ->orderBy('id desc')
      ->execute();

    foreach ($payments as $payment) {
      if ($payment->get('country_id') == 2) {
        if ($payment->get('national_currency_amount') == 684) {
          $this->log(sprintf('old: %s, new: %s', $payment->get('amount'), 720));
          $payment->set('amount', 720);
        } else {
          $this->log(sprintf('old: %s, new: %s', $payment->get('amount'), $payment->get('national_currency_amount')));
          $payment->set('amount', $payment->get('national_currency_amount'));
        }
      } elseif ($payment->get('country_id') == 1) {

        if ($payment->get('national_currency_amount') == 570) {
          $this->log(sprintf('old: %s, new: %s', $payment->get('amount'), 598));
          $payment->set('amount', 598);
        } else {
          $this->log(sprintf('old: %s, new: %s', $payment->get('amount'), $payment->get('national_currency_amount')));
          $payment->set('amount', $payment->get('national_currency_amount'));
        }
      }
      $payment->save();
    }

    $listings = Doctrine::getTable('Listing')
      ->createQuery('l')
      ->innerJoin('l.AcceptedRequest r')
      ->addWhere('r.status = ?', Request::STATUS_ACCEPTED)
      ->addWhere('l.price < 20')
      ->addWhere('r.when_accepted > ?', '2018-10-01')
      ->execute();

    $this->logSection('bookings', 'Correcting charged amounts');
    foreach ($listings as $listing) {
      $request = $listing->get('AcceptedRequest');
      $oldPrice = $listing->get('price');

      $newPrice = Doctrine::getTable('Prices')->getPriceFor(
        $listing->get('pickup_location_id'),
        $listing->get('dropoff_location_id'),
        $listing->get('vehicle_type_id')
      );
      $pricePerAdditionalDay = Doctrine::getTable('Prices')->getPriceForAdditionalDays(
        $listing->get('PickupLocation'),
        $listing->get('DropoffLocation'),
        $listing->get('vehicle_type_id')
      );
      $paidDayFee = $pricePerAdditionalDay * $request->get('nb_paid_days');

      //$this->log(sprintf('TCID: %s, old: %s, new: %s', $listing->getId(), $oldPrice, $newPrice));
      $listing->set('price', $newPrice);
      $listing->set('upselling_price', $paidDayFee);
      
      $newFee     = -$listing->getTotalPrice($request);

      $payment = Doctrine::getTable('Payments')
        ->createQuery()
        ->where('assigned_record_id = ?', -$listing->getId())
        ->limit(1)
        ->fetchOne();

      $oldFee = $payment->get('amount');
      $this->log(sprintf('TCID: %s, when: %s, free: %s/%s, paid: %s/%s, old: %s, new: %s, desc: %s', 
        $listing->getId(),
        $request->get('when_accepted'),
        $request->get('nb_free_days'),
        $listing->get('price'),
        $request->get('nb_paid_days'),
        $paidDayFee,
        $oldFee,
        $newFee,
        $payment->get('description')
      ));

      $payment->set('amount', $newFee);
      $payment->save();
      $listing->save();
    }
  }
}