<?php

class passwordUpgradeTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'password';
    $this->name             = 'upgrade';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [password:upgrade|INFO] task does things.
Call it with:

  [php symfony password:upgrade|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $this->logSection('memory', memory_get_usage()/1024);
    $users = Doctrine::getTable('User')
      ->createQuery('u')
      ->where('not u.password like ?', '$%')
      ->execute();

    $this->logSection('memory', memory_get_usage()/1024);
    $this->logSection('upgrade',count($users));
    foreach ($users as $i => $user)
    {
      $this->logSection('upgrade',$i.' '.$user->get('username'));
      // to prevent rehashing the password and lost it!
      if (false === strpos($user->getPassword(), '$')) {
        $user->setPassword($user->getPassword());
        $user->save();
        $user->free(true);
      }
    }

    $this->logSection('memory', memory_get_usage()/1024);
  }
}