<?php

class transfercarAbgcarsTask extends sfBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'abg-cars';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:abg-cars|INFO] task does things.
Call it with:

  [php symfony transfercar:abg-cars|INFO]
EOF;
    $this->addArgument('file', sfCommandArgument::REQUIRED, 'The abg file');
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    error_reporting(E_ALL);
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);
    $ros = [212056, 232255,232256,232257, 232258,232259,232332];
    $ros = [
      'NQLD' => 232255, // north queensland
      'NSW' => 232256, // new south wales
      'SQLD' => 212056, // sout queensland
      'MEL' => 232259, // victoria
      'WA' => 232332, // western australia + Karratha
      'Karratha' => 232332, // 
      //'NT' => false, // nothern territories
      'SA' => 232257, // south australia
      'TAS' => 232258, // tasmania
    ];

    foreach ($ros as $name => $id) {
      $this->log(str_repeat('-', 80));
      $this->logSection('import', $name);
      $this->log(str_repeat('-', 80));
      $this->import($name, $id);
    }    
  }

  private function import($ro, $roId) {
    $filename = 
    $file = fopen(sfConfig::get('sf_root_dir').'/../abgfleet/'.$ro.'.csv', 'rb');

    while ($row = fgetcsv($file,2048,',')) {
      if ($row[3] == 'Description' || $row[8] == '' || $row[0] == '') {
       //$this->log('.');
        continue;
      }

        $this->logSection('import', $row[0].': '.$row[8].'# '. $row[2]);

        $vehicle = new OwnerVehicleType();
        $vehicle->set('name', $row[3]);
        $vehicle->set('description', $row[3]);
        $vehicle->set('VehicleType', $this->getVehicleType(trim($row[0])));
        $vehicle->set('images', $this->getUploadImage(trim($row[0]),trim($row[5])));
        $vehicle->get('Countries')->add(Doctrine::getTable('LocationCountry')->find(2));
        $vehicle->set('internal_name', $row[1]);
        $vehicle->set('description', $row[3]);
        $vehicle->set('owner_id', $roId);
        $vehicle->set('country_id', 2);
        $vehicle->set('transmission_type', $row[7]);
        $vehicle->set('country_id', 2);
        $vehicle->set('number_adults', $row[10]);
        $vehicle->set('number_small_luggage', 0);
        $vehicle->set('number_large_luggage', 0);
        $vehicle->save();

    }
  }

  private function getVehicleType($type) {
    $mapping = [
      'A' => '4x4 (2 seats)',
      'B' => '4x4 (4 seats)',
      'C' => '',
      'D' => '4x4 (4 seats)',
      'E' => '4x4 (4 seats)',
      'F' => '4x4 (4 seats)',
      'G' => 'Truck',
      'H' => 'Van (5+ seats)',
      'K' => 'Bus - 12 seater',
      'L' => '4x4 (2 seats)',
      'P' => 'Van (5+ seats)',
      'S' => 'Truck',
      'V' => 'Truck',
      'X' => 'Truck',
      'W' => 'Bus - 12 seater',
      'Z' => 'Truck',
      'XA'=> 'Truck',
      'XB'=> 'Truck',
      'XC'=> 'Truck',
      'XD'=> 'Truck',
      'XE'=> 'Truck',
      'XF'=> 'Truck',
      'XG'=> 'Truck',
      'XH'=> 'Truck',
      'XK'=> 'Truck',
      'XL'=> 'Truck',
      'XP'=> 'Truck',
      'XS'=> 'Truck',
      'XV'=> 'Truck',
      'XW'=> 'Trailer',
      'XZ'=> 'varies',
    ];

    if (!array_key_exists($type, $mapping)) {
      throw new Exception("Invalid vehicle type '$type'", 1);
    }
    $description = $mapping[$type];
    $vehicle = Doctrine::getTable('VehicleType')
      ->createQuery()
      ->where('description = ?', $description)
      ->addWhere('country_id = ?', 2)
      ->limit(1)
      ->fetchOne();

    if (!$vehicle) {
      throw new Exception("Invalid vehicle $description($type)");
      
    }

    return $vehicle;
  }

  private function getUploadImage($type, $model) 
  {
    $files = [
      'a' => 'group-a-4x2-single-cab-tray.png',
      'b' => 'group-b-4x4-single-cab-tray-mine-spec.png',
      'b-minespec' => 'group-b-4x4-single-cab-tray.png',
      'd' => 'group-d-4x4-dual-cab-tray.png',
      'e-minespec' => 'group-e-4x4-wagon-mine-spec.png',
      'e' => 'group-e-4x4-wagon.png',
      'f' => 'group-f-4.2m-moving-van.png',
      'f-minespec' => 'group-f-4x-dual-cab-minespec.png',
      'g' => 'group-f-4.2m-moving-van.png',
      'h' => 'group-h-hitop-van.png',
      'k' => 'group-k-large-bus.png',
      'l' => 'group-l-4x2-dual-cab.png',
      'p' => 'group-p-1-tonne-van.png',
      's' => 'group-s-6.4m-tray.png',
      'v' => 'group-v-4.2m-tray.png',
      'w-minespec' => 'group-w-12-seater-bus-minespec.png',
      'w' => 'group-w-12-seater-bus.png',
      'x' => 'group-x-6.4m-van.png',
      'z' => 'group-x-6.4m-van.png',
      'xa'=> 'group-v-4.2m-tray.png',
      'xb'=> 'group-x-6.4m-van.png',
      'xc'=> 'group-x-6.4m-van.png',
      'xd'=> 'group-x-6.4m-van.png',
      'xe'=> 'group-v-4.2m-tray.png',
      'xf'=> 'group-s-6.4m-tray.png',
      'xg'=> 'group-s-6.4m-tray.png',
      'xh'=> 'truck',
      'xk'=> 'truck',
      'xl'=> 'truck',
      'xp'=> 'truck',
      'xs'=> 'truck',
      'xv'=> 'truck',
      'xw'=> 'trailer.gif',
      'xz'=> 'truck',
    ];


    $type = strtolower($type);
    if (stripos($model, 'mine')) {
      $type .= '-minespec';
    }

    if (!isset($files[$type])) {
      throw new Exception("Invalid type $type, $model", 1);
      
    }

    $image = $files[$type];

    $path = sfConfig::get('sf_root_dir').'/../abgfleet/trucks/'.$image;

    if (!file_exists($path)) {
      throw new Exception("Image $image ($type) does not exists", 1);
      
    }
    $newpath = sfConfig::get('sf_upload_dir').'/vehicles/'.md5($image.uniqid()).pathinfo($image, PATHINFO_EXTENSION);


    copy($path, $newpath);

    return [str_replace(sfConfig::get('sf_web_dir'),'',$newpath)];
  }
}
