<?php

class transfercarCAlocationsTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'ca-locations';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:ca-locations|INFO] imports Canadian locations
Call it with:

  [php symfony transfercar:ca-locations|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    $this->addArgument('file', sfCommandArgument::REQUIRED, 'The file name');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);
ini_set('display_errors', 1);
error_reporting(E_ALL);
    $file = fopen($arguments['file'], 'rb');
    $locations = new Doctrine_Collection(Doctrine::getTable('Locations'));

    while(($data = fgetcsv($file, null, ',')) !== false)
    {
      $this->log(sprintf('import %s %s', $data[0], $data[1]));
      $state = $this->getState($data);
      $locations[] = $this->getLocation($data, $state);
    }

    $conn = Doctrine::getTable('Locations')->getConnection();
    $conn->beginTransaction();
    $locations->save($conn);
    $conn->commit();
  }

  private function getLocation($data, $state)
  {
    list($lat, $lon) = $this->getLatLon($data);
    $location = new Locations();
    $location->set('name', trim($data[0]));
    $location->set('lat', $lat);
    $location->set('lon', $lon);
    $location->set('Category', $state);

    return $location;
  }

  private function getState($data)
  {
    static $states = [];

    if (!array_key_exists($data[1], $states)) {
      $state = new LocationCategory();
      $state->set('description', trim($data[1]));
      $state->set('country_id', 3);
      $states[$data[1]] = $state;
    }

    return $states[$data[1]];
  }

  // TODO
  private function getLatLon($data)
  {
    return [0, 0];
  }
}