<?php

use Transfercar\Mailchimp\MailchimpApi;

class transfercarEmailstatsTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'email-stats';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:email-stats|INFO] task does things.
Call it with:

  [php symfony transfercar:email-stats|INFO]
EOF;

    $this->addArgument('start', sfCommandArgument::REQUIRED, 'Start of time frame in format: "HH:MM dd-mm-yyyy"');
    $this->addArgument('end', sfCommandArgument::REQUIRED, 'End of time frame in format: "HH:MM dd-mm-yyyy"');
    $this->addArgument('limit', sfCommandArgument::OPTIONAL, 'The number of delivery stats to fetch', 500);
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // cc375b89311910c17edd75ecb14bd004db3afcfc
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $this->doCampaignMonitorStats($arguments);
  }

  private function doCampaignMonitorStats($arguments)
  {
    foreach (array('nz', 'au') as $domain) {
      $parts = explode(' ', $arguments['start']);
      //remove user to CampaignMonitor Web service

      $mc = new MailchimpApi();
      $bounced = $mc->getBounced(sfConfig::get('app_mailchimp_' . $domain . '_list_apikey'));

      if ($bounced['total_items']) {
        foreach ($bounced['members'] as $bounce)
        {
          $this->logSection($bounce['EmailAddress'], 'bounced by Mailchimp');
          Doctrine::getTable('User')->flagHardBounce($bounce['email_address']);
        }
      }
    }
  }
}
