<?php

class transfercarGeneratemanagersTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'generate-managers';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:generate-managers|INFO] task does things.
Call it with:

  [php symfony transfercar:generate-managers|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    $databaseManager = new sfDatabaseManager($this->configuration);

    $owners = Doctrine::getTable('User')->createQuery('u')
      ->where('u.is_owner = 1')
      ->addWhere('u.user_status = ?', 'active')
      ->execute();

    foreach ($owners as $owner)
    {
      $manager = new OwnerUser();

      if ($owner->get('Users')->count() > 0) {
        foreach ($owner->get('Users') as $user) {
          if ($user->get('username') === $owner->get('username') && $user->checkPassword($owner->get('username'))) {
            $manager = $user;
            break;
          }
        }
      }

      $manager->set('username', $owner->get('username'));
      $manager->set('firstname', $owner->get('firstname'));
      $manager->set('lastname', $owner->get('lastname'));
      $manager->set('password', $owner->get('username') . '+R4Nh');
      $manager->set('email', $owner->get('email'));
      $manager->set('country_id', $owner->get('country_domain_id'));
      $manager->set('owner_id', $owner->get('id'));
      $manager->set('is_admin', true);
      $manager->save();

      $this->logSection('added', sprintf('Manager %s (%s)', $manager->get('username'), $owner->get('company')));
    }
  }
}