<?php

class transfercarImportcartrawlerlocationsTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'import-cartrawler-locations';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:import-cartrawler-locations|INFO] task does things.
Call it with:

  [php symfony transfercar:import-cartrawler-locations|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);
    // add code here

    $locations = CarTrawlerLocation::getNzLocations();

    foreach ($locations as $key => $value) {
      $loc = Doctrine::getTable('Locations')->findOneByName(str_replace(' - ', ' ', $value));

      if (!$loc) {
        // try without the "- XXX" suffix
        $name = preg_replace('/ - .*+$/i', '', $value);
        $loc = Doctrine::getTable('Locations')->findOneByName($name);

        // try by append " City"
        if (!$loc) {
          $loc = Doctrine::getTable('Locations')->findOneByName($name.' City');

          if (!$loc) {
            $this->logSection('not found', $name.'('.$key.') found in our db: ');
          }
        }
      }

      if ($loc) {
        $node = Doctrine::getTable('LocationNode')->findByTypeAndId('location', $loc->getId());
        $this->createLocationMap(3, $key, $node->getId());
      }
    }
  }

  private function createLocationMap($advertiser_id, $advertiser_location_id, $location_id)
  {
    $map = new AdvertiserLocationMap();
    $map->set('advertiser_id', $advertiser_id);
    $map->set('advertiser_location_id', $advertiser_location_id);
    $map->set('tc_location_node_id', $location_id);
    $map->save();
  }

}