<?php

use Transfercar\Geoloc\GoogleMapsDistancesMatrix;

class transfercarInitlistingdistancesTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'init-listing-distances';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:init-listing-distances|INFO] task does things.
Call it with:

  [php symfony transfercar:init-listing-distances|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $matrix = new GoogleMapsDistancesMatrix();


    $q = Doctrine_Query::create()//->select('l.id , p.name')
                ->from('Listing l')
                ->innerJoin('l.PickupLocation p')
                ->innerJoin('l.DropoffLocation d')
                ->innerJoin('l.VehicleType vt')
                ->innerJoin('p.Category pC')
                ->innerJoin('l.Owner u')
                ->where('l.status = ?', Listing::STATUS_NEW);

    $listings = $q->execute();

    foreach ($listings as $listing) {
      $distance = $matrix->getDistances(
        $listing->get('PickupLocation')->getNameWithCountry('name'),
        $listing->get('DropoffLocation')->getNameWithCountry('name'),
        $listing->getCountryDomain()  == 'us' ? 'imperial' : 'metric'
      );

      if (false !== $distance) {
        $this->logSection($listing->getId(), $distance);
        $listing->set('kms_estimated', $distance);
        $listing->save();
      }
    }
    // add code here

  }
}