<?php

use Transfercar\Email\Sender\NewListingNotificationEmail;

class transfercarNotifynewlistingsTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'notify-new-listings';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:notify-new-listings|INFO] task does things.
Call it with:

  [php symfony transfercar:notify-new-listings|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    $this->addArgument('frequence', sfCommandArgument::REQUIRED, 'The frequence type (daily or instant)');
    $this->addArgument('country', sfCommandArgument::REQUIRED, 'The country code (nz, au)');
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
  }

  protected function execute($arguments = array(), $options = array())
  {
    ini_set('memory_limit', '512M');
    set_time_limit(0);
    ini_set('display_errors', true);
    ini_set('error_reporting', (E_ALL|E_STRICT) & ~E_DEPRECATED);

    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);
    sfContext::createInstance($this->configuration);

    $dispatcher = new sfEventDispatcher();
    $fileLogger = new sfFileLogger($dispatcher, array(
      'file' => sfConfig::get('sf_log_dir') . '/new_listing_mailer_'.$arguments['frequence'].'.log',
      'format' => '%time% %message%%EOL%',
      'timeFormat' => '%g-%m-%d %H:%M:%S'
    ));

    $logger = new sfAggregateLogger($dispatcher);
    $logger->addLogger($fileLogger);
    $logger->addLogger(new sfConsoleLogger($dispatcher));

    $mailer = new NewListingNotificationEmail($logger);

    switch ($arguments['frequence'])
    {
      case 'instant':
        $mailer->sendInstantEmails($arguments['country']);
        break;
      case 'daily':
        $mailer->sendDailyEmails($arguments['country']);
        break;
      default:
        throw new Exception("Unknown frequence ".$arguments['frequence']);
    }
  }
}