<?php

class transfercarProcessrefundTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'flo2cash';
    $this->name             = 'process-refund';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:process-refund|INFO] task does things.
Call it with:

  [php symfony flo2cash:process-refund|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    $this->addArgument('username', sfCommandArgument::REQUIRED, 'The username');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $user = Doctrine::getTable('User')->findOneByUsername($arguments['username']);

    if (!$user)
    {
      $this->logSection('refund',  sprintf('User "%s" not found', $arguments['username']));
      return;
    }

    if (!$log = Flo2CashRefundHandler::processRefund($user))
    {
      $this->logSection('refund', 'no transaction found');
      return;
    }

    $this->logSection('refund', 'Refunded transaction ID: '.$log->TransactionId. ' ($'.$log->Amount.')');
  }
}