<?php

use Transfercar\Ranking\SearchScore;

class transfercarRoUpdatescoresTask extends sfBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'update-ro-score';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:update-scores|INFO] update RO response rate score.

Call it with:

  [php symfony transfercar:update-scores|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $conn = Doctrine_Manager::connection();
    $res = $conn->execute($this->getOwnerQuery(), array('date' => date('Y-m-d', strtotime('-3 months'))));

    $this->logSection('owner-stats', $res->rowCount(). ' owners updated');
  }

  private function getOwnerQuery()
  {
    return <<<EOF
UPDATE user set average_response_time=(
    select avg(timediff(when_accepted, r.created_at))/86400
    from request r inner join listing l on r.listing_id=l.id
    where r.status in (1,4)
    AND l.owner_id=user.id
    AND r.created_at > :date
), response_rate = (
SELECT 1 - IFNULL(SUM(
CASE
  WHEN (r.status in (2,5)) THEN 1
END
) / count(*), 0)
 from request r
 inner join listing l on r.listing_id=l.id
 where 1=1
 AND l.owner_id=user.id
 AND r.created_at > :date
),
response_rate_date=CURRENT_DATE

where is_owner=1
EOF;
  }
}