<?php

use Transfercar\Email\ExternLib;

/*
 * This file is part of the symfony package.
 * (c) Fabien Potencier <fabien.potencier@symfony-project.com>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/**
 * Send emails stored in a queue.
 *
 * @package    symfony
 * @subpackage task
 * @author     Fabien Potencier <fabien.potencier@symfony-project.com>
 * @version    SVN: $Id: sfProjectSendEmailsTask.class.php,v 1.1 2010-11-11 11:58:28 nizam Exp $
 */
class sfProjectSendEmailsTask extends sfBaseTask
{
  /**
   * @see sfTask
   */
  protected function configure()
  {
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');

    $this->addOptions(array(
      new sfCommandOption('application', null, sfCommandOption::PARAMETER_OPTIONAL, 'The application name', true),
      new sfCommandOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev'),
      new sfCommandOption('message-limit', null, sfCommandOption::PARAMETER_OPTIONAL, 'The maximum number of messages to send', 0),
      new sfCommandOption('time-limit', null, sfCommandOption::PARAMETER_OPTIONAL, 'The time limit for sending messages (in seconds)', 0),
    ));

    $this->namespace = 'transfercar';
    $this->name = 'send-emails';

    $this->briefDescription = 'Sends emails stored in a queue';

    $this->detailedDescription = <<<EOF
The [project:send-emails|INFO] sends emails stored in a queue:

  [php symfony project:send-emails|INFO]

You can limit the number of messages to send:

  [php symfony project:send-emails --message-limit=10|INFO]

Or limit to time (in seconds):

  [php symfony project:send-emails --time-limit=10|INFO]
EOF;
  }

  protected function execute($arguments = array(), $options = array())
  {
    $databaseManager = new sfDatabaseManager($this->configuration);

    ini_set('memory_limit', '512M');
    ini_set('display_errors', true);
    ini_set('error_reporting', (E_ALL|E_STRICT) & ~E_DEPRECATED);


    $this->logSection('deprecated', 'deprecated');
  }
}
