<?php


use Symfony\Component\DomCrawler\Crawler;

class transfercarTestImportrentalcarscomlocationsTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'test-import-rentalcarscom-locations';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:import-rentalcarscom-locations|INFO] task does things.
Call it with:

  [php symfony transfercar:test-import-rentalcarscom-locations|INFO]
EOF;

    $this->addArgument('advertiser_username', sfCommandArgument::REQUIRED, 'Advertiser username');
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'propel');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    error_reporting(E_ALL);

    /*if (!$advertiser = Doctrine::getTable('Advertiser')->findOneByUsername($arguments['advertiser_username']))
    {
      throw new InvalidArgumentException("Advertiser account not found");
    }
    $this->advertiser = $advertiser;*/

    $gateway   = new RentalcarsComGateway($this);

    $xml = $gateway->findLocations('Australia');
    print_r($xml);
    return;
    //$xml = $gateway->find_vehicles('Auckland', '2017-11-30', 'Auckland', '2017-12-07', '25', 'NZD');
/*
    $xml = $gateway->findLocations('New Zealand');
    $crawler = new Crawler('<?xml version="1.0" encoding="UTF-8"?>'.  $xml);
    $this->loadCountry($crawler, 'NZ');

    $xml = $gateway->findLocations('Australia');
    $crawler = new Crawler('<?xml version="1.0" encoding="UTF-8"?>'.  $xml);
    $this->loadCountry($crawler, 'AU');
*/
    $names = [
      'USA - California',
      'USA - Florida',
      'USA - Las Vegas',
      'USA - New York',
      'USA - Other',
    ];

    foreach ($names as $name) {
      $xml = $gateway->findLocations($name);
      $crawler = new Crawler('<?xml version="1.0" encoding="UTF-8"?>'.  $xml);
      $this->loadCountry($crawler, 'US');
    }
  }

  private function loadCountry($crawler, $countryCode)
  {
    $cities = $crawler->filterXPath('//City');

    $this->logSection('cities', count($cities));
    foreach ($cities as $city) {
      $cityName = (string) $city->nodeValue;
      if (($locs = $this->findLocations(trim($cityName))) && count($locs))
      {
        $this->logSection('count', count($locs));
        foreach ($locs as $loc)
        {
          $this->createLocationMap($this->advertiser->getId(), $cityName, $loc->getId());
          $this->logSection('location', $loc->get('type').' '.$loc->get('name'));
        }
      }
    }
  }


  private function createLocationMap($advertiser_id, $advertiser_location_id, $location_id)
  {
    try {
      $map = new AdvertiserLocationMap();
      $map->set('advertiser_id', $advertiser_id);
      $map->set('advertiser_location_id', $advertiser_location_id);
      $map->set('tc_location_node_id', $location_id);
      $map->save();
      $this->logSection('added', 'locations added '.$location_id);
    } catch (Exception $e) {
      $this->logSection('error', 'locations exists '.$location_id);
    }
  }

  private function findLocations($value)
  {
    $value = str_replace(' Downtown', '', $value);
    $value = trim(preg_replace('/ \(\w+\)$/', '', $value));
    $value = trim(preg_replace('/, [A-Z]{2,3}$/', '', $value));
    $this->logSection('location', 'looking for '.$value);

    $locs = Doctrine::getTable('LocationNode')->findByName(str_replace(' - ', ' ', $value));

    if (!$locs->count()) {
      // try without the "- XXX" suffix
      $name = preg_replace('/ - .*+$/i', '', $value);
      $locs = Doctrine::getTable('LocationNode')->findByName($name);

      // try by append " City"
      if (!$locs->count()) {
        $locs = Doctrine::getTable('LocationNode')->findByName($name.' City');


        if (strpos($value, 'Airport') !== false) {
          return $this->findLocations(str_replace(' Airport', '', $value));
        }
        if (!$locs->count()) {
          $this->logSection('not found', $value.' not found in our db: ');
        }
      }
    }

    return $locs;
  }
}