<?php

use PhpAmqpLib\Message\AMQPMessage;

class transfercarTestemailsTask extends sfBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'test-emails';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:test-emails|INFO] task does things.
Call it with:

  [php symfony transfercar:test-emails|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    $this->addOption('is-agent', null, sfCommandOption::PARAMETER_REQUIRED, 'Set RO as agent', 0);
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    $_SERVER['TRANSFER_CAR_COUNTRY'] = 'nz';
    $_SERVER['HTTP_HOST'] = 'nz.transfercar.local';
    $_SERVER['SERVER_NAME'] = 'nz.transfercar.local';

    sfContext::createInstance($this->configuration);
    // Database initialization
    // $databaseManager = new sfDatabaseManager($this->configuration);


        $queue = new Transfercar\PhpAmqpLib\tcRabbitmq(
          sfConfig::get('app_amqp_host'),
          sfConfig::get('app_amqp_port'),
          sfConfig::get('app_amqp_username'),
          sfConfig::get('app_amqp_password'),
          sfConfig::get('app_amqp_path')
        );
        $queue->getChannel('accepted_requests_delayed');

        $msg = new AMQPMessage(260108, array('content_type' => 'text/plain', 'delivery_mode' => 2));
        $queue->getChannel('accepted_requests_delayed')->basic_publish($msg, '', 'accepted_requests_delayed');
   return;
    sfConfig::set('app_mailer_redirect_address', 'noel@transfercar.co.nz');
    $request = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->innerJoin('l.OwnerPickupBranch pb')
      ->innerJoin('l.OwnerDropoffBranch db')
      ->where('l.listed_by is not null')
      ->addWhere('r.status in (?, ?)', array(1, 4))
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $pendingRequest = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->innerJoin('l.OwnerPickupBranch pb')
      ->innerJoin('l.OwnerDropoffBranch db')
      ->where('l.listed_by is not null')
      ->addWhere('r.status = ?', 0)
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $ratedRequest = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->innerJoin('l.OwnerPickupBranch pb')
      ->innerJoin('l.OwnerDropoffBranch db')
      ->where('l.listed_by is not null')
      ->addWhere('r.status in (?)', array(4))
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $requestCancelledByRo = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->where('l.listed_by is not null')
      ->addWhere('r.status in (?, ?)', array(8, 9))
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $requestCancelledByDriver = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->where('l.listed_by is not null')
      ->addWhere('r.status in (?)', array(10))
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $bookingCancelledByDriver = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.AcceptedListing l')
      ->where('l.listed_by is not null')
      ->addWhere('r.status in (?)', array(10))
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $requestCancelledBySystem = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->where('l.listed_by is not null')
      ->addWhere('r.status in (?)', array(6))
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $requestWithReview = Doctrine::getTable('Request')
      ->createQuery('r')
      ->innerJoin('r.Listing l')
      ->innerJoin('r.Review rr')
      ->where('l.listed_by is not null')
      ->orderBy('id desc')
      ->limit(1)
      ->fetchOne();

    $request->get('Driver')->set('activation_code', '987612');
    $request->get('Driver')->set('new_email_confirm', '987612');
    $request->get('Listing')->get('Owner')->set('require_bond', (bool) $options['is_agent']);
    $request->get('Listing')->get('Owner')->set('bond_amount', 75);

    $event = new sfEvent($request, 'my.name');

    $templates = array(
      array(
        'callable' => array(new RequestNotificationEmail($request), 'send'),
        'data' => array('expiring-request', $request->get('Listing')->getNewRequestContact()->getEmailToParams())
      ),
      array(
        'callable' => array(new PaymentsForm(), 'sendRefundNotification'), // refund
        'data' => $request
      ),
      array(
        'callable' => array(new PaymentsForm(), 'sendNoRefundNotification'),// no_refund
        'data' => $request
      ),
      array(
        'callable' => array(new ChargeFeeForm(), 'sendNotificationEmail'), // charge fee
        'data' => $request
      ),
      array(
        'callable' => array('Transfercar\Event\RelocationReviewEvent', 'listenToReviewReplied'),
        'data' => new sfEvent($requestWithReview->get('Review'), 'review.replied.')
      ),
      array(
        'callable' => array('Transfercar\Event\RelocationReviewEvent', 'listenToReviewCreated'),
        'data' => new sfEvent($requestWithReview->get('Review'), 'review.created.')
      ),
      array(
        'callable' => array('Transfercar\Event\RelocationReviewEvent', 'listenToReviewReported'),
        'data' => new sfEvent($requestWithReview->get('Review'), 'review.reported.', array('message' => 'Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet. Lorem ipsum dolor sit amet.'))
      ),
      array(
        'callable' => array('RequestCancelledEmails', 'notify'),
        'data' => new sfEvent($requestCancelledByRo, 'by.ro')
      ),
      array(
        'callable' => array('RequestCancelledEmails', 'notify'),
        'data' => new sfEvent($requestCancelledByDriver, 'by.driver')
      ),
      array(
        'callable' => array('RequestCancelledEmails', 'notify'),
        'data' => new sfEvent($bookingCancelledByDriver, 'by.driver')
      ),
      array(
        'callable' => array('RelocationConfirmedEmail', 'notify'),
        'data' => new sfEvent($request->get('Listing'), 'reloc.confirmed')
      ),
      array(
        'callable' => array('RelocationAcceptedEmail', 'notify'),
        'data' => $request
      ),
      array(
        'callable' => array('RelocationAcceptedEmail', 'notifyRo'),
        'data' => $event
      ),
      array(
        'callable' => array('tcEmailNotificationEvents', 'listenToSomeElseAccepted'),
        'data' => $event
      ),
      array(
        'callable' => array('tcEmailNotificationEvents', 'listenToRequestCancelled'),
        'data' => new sfEvent($requestCancelledBySystem, 'by.sys') // Request::STATUS_CANCELED
      ),
      array(
        'callable' => array('tcEmailNotificationEvents', 'listenToRequestRejected'),
        'data' => $event
      ),
      array(
        'callable' => array('tcEmailNotificationEvents', 'listenToRequestExpired'),
        'data' => $event
      ),
      array(
        'callable' => array('tcEmailNotificationEvents', 'listenToRequestRated'),
        'data' => new sfEvent($ratedRequest, 'req.rated')
      ),
        array(
          'callable' => array('RegistrationFormHandler', 'sendWelcomeEmail'),
          'data'  => $request->get('Driver')
        ),
      array(
        'callable' => array(new emailChangeForm(), 'sendConfirmationEmail'),
        'data' => $request->get('Driver')
      ),
      array(
        'callable' => array(new forgotPasswordForm(), 'sendPasswordEmail'),
        'data' => [$request->get('Driver'), '123456']
      ),
      array(
        'callable' => array($request->get('Listing'), 'notifyAboutNewRequest'),
        'data' => $request
      ),
    );

    foreach ($templates as $template) {
      if (!is_callable($template['callable'])) {
        throw new Exception("not callable ".print_r($template['callable'], 1), 1);
      }

      if (is_array($template['data'])) {
        call_user_func_array($template['callable'], $template['data']);
      } else {
        call_user_func($template['callable'], $template['data']);
      }
    }

    $this->log(count($templates));
  }
}
