<?php

use Transfercar\Ranking\SearchScore;

class transfercarUpdatescoresTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'update-scores';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:update-scores|INFO] task does things.
Call it with:

  [php symfony transfercar:update-scores|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $listings = Doctrine::getTable('Listing')
      ->createQuery('l')
      ->where('l.created_at > ?', '2019-01-01')
     // ->addWhere('(l.score is null or l.score = 1 or l.score_debug is null)')
      ->addWhere('(l.status = 0 or l.status=5)')
      ->addWhere('l.owner_id=?', 17410)
      ->execute();

    $score = new SearchScore();
    foreach ($listings as $listing) {
      $listingScore = $score->getScore($listing);
      $this->logSection('score', sprintf('%s: %s', $listing->getId(), $listingScore));
      $this->logSection('score', sprintf('%s: %s', $listing->getId(), $score->debug));
      $listing->set('score', $listingScore);
      $listing->set('score_debug', $score->debug);
      $listing->save();
    }

  }
}
