<?php

class transfercarUpgradecmsmetaTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'upgrade-cms-meta';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:upgrade-cms-meta|INFO] task does things.
Call it with:

  [php symfony transfercar:upgrade-cms-meta|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $pages = Doctrine::getTable('CMSPage')->findAll();
    // add code here

    foreach ($pages as $page) {
      $this->createMeta($page);
    }
  }

  private function createMeta(CMSPage $page)
  {
    $page->get('HeadElements')->delete();
    foreach(array('meta_title', 'meta_description', 'og_title', 'og_description', 'og_sitename', 'og_image') as $name)
    {
      $metaName = str_replace(array('meta_', '_'), array('', ':'), $name);

      $meta = new CMSPageHeadElement();
      $meta->set('type', 'meta');
      $meta->set('name', $metaName == 'og:sitename' ? 'og:site_name' : $metaName);
      $meta->set('properties', array('content' => $page->get($name)));
      $meta->set('Page', $page);

      $page->get('HeadElements')->add($meta);
    }

    $page->save();
  }
}