<?php

class transfercarUpgradevehicletypesTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'upgrade-vehicle-types';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:upgrade-vehicle-types|INFO] task does things.
Call it with:

  [php symfony transfercar:upgrade-vehicle-types|INFO]
EOF;
    $this->addArgument('application', sfCommandArgument::REQUIRED, 'The application name');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    error_reporting(E_ALL);
    ini_set('display_errors', true);
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);
    $vehicleTypes = Doctrine::getTable('VehicleType')->findAll();
    $conn = Doctrine_Manager::getInstance()->getConnection('doctrine');



    $updateListingQuery =  'UPDATE listing l INNER JOIN locations loc on l.pickup_location_id=loc.id'
                          .' INNER JOIN location_category lc ON loc.category_id=lc.id'
                          .' SET l.vehicle_type_id = ?'
                          .' WHERE lc.country_id = ?'
                          .' AND l.vehicle_type_id = ?';

    $updateListingQuery = $conn->getDbh()->prepare($updateListingQuery);

    $updateListingROQuery = 'UPDATE listing l INNER JOIN locations loc on l.pickup_location_id=loc.id'
                          . ' INNER JOIN location_category lc ON loc.category_id=lc.id'
                          . ' SET l.owner_vehicle_type_id = ?'
                          . ' WHERE lc.country_id = ?'
                          . ' AND l.owner_vehicle_type_id = ?';

    $updateListingROQuery = $conn->getDbh()->prepare($updateListingROQuery);

    $updateSnapshotsQuery = 'UPDATE request r'
                          . ' INNER JOIN listing l'
                          . ' INNER JOIN locations loc ON l.pickup_location_id=loc.id'
                          . ' INNER JOIN location_category lc ON loc.category_id=lc.id'
                          . ' SET r.listing_data = REPLACE(r.listing_data, ?, ?)'
                          . ' WHERE lc.country_id = ?';

    $updateSnapshotsQuery = $conn->getDbh()->prepare($updateSnapshotsQuery);


    $countries = array('au' => 2, 'us' => 3);


    $conn->prepare('SET AUTOCOMMIT=0')->execute();
    $conn->beginTransaction();
    foreach($vehicleTypes as $vehicleType)
    {
      $vehicleType->set('country_id', 1);
      $vehicleType->set('upselling_price', $vehicleType->get('credits_per_additional_day_nz'));
      $vehicleType->save($conn);
      $roVehicles = $vehicleType->get('OwnerVehicleTypes');

      foreach ($countries as $country => $country_id)
      {
        $dup = $this->duplicate($vehicleType, $country_id, $conn);
        $updateListingQuery->execute(array($dup->getId(), $country_id, $vehicleType->getId()));


        foreach ($roVehicles as $roVehicle)
        {
          $roVehicle->set('country_id', 1);
          $roVehicle->save($conn);

          // duplicate only if RO have multiple countries (only Apollo and testing accounts)
          if ($roVehicle->get('Countries')->count() > 1)
          {
            $rodup = $this->duplicate($roVehicle, $country_id, $conn, $dup);
            $updateListingROQuery->execute(array($rodup->getId(), $country_id, $roVehicle->getId()));
          }
        }
      }
    }

    $conn->commit();
  }

  private function duplicate($vehicleType, $country_id, $conn, $tcdup = null)
  {
    $dup = $vehicleType->copy(false);
    $dup->set('country_id', $country_id);

    if ($tcdup)
    {
      $dup->set('vehicle_type_id', $tcdup->getId());
    }
    else
    {
      switch ($country_id) {
        case 2:
          $dup->set('upselling_price', $vehicleType->get('credits_per_additional_day_au'));
          break;

        case 3:
          $dup->set('upselling_price', 50);
      }
    }

    $dup->save($conn);

    return $dup;
  }
}