<?php

class TcSocialLogin
{
    public static function getClientId($provider)
    {
        switch ($provider) {
            case 'google':
                return '162448195381-dr85l8u4onlaa8ir8snebqsb469atqjj.apps.googleusercontent.com';

            case 'facebook':
                return '762097323908395';


        }
    }

    public static function getClientSecret($provider)
    {
        switch ($provider) {
            case 'google':
                return '_RiHZ_LxoYhDCrduDIQnOgvV';

            case 'facebook':
                return 'd86fc701966d92fafdd5a7f5c034a075';
        }
    }


    public static function signin($request, $user, $provider, $redirect)
    {
        $provider = self::getProvider($provider, $redirect);

        if (!$request->getParameter('code')) {

            // If we don't have an authorization code then get one
            $authUrl = $provider->getAuthorizationUrl();
            $user->setAttribute('oauth2state', $provider->getState());
            $user->setAttribute('oauth2referer', $request->getParameter('referer'));
            $user->shutdown(true);

            header('Location: '.$authUrl);
            exit;

        // Check given state against previously stored one to mitigate CSRF attack
        } elseif (!$request->getParameter('state') || ($request->getParameter('state') !== $user->getAttribute('oauth2state'))) {
            $user->setAttribute('oauth2state', null);
            exit('Invalid state');
        } else {

            // Try to get an access token (using the authorization code grant)
            $token = $provider->getAccessToken('authorization_code', [
                'code' => $request->getParameter('code')
            ]);

            // We got an access token, let's now get the user's details
            $userDetails = $provider->getResourceOwner($token);
            $tcUser = Doctrine::getTable('User')->getOrCreateFromOAuth($userDetails);
            $user->login($tcUser);

            return $user;
        }
    }

    private static function getProvider($provider, $redirect)
    {
        $providerOptions = [
            'clientId'      => self::getClientId($provider),
            'clientSecret'  => self::getClientSecret($provider),
            'scopes'        => ['email'],
            'redirectUri'   => $redirect
        ];

        switch ($provider) {
            case 'google':
                $class = 'League\OAuth2\Client\Provider\Google';
                break;

            case 'facebook':
                $class = 'League\OAuth2\Client\Provider\Facebook';
                $providerOptions['graphApiVersion'] = 'v2.2';
                break;

            default:
                throw new Exception("Invalid provider");

        }

        return new $class($providerOptions);
    }
}