<?php

class tcAdvertiserSigninValidator extends sfValidatorBase
{
    public function configure($options = array(), $messages = array())
    {
        $this->addMessage('invalid', 'Login failed');
    }

    /*
     * All required data will be taken from request parameter "login[]"
     */
    public function doClean($values)
    {
        $object = Doctrine_Query::create()
            ->from('Advertiser')
            ->where('username = ?', $values['user'])
            ->fetchOne();

        if ($object)
        {
            if ($object->checkPassword($values['password']))
            {
                $values['user'] = $object;
                return $values;
            }
        }

        $error = new sfValidatorError($this, 'invalid', array('values' => $values));

        throw new sfValidatorErrorSchema($this, array('user' => $error));
    }
}