<?php
/**
 * Compare dates in listing form - return-by date cannot be
 * lower than availability date
 */
class myValidatorDatesInListing extends sfValidatorBase
{
    /**
     * Set validator error message
     */
    protected function configure($options = array(), $messages = array())
    {
        $this->addMessage('invalid', 'Return date cannot be earlier than availability date');
    }
    /**
     * Validate data
     * 
     * @param string $value not used here
     */
    protected function doClean($value)
    {
        // Get all needed data from sfWebRequest object
        $listing = sfContext::getInstance()->getRequest()
            ->getParameter('listing');
        
        $from = strtotime($listing['date_available_from']);
        $to = strtotime($listing['date_return_by']);
        
        // Make validation
        if($to < $from){
            throw new sfValidatorError($this, 'invalid', array('value' => $value));
        }
        
        return $value;
    }
}
