<?php
/**
 * Validate e-mail address given in "forgot password" form
 */
class myValidatorForgotPassword extends sfValidatorEmail
{
    public function configure($options = array(), $messages = array())
    {
        // Add specific messages
        $this->addMessage('invalid', 'Wrong e-mail');
        $this->addMessage('blocked', 'User has been blocked');
        $this->addMessage('inactive', 'This account is inactive, please contact Transfercar support');

        return parent::configure($options, $messages);
    }

    /// Make validation
    public function doClean($value)
    {
        $value = strtolower($value);
        $value = parent::doClean($value);

        // Check if we have registered user with that e-mail address
        $user = Doctrine_Query::create()
            ->from('User')
            ->where('LOWER(email) = ?', $value)
            ->fetchOne();

        // We haven't such user?
        if(!is_object($user)){
            throw new sfValidatorError($this, 'invalid', array('value' => $value));
        }

        // Check if user is presently in blocked state
        if($user->user_status == 'inactive'){
            throw new sfValidatorError($this, 'inactive', array('value' => $value));
        }

        return $value; // Everything is OK
    }
}
