<?php
/*
 * Validate confirmation code
 */
class myValidatorJoinConfirmCode extends sfValidatorBase
{   
    public function configure($options = array(), $messages = array())
    {
        $this->addMessage('invalid', 'This code is invalid');
        return;
    }
        
    public function doClean($value)
    {
        // User ID is stored as session attribute
        $uid = intval(sfContext::getInstance()->getUser()
            ->getAttribute('new_user_id'));
        
        $value = intval($value);
        
        // Find if desired user with given code exists
        $count = Doctrine_Query::create()
            ->from('User')
            ->where('id = ? AND activation_code = ?', array($uid, $value))
            ->addWhere('username IS NULL') // user not registered yet
            ->count();
            
        if($count == 0){
            throw new sfValidatorError($this, 'invalid',
                array('value' => $value));
        }
        
        // Everything is OK
        return $value;
    }
}
?>