<?php
/**
 * Validate data from sign in form
 */
class myValidatorSignIn extends sfValidatorBase
{
    public function configure($options = array(), $messages = array())
    {
        $this->addMessage('invalid', 'Login failed');
    }

    /*
     * All required data will be taken from request parameter "login[]"
     */
    public function doClean($values)
    {
        // Check if requested user exists
        $object = Doctrine_Query::create()
            ->from('User')
            ->where('(username = ? or email = ?)', array($values['user'], $values['user']))
            ->addWhere('(user_status = ? OR user_status = ? OR user_status = ?)', array('active', 'subscribe', 'blocked'))
            ->fetchOne();

        if ($object)
        {
            if ($object->checkPassword(sha1($values['password'])))
            {
                return $values;
            }
        }

        $error = new sfValidatorError($this, 'invalid', array('values' => $values));

        throw new sfValidatorErrorSchema($this, array('user' => $error));
    }
}
