<?php
/**
 * Validate entered value with current user password.
 *
 * @package transfercar
 * @subpackage form
 */
class myValidatorUserPassword extends sfValidatorBase
{
    public function configure($options = array(), $messages = array())
    {
        // Add specific messages
        $this->addMessage('invalid', 'Password invalid');
    }

    // Validate
    public function doClean($value)
    {
        if (!$user = $this->getOption('user')) {
            $user = sfContext::getInstance()->getUser()->getAttribute('profile');
        }

        if(!is_object($user) || !$user->checkPassword(sha1($value))){
            throw new sfValidatorError($this, 'invalid', array('value' => $value));
        }

        return $value;
    }
}
