<?php
/**
 * Check if given username is unique
 * 
 * @package transfercar
 * @subpackage backend
 */
class myValidatorUsernameUnique extends sfValidatorBase
{
    /**
     * Configure validator
     * 
     * @param array $options Validator options
     * @param array $messages Error messages
     * 
     * @see sfValidatorBase
     */
    public function configure($options = array(), $messages = array())
    {
        $this->addOption('ignore_id', 0); // Should we ignore some record from DB?
    }
    
    /**
     * Make validation
     *
     * @param mixed $value validated data
     * @return mixed Input value
     * 
     * @see sfValidatorBase
     */
    public function doClean($value)
    {
        $username = strtolower($value);
        $ignore_id = intval($this->getOption('ignore_id'));
        
        // Check record presence
        $count = Doctrine_Query::create()
            ->from('User')
            ->where('LOWER(username) = ?', $username)
            ->addWhere('id != ?', $ignore_id)
            ->count();
            
        if($count > 0){ // username reserved
            throw new sfValidatorError($this, 'invalid', array('value' => $value));
        }
        
        return $value;
    }
}