<?php
/**
 * We will use validator object in order to secure input data
 * against XSS forgery
 *
 * @package transfercar
 * @subpackage validator
 */
class myValidatorXSSCleaner extends sfValidatorBase
{
    /**
     * Configure validator
     *
     * @param array $options Validator options
     * @param array $messages Error messages
     *
     * @see sfValidatorBase
     */
    public function configure($options = array(), $messages = array())
    {
        $this->addOption('allowed_tags', array('i', 'u', 'b', 'p'));
    }

    /**
     * Make validation
     *
     * @param mixed $value validated data
     * @return mixed Input value
     *
     * @see sfValidatorBase
     */
    public function doClean($value)
    {
        sfLoader::loadHelpers(array('XSS'));
        $cleaned = xss_cleanup($value, $this->getOption('allowed_tags'));
        return $cleaned;
    }
}
