<?php

class tcValidatorRentalBranch extends sfValidatorBase
{
    public function configure($options = array(), $messages = array())
    {
        $this->addRequiredOption('user');
    }

    protected function doClean($values)
    {
        if (!is_array($values)) {
            throw new sfValidatorError($this, 'invalid');
        }
        $objects = [];
        foreach ($values as $key => $value) {
            # code...
        
            if (strpos($value, '_') === false) {
                throw new sfValidatorError($this, 'invalid');
            }

            list($type, $id) = explode('_', $value);

            $model = $type === 'tc' ? 'Locations' : 'OwnerBranch';

            $validator = new sfValidatorDoctrineChoice(array(
                'model' => $model,
                'query' => $this->getQueryFor($model, $this->getOption('user'))
            ));

            $value = $validator->clean($id);
            $objects[] = Doctrine::getTable($model)->find($value);
        }

        return $objects;
    }

    private function getQueryFor($model, $user)
    {
        $query = Doctrine::getTable($model)
                ->createQuery();

        if ('OwnerBranch' === $model)
        {
            $query->addWhere('owner_id = ?', $user->getOwnerId());
        }

        return $query;
    }
}