<?php

class tcValidatorVehicleType extends sfValidatorBase
{
    public function configure($options = array(), $attributes = array())
    {
        $this->addRequiredOption('user');
    }

    protected function doClean($value)
    {
        if (strpos($value, '_') === false) {
            throw new sfValidatorError($this, 'invalid');
        }

        list($type, $id) = explode('_', $value);

        $model = $type === 'tc' ? 'VehicleType' : 'OwnerVehicleType';

        $validator = new sfValidatorDoctrineChoice(array(
            'model' => $model,
            'query' => $this->getQueryFor($model, $this->getOption('user'))
        ));

        $value = $validator->clean($id);

        $object = Doctrine::getTable($model)->find($value);

        return $object;
    }

    private function getQueryFor($model, $user)
    {
        $query = Doctrine::getTable($model)
                ->createQuery();

        if ('OwnerVehicleType' === $model)
        {
            $query->addWhere('owner_id = ?', $user->getOwnerId());
        }

        return $query;
    }
}