<?php
/**
 * Compares locations
 * 
 * @package transfercar
 * @subpackage form 
 */
class sfValidatorLocation extends sfValidatorBase
{
  public function configure($options = array(), $messages = array())
  {
    $this->addOption('required_location', true);
    $this->addMessage('invalid', 'Location is invalid');
    $this->addMessage('required_location', 'Please select location');
  }
  
  protected function doClean($value)
  {
    $categoryOptions = array_keys(sfWidgetFormLocation::getCategories());
    if ($this->getOption('required')) {
      if (empty($value['category'])) {
        throw new sfValidatorError($this, 'required', array('value' => $value));
      }
    }
    
    if (!empty($value['category']) && !in_array($value['category'], $categoryOptions)) {
      throw new sfValidatorError($this, 'invalid', array('value' => $value));
    }
    
    $locationOptions = array_keys(sfWidgetFormLocation::getLocations());
    
    if ($this->getOption('required_location')) {
      if (empty($value['location'])) {
        throw new sfValidatorError($this, 'required_location', array('value' => $value));
      }
    }
    
    if (!empty($value['location']) && !in_array($value['location'], $locationOptions)) {
      throw new sfValidatorError($this, 'invalid', array('value' => $value));
    }
    
    return $value;
  }
}
?>