<?php
/**
 * Compares dates
 * 
 * @package transfercar
 * @subpackage form 
 */
class sfValidatorLocationsCompare extends sfValidatorSchemaCompare
{

  public function __construct($leftField, $rightField, $options = array(), $messages = array())
  {
    parent::__construct($leftField, 'not_equal', $rightField, $options, $messages);
  }
  
  public function configure($options = array(), $messages = array())
  {
    
  }
  
  protected function doClean($values)
  {
    if (is_null($values))
    {
      $values = array();
    }

    if (!is_array($values))
    {
      throw new InvalidArgumentException('You must pass an array parameter to the clean() method');
    }

    $leftValue  = isset($values[$this->getOption('left_field')]) ? $values[$this->getOption('left_field')] : null;
    $rightValue = isset($values[$this->getOption('right_field')]) ? $values[$this->getOption('right_field')] : null;

    $valid = $leftValue['location'] != $rightValue['location'];

    if (!$valid)
    {
      $error = new sfValidatorError($this, 'invalid', array(
        'left_field'  => $leftValue,
        'right_field' => $rightValue,
      ));
      if ($this->getOption('throw_global_error'))
      {
        throw $error;
      }

      throw new sfValidatorErrorSchema($this, array($this->getOption('left_field') => $error));
    }

    return $values;
  }
}
?>