<?php

class sfValidatorPostDriverListing extends sfValidatorSchema
{
  public function doClean($values)
  {
    $compareDate = new sfValidatorDateCompare('date_to', 'greater_than_equal', 'date_from', array(), array(
      'invalid' => 'To date must be greater or equal from date'
    ));
    $compareLocations = new sfValidatorLocationsCompare('pickup', 'dropoff', array('throw_global_error' => true), array(
      'invalid' => 'Pickup and dropoff locations cannot be equal'
    ));
    $compareDate->doClean($values);
    $compareLocations->doClean($values);
    
    
    $clean = array(
      'pickup_location_id'  => $values["pickup"]["location"],
      'dropoff_location_id' => $values["dropoff"]["location"],
    );
    
    unset($values['pickup']);
    unset($values['dropoff']);
    
    $clean = array_merge($clean, $values);
    
    return $clean;
  }
}