<?php

class tcValidatorPaidDays extends sfValidatorBase
{
    protected function configure($options = array(), $messages = array())
    {
        $this->setMessage('invalid', 'You must type in the number of allowed days and the price per day');
    }
    public function doClean($values)
    {
        $paidDays = isset($values['paid_days_allowed']) ? $values['paid_days_allowed'] : false;
        $price = isset($values['price_per_day']) ? $values['price_per_day'] : false;

        // price and days or wether both full or empty
        if (($price && $paidDays) || (!$price && !$paidDays))
        {
            return $values;
        }

        $field = 'price_per_day';

        if ($price && !$paidDays) {
            $field = 'paid_days_allowed';
        }

        $error = new sfValidatorError($this, 'invalid');
        throw new sfValidatorErrorSchema($this, array($field => $error));
    }
}