<?php
/**
 * Implements date choose with calendar picker
 *
 * @package transfercar
 * @subpackage form
 */
class myWidgetFormDateWithPicker extends sfWidgetForm
{
    /**
     * Constructor
     *
     * @param array $options An array of options
     * @param array $attributes An array of default HTML attributes
     */
    protected function configure($options = array(), $attributes = array())
    {
        $this->setOption('is_hidden', false);
        $this->addOption('picker_name', 'Calendar');
    }

    /**
     * Return widget HTML representation
     *
     * @param string $namen Element name
     * @param string $value Displayed value
     * @param array $attributes Additional HTML attributes
     * @param array $errors Element errors
     *
     * @return string Widget HTML representation
     */
    public function render($name, $value = null, $attributes = array(), $errors = array())
    {
        $result = '';

        if($value === null){
            $value = date('d-m-Y');
        }

        // First, display input box
        $result .= $this->renderTag('input', array_merge(array('type' => 'text',
            'value' => $value, 'name' => $name, 'style' => 'width: 100px',),
            $attributes));

        $result .= ' ';

        // Generate ID from given name
        $id = $name;
        $id = str_replace('[', '_', $id);
        $id = str_replace(']', '', $id);

        // Generate button ID
        $btn_id = $id.'_btn';

        // Add button
        $result .= '<button class="calendar_button" type="button" id="'.$btn_id.'" onclick="return false;"></button>';

        // Init calendar picker
        $result .= '<script type="text/javascript" language="JavaScript">';
        $result .= "\n// <!--\n";

        $result .= 'Calendar.setup({inputField: "'.$id.'",'.
            'ifFormat: "%d-%m-%Y", '.
            'firstDay: 1, '.
            'range: ['.date('Y').', '.(date('Y') + 5).'], '.
            'step: 1, '.
            'button: "'.$btn_id.'", '.
            'showOthers: true'.
            '})';

        $result .= "\n// -->\n";
        $result .= '</script>';

        return $result;
    }
}