<?php

class tcWidgetFormOwnerBranch extends sfWidgetFormSelect
{
    public function __construct($options = array(), $attributes = array())
    {
        $options['choices'] = new sfCallable(array($this, 'getChoices'));

        parent::__construct($options, $attributes);
    }

    public function configure($options = array(), $attributes = array())
    {
        $this->addRequiredOption('user');
        $this->addRequiredOption('country');
        $this->addOption('empty_choice', '');

        parent::configure($options, $attributes);
    }

    public function getChoices()
    {
        $user = $this->getOption('user');
        $country = $this->getOption('country');

        $choices = array('' => $this->getOption('empty_choice'));

        if (count($ownerbranches = Doctrine::getTable('OwnerBranch')->getTypesList($user, $country)))
        {
            $ownerbranches = $this->addPrefix($ownerbranches, 'owner_');

            $choices['Select branch'] = $ownerbranches;
        }

        $choices['Standard locations'] = Doctrine::getTable('Locations')->findNestedByCategory($country, 'tc_');

        return $choices;
    }

    public function addPrefix($array, $prefix)
    {
        $newArray = array();

        foreach ($array as $key => $value)
        {
            $newArray[$prefix.$key] = $value;
        }

        return $newArray;
    }
}
