<?php

class tcWidgetFormOwnerVehicle extends sfWidgetFormSelect
{
    public function __construct($options = array(), $attributes = array())
    {
        $options['choices'] = new sfCallable(array($this, 'getChoices'));

        parent::__construct($options, $attributes);
    }

    public function configure($options = array(), $attributes = array())
    {
        $this->addRequiredOption('user');
        $this->addRequiredOption('country');
        $this->addOption('empty_choice', '');
        $this->addOption('tc_vehicles', true);

        parent::configure($options, $attributes);
    }

    public function getChoices()
    {
        $user = $this->getOption('user');
        $country = $this->getOption('country');

        $choices = array('' => $this->getOption('empty_choice'));

        if (count($ownervehicles = Doctrine::getTable('OwnerVehicleType')->getTypesList($user, $country)))
        {
            $choices[sprintf('%s vehicles', $user->getCompany())] = $this->addPrefix($ownervehicles, 'owner_');
        }

        if ($this->getOption('tc_vehicles')) 
        {
            $vehicles = $this->addPrefix(VehicleType::typeList($country), 'tc_');
            $choices['Standard categories'] = $vehicles;
        }

        return $choices;
    }

    public function addPrefix($array, $prefix)
    {
        $newArray = array();

        foreach ($array as $key => $value)
        {
            $newArray[$prefix.$key] = $value;
        }

        return $newArray;
    }
}