<?php

/**
 * sfWidgetFormAddon represents a single addone - name of product and price
 *
 * @package    transfercar
 * @subpackage widget
 * @author     Bartosz Pasinski <bartosz.pasinski@planetsoft.pl>
 */

class sfWidgetFormAddon extends sfWidgetForm
{
  protected function configure($options = array(), $attributes = array())
  {

  }

  public function render($name, $value = null, $attributes = array(), $errors = array())
  {
    $result = '';
    $productName  = new sfWidgetFormInput();
    $productPrice = new sfWidgetFormInput(array(), array('pattern' => '^\d*(\.\d{2}$)?', 'title' => 'no dollar sign and no comma(s) - cents (.##) are optional'));
    $attributes["name"]["size"] = 40;
    $attributes["price"]["size"] = 4;
    if(!isset($value['price'])) $value['price'] = '';
    if(!isset($value['name'])) $value['name'] = '';

    $result .= '<td>' . $productName->render($name . "[name]", $value["name"], $attributes["name"], array()) . '</td>';
    $result .= '<td>' . $productPrice->render($name . "[price]", $value["price"], $attributes["price"], array()) . '</td>';
    $result .= '<td>';
    if(!empty($errors)) {
      $result .= '<ul class="error">';
      foreach($errors as $error) {
        $result .= "<li>$error</li>";
      }
      $result .= '</ul>';
    }
    $result .= '</td>';
    return $result;
  }
}

?>