<?php

/**
 * sfWidgetFormAddon represents a single addone - name of product and price
 *
 * @package    transfercar
 * @subpackage widget
 * @author     Bartosz Pasinski <bartosz.pasinski@planetsoft.pl>
 */

class sfWidgetFormOwnerAddon extends sfWidgetForm
{
  protected function configure($options = array(), $attributes = array())
  {

  }

  public function render($name, $value = null, $attributes = array(), $errors = array())
  {
    $result = '';
    $productName    = new sfWidgetFormInput();
    $productPrice   = new sfWidgetFormInput();
    $productPeriods = new sfWidgetFormChoice(array(
      'choices' => Addon::getPeriods()
    ));

    $attributes["name"]["size"] = 40;
    $attributes["price"]["size"] = 4;
    if(!isset($value['price'])) $value['price'] = '';
    if(!isset($value['name'])) $value['name'] = '';
    if(!isset($value['period'])) $value['period'] = '';

    $result .= '<div class="six columns">' . $productName->render($name . "[name]", $value["name"], $attributes["name"], array()) . '</div>';
    $result .= '<div class="two columns">' . $productPrice->render($name . "[price]", $value["price"], $attributes["price"], array()) . '</div>';
    $result .= '<div class="two columns end">' . $productPeriods->render($name . "[period]", $value["period"], array(), array()) . '</div>';

    return $result;
  }
}
