<?php

class sfWidgetFormatter extends sfWidgetFormSchemaFormatter
{
  protected
    $rowFormat             = "<tr>\n  <th>%label%</th>\n  <td>%field%%help%%hidden_fields%</td>\n  <td>%error%</td>\n</tr>\n",
    $errorRowFormat        = "<tr><td colspan=\"3\">\n%errors%</td></tr>\n",
    $helpFormat            = '<br />%help%',
    $decoratorFormat       = "<table>\n  %content%</table>",
    $errorListFormatInARow = "  <ul class=\"error_list\">\n%errors%  </ul>\n",
    $errorRowFormatInARow  = "    <li>%error%</li>\n";
	
  public function formatRow($label, $field, $errors = array(), $help = '', $hiddenFields = null)
  {
	if(!empty($errors)) {
	  $this->rowFormat = "<tr>\n  <td class=\"label\">%label%</td>\n  <td class=\"error\">%field%%help%%hidden_fields%</td>\n  <td>%error%</td>\n</tr>\n";
	} else {
	  $this->rowFormat = "<tr>\n  <td class=\"label\">%label%</td>\n  <td>%field%%help%%hidden_fields%</td>\n  <td>%error%</td>\n</tr>\n";
	}
    return strtr($this->getRowFormat(), array(
      '%label%'         => $label,
      '%field%'         => $field,
      '%error%'         => $this->formatErrorsForRow($errors),
      '%help%'          => $this->formatHelp($help),
      '%hidden_fields%' => is_null($hiddenFields) ? '%hidden_fields%' : $hiddenFields,
    ));
  }
}

?>