<?php

class tcWidgetFormAutocomplete extends sfWidgetFormInput
{
    protected function configure($options = array(), $attributes = array())
    {
        parent::configure($options, $attributes);
        $this->addRequiredOption('url');
    }

    public function render($name, $value = null, $attributes = array(), $errors = array())
    {
        $input = parent::render($name, $value, $attributes, $errors);

        $id = $this->generateId($name);

        $script = <<<EOF
<script type="text/javascript">
//<![CDATA[
new Ajax.Autocompleter('%s', '%s_auto_complete', '%s', {});
//]]>
</script>
EOF;

        $input .= $this->renderContentTag('div', null, array('id' => $id.'_auto_complete', 'class' => 'auto_complete'));
        $input .= sprintf($script, $id, $id, $this->getOption('url'));

        return $input;


// <input type="text" name="payment[username]" value="" id="payment_username" /><div id="payment_username_auto_complete" class="auto_complete"></div>
    }
}