<?php


class tcGDAdapter extends sfGDAdapter
{
    public function save($thumbnail, $thumbDest, $targetMime = null)
    {

        $cache_dir = dirname($thumbDest);
        // create cache dir if needed
        if (!is_dir($cache_dir))
        {
          $current_umask = umask(0000);
          @mkdir($cache_dir, 0777, true);
          umask($current_umask);
        }

        parent::save($thumbnail, $thumbDest, $targetMime);
    }

    public function loadFile($thumbnail, $image)
    {
        parent::loadFile($thumbnail, $image);
        $this->addFillingBackground($thumbnail);
    }

    public function loadData($thumbnail, $image, $mime)
    {
        parent::loadData($thumbnail, $image, $mime);
        $this->addFillingBackground($thumbnail);
    }

    private function addFillingBackground($thumbnail)
    {
        $final = imagecreatetruecolor($this->maxWidth, $this->maxHeight);
        $backgroundColor = imagecolorallocate($final, 255, 255, 255);
        imagealphablending($final, false);
        imagesavealpha($final, true);
        $transparent = imagecolorallocatealpha($final, 255, 255, 255, 127);
        imagefilledrectangle($final, 0, 0, $this->maxWidth, $this->maxHeight, $transparent);
        imagefill($final, 0, 0, $backgroundColor);
        imagecopy($final, $this->thumb, (($this->maxWidth - $thumbnail->getThumbWidth())/ 2), (($this->maxHeight - $thumbnail->getThumbHeight()) / 2), 0, 0, $thumbnail->getThumbWidth(), $thumbnail->getThumbHeight());

        $this->thumb = $final;
    }
}