<?php

/**
 * Thumbnail actions.
 *
 * @package    jsThumbnail
 * @subpackage jsThumbnailActions
 * @author     Julian Stricker <julian@julianstricker.com>
 * @version
 */
class jsThumbnailActions extends sfActions
{
  /**
   * Output captcha image
   *
   */
  public function executeThumbnail($request)
  {
	  ini_set('error_reporting',E_ALL);
	  error_log(__METHOD__,3,'/tmp/debug.log');
    $imgname = sfConfig::get('sf_web_dir').'/'.$this->getRequestParameter('img');
    $style   = $this->getRequestParameter('style');

    $imgname = file_exists($imgname) ? $imgname : sfConfig::get('app_thumbnail_default_image');

    $config = sfConfig::get('app_thumbnail_styles');

    $this->forward404Unless(isset($config[$style]), 'Style not found');

    $config = array_merge(array(
      'options' => [],
      'mode'    => 'stretch',
    ), $config[$style]);

    // $config['options'] = array_merge($config['options'], $attributes);

    $config['options']['width'] = $config['width'];
    $config['options']['height'] = $config['height'];

    $maxx = $config['width'];
    $maxy = $config['height'];
    $mode = $config['mode'];

    $thumbnail = new sfThumbnail($maxx, $maxy, true, true, 90, 'tcGDAdapter');
    $thumbnail->loadFile($imgname);

    $thumbnail->save(sfConfig::get('sf_web_dir').'/'.$request->getPathInfo());

    $this->getResponse()->setHttpHeader('Cache-Control', 'max-age=0, s-maxage=60, public=true');
    $this->getResponse()->setContentType($thumbnail->getMime());

    return $this->renderText($thumbnail->toString());
  }
}
