<?php

class transfercarRebuildelasticsearchindexTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'rebuild-elastic-search-index';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:rebuild-elastic-search-index|INFO] task does things.
Call it with:

  [php symfony transfercar:rebuild-elastic-search-index|INFO]
EOF;
    $this->addArgument('domain', sfCommandArgument::REQUIRED, 'The domain code');
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $tcElasticaClient = new tcElasticaClient();

    $country = Doctrine::getTable('LocationCountry')->findOneByDomain($arguments['domain']);

    $index = $tcElasticaClient->createIndex($country->get('domain'));
    $listings = Doctrine::getTable('Listing')->getListingsByParams($country->getId(), null, null, null, null, null, null);
    $documents = [];
    foreach ($listings as $listing)
    {
      $listingDocument = new \Elastica\Document($listing->getId(), tcElasticaListing::buildListingDocument($listing));
      $documents[] = $listingDocument;
    }

    $listings = Doctrine::getTable('GhostListing')
      ->createQuery('g')
      ->innerJoin('g.PickupLocation p')
      ->innerJoin('p.Category c')
      ->where('c.country_id = ?', $country->getId())
      ->execute();

    foreach ($listings as $listing)
    {
      $listingDocument = new \Elastica\Document('ghost_'.$listing->getId(), tcElasticaGhostListing::buildGhostListingDocument($listing));
      $documents[] = $listingDocument;
    }

    if (count($documents))
    {
      $index->getType('listing')->addDocuments($documents);
    }

  }
}