<?php if ($listing->isBooked()): ?>
<?php use_helper('Transfercar', 'Date') ?>
<?php $showgmap = isset($showgmap) ? $showgmap : true ?>

<?php
$cssAlert = array(
'color:#34495E',
'padding:16px 45px 16px 30px',
'text-shadow:none',
'background-color:#F8F5F5',
'border:2px solid #EBE9EA',
'font-size:16px',
'line-height:1.53875em',
'-webkit-border-radius:6px',
'-moz-border-radius:6px',
'border-radius:6px',
'margin-bottom:20px',
);
?>

<?php if ($listing->get('Owner')->get('driver_accepted_instructions')): ?>
<h2></h2>
<p>
    <?php echo __('The rental operator for this relocation is') ?> <?php echo $listing->get('Owner')->get('company') ?>.
    <?php echo __('It is important that you follow the instructions below in order to confirm and book this vehicle:') ?>
</p>
<div style="<?php echo implode(';', $cssAlert) ?>">
    <h2 style="font-size: 23.996px;margin-bottom:4px;margin-top:2px">Message from <?php echo $listing->get('Owner')->get('company') ?>:</h2>
    <p>
        <strong><?php echo $listing->get('Owner')->get('driver_accepted_instructions') ?></strong>
    </p>
</div>
<?php endif ?>

<h3><?php echo __('Relocation details') ?></h3>

<table class="twelve">
    <tr>
        <th class="three"><?php echo __('Rental Operator') ?></th>
        <td colspan="2">
            <?php echo $listing->get('Owner')->get('company') ?>
        </td>
    </tr>

    <?php if ($listing->get('Owner')->get('logo')): ?>
        <tr>
            <th><?php echo __('Rental Operator') ?></th>
            <td colspan="2">
                <?php echo image_tag($listing->get('Owner')->get('logo'), array('absolute' => true)) ?>
            </td>
        </tr>
    <?php endif ?>

    <tr>
        <td></td>
        <th><?php echo __('Pickup') ?></th>
        <th><?php echo __('Dropoff') ?></th>
    </tr>

    <?php if ($showgmap && ($data = $request->get('listing_data'))): ?>
        <tr>
            <th><?php echo __('Map') ?></th>
            <td>
                <?php list($lat, $lon) = isset($data['owner_pickup']) ? array($data['owner_pickup']['latitude'], $data['owner_pickup']['longitude']) : array($listing->get('PickupLocation')->get('lat'), $listing->get('PickupLocation')->get('lon')) ?>
                <?php echo gmap_widget($lat, $lon, $listing->get('Pickup')->get('name')) ?>
            </td>
            <td>
                <?php list($lat, $lon) = isset($data['owner_dropoff']) ? array($data['owner_dropoff']['latitude'], $data['owner_dropoff']['longitude']) : array($listing->get('DropoffLocation')->get('lat'), $listing->get('DropoffLocation')->get('lon')) ?>
                <?php echo gmap_widget($lat, $lon, $listing->get('Dropoff')->get('name')) ?>
            </td>
        </tr>
    <?php elseif ($showgmap): ?>
        <tr>
            <th><?php echo __('Map') ?></th>
            <td><?php echo gmap_widget($listing->get('Pickup')->get('latitude'), $listing->get('Pickup')->get('longitude'), $listing->get('Pickup')->get('name')) ?></td>
            <td><?php echo gmap_widget($listing->get('Dropoff')->get('latitude'), $listing->get('Dropoff')->get('longitude'), $listing->get('Dropoff')->get('name')) ?></td>
        </tr>
    <?php endif ?>

    <tr>
        <td colspan="3">
            <?php echo __('Relocations can be returned earlier by arrangement at no charge, however no refund will be provided.') ?>
        </td>
    </tr>

    <tr>
        <th><?php echo __('Contact name') ?></th>
        <td>
            <?php if ($listing->get('owner_pickup_branch_id')): ?>
                <?php echo $listing->get('OwnerPickupBranch')->get('Contact')->get('name') ?>
            <?php elseif ($contact = $listing->get('Owner')->getDefaultContact()): ?>
                <?php echo $contact->get('name') ?>
            <?php else: ?>
                <?php echo $listing->get('Owner')->get('company') ?>
            <?php endif ?>
        </td>
        <td>
            <?php if ($listing->get('owner_dropoff_branch_id')): ?>
                <?php echo $listing->get('OwnerDropoffBranch')->get('Contact')->get('name') ?>
            <?php elseif ($contact = $listing->get('Owner')->getDefaultContact()): ?>
                <?php echo $contact->get('name') ?>
            <?php else: ?>
                <?php echo $listing->get('Owner')->get('company') ?>
            <?php endif ?>
        </td>
    </tr>

    <tr>
        <th><?php echo __('Contact phone') ?></th>
        <td>
            <?php if ($listing->get('owner_pickup_branch_id')): ?>
                <?php echo $listing->get('OwnerPickupBranch')->get('Contact')->get('phone') ?>
            <?php elseif ($contact = $listing->get('Owner')->getDefaultContact()): ?>
                <?php echo $contact->get('phone') ?>
            <?php else: ?>
                <?php echo $listing->get('Owner')->get('contact_phone') ?>
            <?php endif ?>
        </td>
        <td>
            <?php if ($listing->get('owner_dropoff_branch_id')): ?>
                <?php echo $listing->get('OwnerDropoffBranch')->get('Contact')->get('phone') ?>
            <?php elseif ($contact = $listing->get('Owner')->getDefaultContact()): ?>
                <?php echo $contact->get('phone') ?>
            <?php else: ?>
                <?php echo $listing->get('Owner')->get('contact_phone') ?>
            <?php endif ?>
        </td>
    </tr>

    <tr>
        <th><?php echo __('Contact email') ?></th>
        <td>
            <?php if ($listing->get('owner_pickup_branch_id')): ?>
                <?php echo $listing->get('OwnerPickupBranch')->get('Contact')->get('email') ?>
            <?php elseif ($contact = $listing->get('Owner')->getDefaultContact()): ?>
                <?php echo $contact->get('email') ?>
            <?php else: ?>
                <?php echo $listing->get('Owner')->get('email') ?>
            <?php endif ?>
        </td>
        <td>
            <?php if ($listing->get('owner_dropoff_branch_id')): ?>
                <?php echo $listing->get('OwnerDropoffBranch')->get('Contact')->get('email') ?>
            <?php elseif ($contact = $listing->get('Owner')->getDefaultContact()): ?>
                <?php echo $contact->get('email') ?>
            <?php else: ?>
                <?php echo $listing->get('Owner')->get('email') ?>
            <?php endif ?>
        </td>
    </tr>

    <?php if ($data = $request->get('listing_data')): ?>
        <tr>
            <th><?php echo __('Location') ?></th>
            <td>
                <?php echo isset($data['owner_pickup']) ? $data['owner_pickup']['name'] : $listing->get('PickupLocation')->get('name') ?>

                <?php echo isset($data['owner_pickup']) ? '<br/>'.$data['owner_pickup']['address'] : '' ?>
            </td>
            <td>
                <?php echo isset($data['owner_dropoff']) ? $data['owner_dropoff']['name'] : $listing->get('DropoffLocation')->get('name') ?>

                <?php echo isset($data['owner_dropoff']) ? '<br/>'.$data['owner_dropoff']['address'] : '' ?>
            </td>
        </tr>
    <?php else: ?>
        <tr>
            <th><?php echo __('Location') ?></th>
            <td><?php echo $listing->getPickup()->get('name') ?></td>
            <td><?php echo $listing->getDropoff()->get('name') ?></td>
        </tr>
    <?php endif ?>

    <?php if ($data = $request->get('listing_data')): ?>
        <tr>
            <th><?php echo __('Opening hours') ?></th>
            <td><?php echo isset($data['owner_pickup']) ? $data['owner_pickup']['opening_hours'] : 'N/A' ?></td>
            <td><?php echo isset($data['owner_dropoff']) ? $data['owner_dropoff']['opening_hours'] : 'N/A' ?></td>
        </tr>
    <?php else: ?>
        <tr>
            <th><?php echo __('Opening hours') ?></th>
            <?php if ($listing->get('owner_pickup_branch_id')): ?>
                <td><?php echo $listing->getPickup()->get('opening_hours') ?></td>
            <?php else: ?>
                <td><?php echo __('N/A') ?></td>
            <?php endif ?>
            <?php if ($listing->get('owner_dropoff_branch_id')): ?>
                <td><?php echo $listing->getDropoff()->get('opening_hours') ?></td>
            <?php else: ?>
                <td><?php echo __('N/A') ?></td>
            <?php endif ?>
        </tr>
    <?php endif ?>

    <tr>
        <th><?php echo __('Earliest/Latest date') ?></th>
        <td><?php echo ($request->get('pickup_date') !== null && $request->get('pickup_date') !== '') ? tc_format_date($request->get('pickup_date')) : '' ?></td>
        <td><?php echo ($request->get('drop_off_date') !== null && $request->get('drop_off_date') !== '') ? tc_format_date($request->get('drop_off_date')) : '' ?></td>
    </tr>

    <tr>
        <th><?php echo __('Time') ?></th>
        <td>
            <?php echo ($listing->get('pickup_time') !== null && $listing->get('pickup_time') !== '') ? tc_format_date($listing->get('pickup_time'), 'hours') : 'N/A' ?>
            -
            <?php echo ($listing->get('latest_pickup_time') !== null && $listing->get('latest_pickup_time') !== '') ? tc_format_date($listing->get('latest_pickup_time'), 'hours') : 'N/A' ?>
        </td>
        <td>
            <?php echo ($listing->get('dropoff_time') !== null && $listing->get('dropoff_time') !== '') ? tc_format_date($listing->get('dropoff_time'), 'hours') : 'N/A' ?>
            -
            <?php echo ($listing->get('latest_dropoff_time') !== null && $listing->get('latest_dropoff_time') !== '') ? tc_format_date($listing->get('latest_dropoff_time'), 'hours') : 'N/A' ?>
        </td>
    </tr>
    <tr>
        <th><?php echo __('Fuel included') ?></th>
        <td colspan="2"><?php echo $listing->get('petrol_included') ? default_text($listing->get('petrol_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Ferry included') ?></th>
        <td colspan="2"><?php echo $listing->get('ferry_included') ? default_text($listing->get('ferry_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Expenses included') ?></th>
        <td colspan="2"><?php echo $listing->get('expenses_included') ? default_text($listing->get('expenses_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <?php if ($listing->get('InsurancePolicy')->getId()): ?>
        <tr>
            <th><?php echo __('Insurance') ?> <?php echo tooltip('insurance_included') ?></th>
            <td colspan="2">
              <ul style="list-style-type: none;padding:0;">
                <li>
                  <?php echo __('Bond') ?> 
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="A bond is an amount of money frozen on your credit card. Providing there are no additional charges at the end of your rental, the bond will be refunded to the same card."></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('bond') ?></li>
                <li>
                  <?php echo __('Excess') ?>
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="An excess is a contribution you are required to pay towards a claim you make on your car insurance policy"></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('excess') ?></li>
                <li>
                  <?php echo __('Insurance waivers') ?> 
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="A collision damage waiver (CDW) or loss damage waiver (LDW), is optional damage insurance coverage that is available to you when you rent a car."></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('waiver') ?>
                  </li>
              </ul>
            </td>
        </tr>
    <?php else: ?>
    <tr>
        <th><?php echo __('Insurance') ?></th>
        <td colspan="2"><?php echo $listing->get('insurance_included') ? default_text($listing->get('insurance_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <?php endif ?>
    <tr>
        <th><?php echo __('Road tolls included') ?></th>
        <td colspan="2"><?php echo $listing->get('tolls_included') ? default_text($listing->get('tolls_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Kms allowed') ?></th>
        <td colspan="2"><?php echo $listing->get('kms_allowed') ?>&nbsp;</td>
    </tr>
    <tr>
        <th><?php echo __('No. of free days') ?></th>
        <td colspan="2"><?php echo $request->get('nb_free_days') ?>&nbsp;</td>
    </tr>
    <tr>
        <th><?php echo __('No. of paid days') ?></th>
        <td colspan="2"><?php echo $request->get('nb_paid_days') ?>&nbsp;</td>
    </tr>
    <tr>
        <th><?php echo __('Price per paid day') ?></th>
        <td colspan="2">
            <?php if ($listing->get('price_per_day')): ?>
                $<?php echo $listing->get('price_per_day') ?> <?php echo strtoupper($listing->get('PickupLocation')->get('Category')->get('Country')->get('domain')) ?>D
            <?php endif ?>
        </td>
    </tr>
    <tr>
        <th><?php echo __('Rental operator comment') ?></th>
        <td colspan="2"><?php echo default_text($listing->get('comment'), 'N/A') ?></td>
    <tr>
        <th><?php echo __('Request ID') ?></th>
        <td colspan="2"><?php echo $request->getIncrementedId() ?></td>
    </tr>
    <tr>
        <th><?php echo __('Request date') ?></th>
        <td colspan="2"><?php echo format_date($request->get('created_at'), 'p') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Request status') ?></th>
        <td colspan="2"><?php echo $request->getStatusName() ?></td>
    </tr>
</table>
<?php else: ?>
    <?php echo __('Not booked yet') ?>
<?php endif ?>