<?php use_helper('Transfercar') ?>
<?php $isBooked = isset($isBooked) ? $isBooked : false ?>
<div class="row">
    <div class="col-md-7 col-12">
        <h3><?php echo __('Pickup branch') ?></h3>
        <table class="table tables-tc">

            <?php if ($isBooked && $data = $request->get('listing_data')): ?>
                <tr>
                    <th><?php echo __('Location') ?></th>
                    <td><?php echo isset($data['owner_pickup']) ? $data['owner_pickup']['name'] : $listing->get('PickupLocation')->get('name') ?></td>
                </tr>
            <?php else: ?>
                <tr>
                    <th><?php echo __('Location') ?></th>
                    <td><?php echo $listing->getPickupLocation()->get('name') ?></td>
                </tr>
            <?php endif ?>

            <?php if ($isBooked && $data = $request->get('listing_data')): ?>
                <tr>
                    <th><?php echo __('Opening hours') ?></th>
                    <td><?php echo isset($data['owner_pickup']) ? $data['owner_pickup']['opening_hours'] : $listing->get('PickupLocation')->get('opening_hours') ?></td>
                </tr>
            <?php else: ?>
                <tr>
                    <th><?php echo __('Opening hours') ?></th>
                    <?php if ($listing->get('owner_pickup_branch_id')): ?>
                        <td><?php echo $listing->getPickup()->get('opening_hours') ?></td>
                    <?php else: ?>
                        <td>N/A</td>
                    <?php endif ?>
                </tr>
            <?php endif ?>

            <?php if ($isBooked): ?>
                <tr>
                    <th><?php echo __('Pickup date') ?></th>
                    <td><?php echo ($request->get('pickup_date') !== null && $request->get('pickup_date') !== '') ? tc_format_date($request->get('pickup_date')) : '' ?></td>
                </tr>
            <?php endif ?>

            <?php if ($isBooked): ?>
                <tr>
                    <th><?php echo __('Pickup time') ?></th>
                    <td><?php echo ($request->get('pickup_time') !== null && $request->get('pickup_time') !== '') ? tc_format_date($request->get('pickup_time'), 'hours') : '' ?></td>
                </tr>
            <?php endif ?>
        </table>
    </div>
    <div class="col-12 col-md-5 maps">
        <div>
            <img src="<?php echo url_for('listing/staticmap?center='.$listing->get('PickupLocation')->getLatLong()) ?>" />
            <!-- <img src="/images/map_circle_overlay.png" class="layer" /> -->
        </div>
    </div>
    <div class="col-12 col-md-7">
        <h3><?php echo __('Dropoff branch') ?></h3>
        <table class="table tables-tc">
            <?php if ($isBooked && $data = $request->get('listing_data')): ?>
                <tr>
                    <th><?php echo __('Location') ?></th>
                    <td><?php echo isset($data['owner_dropoff']) ? $data['owner_dropoff']['name'] : $listing->get('DropoffLocation')->get('name') ?></td>
                </tr>
            <?php else: ?>
                <tr>
                    <th><?php echo __('Location') ?></th>
                    <td><?php echo $listing->getDropoffLocation()->get('name') ?></td>
                </tr>
            <?php endif ?>

            <?php if ($isBooked && $data = $request->get('listing_data')): ?>
                <tr>
                    <th><?php echo __('Opening hours') ?></th>
                    <td><?php echo isset($data['owner_dropoff']) ? $data['owner_dropoff']['opening_hours'] : $listing->get('DropoffLocation')->get('opening_hours') ?></td>
                </tr>
            <?php else: ?>
                <tr>
                    <th><?php echo __('Opening hours') ?></th>
                    <?php if ($listing->get('owner_dropoff_branch_id')): ?>
                        <td><?php echo $listing->getDropoff()->get('opening_hours') ?></td>
                    <?php else: ?>
                        <td>N/A</td>
                    <?php endif ?>
                </tr>
            <?php endif ?>

            <?php if ($isBooked): ?>
                <tr>
                    <th><?php echo __('Dropoff date') ?></th>
                    <td><?php echo ($request->get('drop_off_date') !== null && $request->get('drop_off_date') !== '') ? tc_format_date($request->get('drop_off_date')) : '' ?></td>
                </tr>
            <?php endif ?>

            <?php if ($isBooked): ?>
                <tr>
                    <th><?php echo __('Dropoff time') ?></th>
                    <td><?php echo ($request->get('dropoff_time') !== null && $request->get('dropoff_time') !== '') ? tc_format_date($request->get('dropoff_time'), 'hours') : '' ?></td>
                </tr>
            <?php endif ?>
        </table>
    </div>
    <div class="col-12 col-md-5 maps">
        <div>
            <img src="<?php echo url_for('listing/staticmap?center='.$listing->get('DropoffLocation')->getLatLong()) ?>" />
            <!-- <img src="/images/map_circle_overlay.png" class="layer" /> -->
        </div>
    </div>
</div>