<?php use_helper('DateForm', 'TransfercarRO') ?>
<?php $word = __('days') ?>
<?php $price = $listing->getIncludedDaysPrice() ? '$'.$listing->getIncludedDaysPrice() : 'Free' ?>
<table class="twelve table tables-tc">
    <?php if ($isBooked): ?>
        <tr>
            <th class="seven text-left"><?php echo __('Kms allowed') ?></th>
            <td class="five text-right"><?php echo format_number_choice('[0] Unlimited|[1,+Inf] %km%',
                array('%km%' => $listing->get('kms_allowed')),
                $listing->get('kms_allowed')) ?>&nbsp;</td>
        </tr>
        <tr>
            <th class="seven text-left"><?php echo ucfirst($price).' '.$word ?> <?php echo __('available') ?></th>
            <td class="five text-right" class="five text-right"><?php echo $request->get('nb_free_days') ?>&nbsp;</td>
        </tr>
        <tr>
            <th class="seven text-left"><?php echo __('Extra days available') ?></th>
            <td class="five text-right" class="five text-right"><?php echo default_text($request->get('nb_paid_days'), 'None') ?></td>
        </tr>
    <?php else: ?>
        <tr>
            <th class="six text-left"><?php echo ucfirst($price).' '.$word ?> <?php echo __('available') ?></th>
            <td class="six text-left"><?php echo $listing->get('days_allowed') ?>&nbsp;</td>
        </tr>
        <tr>
            <th class="six text-left"><?php echo __('Kms allowed') ?></th>
            <td class="six text-left"><?php echo format_number_choice('[0] Unlimited|[1,+Inf] %km%',
                array('%km%' => $listing->get('kms_allowed')),
                $listing->get('kms_allowed')) ?>
                <br/>
                <a style="color: #27ae60;text-decoration: underline;" href="<?php echo url_for('listing/map?id='.$listing->getId()) ?>" class="reveal-ajax"><?php echo __('Estimated route') ?> <?php echo default_text($listing->get('kms_estimated'), $listing->getApproximateDistance()) ?> <?php echo __('kms') ?></a>
            </td>
        </tr>
        <?php if ($listing->get('price_per_day')): ?>
            <tr>
                <th class="six text-left"><?php echo __('Extra days available') ?></th>
                <td class="six text-left">
                    <?php echo default_text($listing->get('paid_days_allowed'), 'None') ?>
                   ($<?php echo round($listing->get('price_per_day'), 0) ?> <?php echo __('per extra day') ?>)
                </td>
            </tr>
        <?php endif ?>
    <?php endif ?>


    <?php if ($isBooked): ?>
        <?php if ($listing->get('price_per_day')): ?>
        <tr>
            <th class="seven text-left"><?php echo __('Price per extra day') ?></th>
            <td class="five text-right">
                $<?php echo $listing->get('price_per_day') ?> <?php echo $listing->getCurrency() ?>
            </td>
        </tr>
        <?php endif ?>

        <tr>
            <th class="seven text-left"><?php echo __('Fuel included') ?></th>
            <td class="five text-right"><?php echo $listing->get('petrol_included') ? default_text($listing->get('petrol_included_text'), __('Yes')) : __('No') ?></td>
        </tr>
        <tr>
            <th class="seven text-left"><?php echo __('Ferry included') ?></th>
            <td class="five text-right"><?php echo $listing->get('ferry_included') ? default_text($listing->get('ferry_included_text'), __('Yes')) : __('No') ?></td>
        </tr>
        <tr>
            <th class="seven text-left"><?php echo __('Expenses included') ?></th>
            <td class="five text-right"><?php echo $listing->get('expenses_included') ? default_text($listing->get('expenses_included_text'), __('Yes')) : __('No') ?></td>
        </tr>
        <?php if ($listing->get('InsurancePolicy')->getId()): ?>
        <tr>
            <th class="seven text-left"><?php echo __('Insurance') ?> <?php echo tooltip('insurance_included') ?></th>
            <td class="five text-right">
              <ul style="list-style-type: none;padding:0;">
                <li>
                  <?php echo __('Bond') ?> 
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="A bond is an amount of money frozen on your credit card. Providing there are no additional charges at the end of your rental, the bond will be refunded to the same card."></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('bond') ?></li>
                <li>
                  <?php echo __('Excess') ?>
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="An excess is a contribution you are required to pay towards a claim you make on your car insurance policy"></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('excess') ?></li>
                <li>
                  <?php echo __('Insurance waivers') ?> 
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="A collision damage waiver (CDW) or loss damage waiver (LDW), is optional damage insurance coverage that is available to you when you rent a car."></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('waiver') ?>
                  </li>
              </ul>
            </td>
        </tr>
        <?php else: ?>
        <tr>
            <th class="seven text-left"><?php echo __('Insurance') ?></th>
            <td class="five text-right"><?php echo $listing->get('insurance_included') ? default_text($listing->get('insurance_included_text'), __('Yes')) : __('No') ?></td>
        </tr>
        <?php endif ?>
        <tr>
            <th class="seven text-left"><?php echo __('Road tolls included') ?></th>
            <td class="five text-right"><?php echo $listing->get('tolls_included') ? default_text($listing->get('tolls_included_text'), __('Yes')) : __('No') ?></td>
        </tr>
    <?php endif ?>
</table>
