<?php use_helper('Date') ?>
<h3>Reference details</h3>
<table class="twelve">
    <tr>
        <th class="three"><?php echo __('Reference code') ?></th>
        <td><?php echo $listing->get('internal_reference') ?></td>
        <th><?php echo __('TCID') ?></th>
        <td><?php echo $listing->getCompoundId() ?></td>
    </tr>
    <tr>
        <th><?php echo __('Listing status') ?></th>
        <td><?php echo __($listing->getStatusName()) ?></td>
        <th><?php echo __('Quantity') ?></th>
        <td><?php echo $listing->get('nb_listings') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Listed date') ?></th>
        <td><?php echo ($listing->get('created_at') !== null && $listing->get('created_at') !== '') ? tc_format_date($listing->get('updated_at')) : '' ?></td>
        <th><?php echo __('Listed by Manager') ?></th>
        <td><?php echo $listing->get('Manager') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Last updated date') ?></th>
        <td><?php echo ($listing->get('updated_at') !== null && $listing->get('updated_at') !== '') ? tc_format_date($listing->get('updated_at')) : '' ?></td>
        <th><?php echo __('Last updated manager') ?></th>
        <td>
            <?php if ($listing->get('admin_id')): ?>
                <?php echo $listing->get('AdminUser')->get('name') ?> at Transfercar as
            <?php endif ?>
            <?php echo $listing->get('updated_by') ? $listing->get('UpdatedByManager') : $listing->get('Manager') ?>
        </td>
    </tr>
    <?php if ($listing->isBooked()): ?>
    <tr>
        <th><?php echo __('Listing dates') ?></th>
        <td><?php echo __('From') ?> <?php echo tc_format_date($listing->get('date_available_from')) ?> <?php echo __('to') ?> <?php echo tc_format_date($listing->get('date_return_by')) ?></td>
        <th><?php echo __('Days') ?></th>
        <td>
            <?php echo format_number_choice('[1] 1 free day |(1,+Inf] %days% free days', array('%days%' => $listing->get('days_allowed')), $listing->get('days_allowed')) ?>
            <?php if ($listing->get('paid_days_allowed')): ?>
                <?php echo __('and') ?>
                <?php echo format_number_choice('[1] 1 day at $%price% |(1,+Inf] %days% days at %price%', array('%days%' => $listing->get('days_allowed'), '%price%' => $listing->get('price_per_day')), $listing->get('days_allowed')) ?>    
            <?php endif ?>

        </td>
    </tr>
    <?php endif ?>
</table>