<?php if ($listing->isBooked()): ?>
<?php use_helper('Transfercar') ?>
<h3>Booking details</h3>
<table class="twelve">
    <tr>
        <td class="three"></td>
        <th><?php echo __('Pickup') ?></th>
        <th><?php echo __('Dropoff') ?></th>
    </tr>
    <?php $request = $listing->getAcceptedRequest(); ?>
    <?php if ($data = $request->get('listing_data')): ?>
        <tr>
            <th><?php echo __('Code') ?></th>
            <td><?php echo isset($data['owner_pickup']) ? default_text($data['owner_pickup']['internal_name'], $data['owner_pickup']['name']) : $listing->get('PickupLocation')->get('name') ?></td>
            <td><?php echo isset($data['owner_dropoff']) ? default_text($data['owner_dropoff']['internal_name'], $data['owner_dropoff']['name']) : $listing->get('DropoffLocation')->get('name') ?></td>
        </tr>
        <tr>
            <th><?php echo __('Name') ?></th>
            <td><?php echo isset($data['owner_pickup']) ? $data['owner_pickup']['name'] : $listing->get('PickupLocation')->get('name') ?></td>
            <td><?php echo isset($data['owner_dropoff']) ? $data['owner_dropoff']['name'] : $listing->get('DropoffLocation')->get('name') ?></td>
        </tr>
    <?php else: ?>
        <tr>
            <th><?php echo __('Code') ?></th>
            <td><?php echo default_text($listing->getPickup()->get('internal_name'), $listing->getPickup()->get('name')) ?></td>
            <td><?php echo default_text($listing->getDropoff()->get('internal_name'), $listing->getDropoff()->get('name')) ?></td>
        </tr>
        <tr>
            <th><?php echo __('Name') ?></th>
            <td><?php echo $listing->getPickup()->get('name') ?></td>
            <td><?php echo $listing->getDropoff()->get('name') ?></td>
        </tr>
    <?php endif ?>

    <tr>
        <th><?php echo __('Date') ?></th>
        <td><?php echo ($request->get('pickup_date') !== null && $request->get('pickup_date') !== '') ? tc_format_date($request->get('pickup_date')) : '' ?></td>
        <td><?php echo ($request->get('drop_off_date') !== null && $request->get('drop_off_date') !== '') ? tc_format_date($request->get('drop_off_date')) : '' ?></td>
    </tr>
    <tr>
        <th><?php echo __('Time') ?></th>
        <td><?php echo ($request->get('pickup_time') !== null && $request->get('pickup_time') !== '') ? tc_format_date($request->get('pickup_time'), 'hours') : '' ?></td>
        <td><?php echo ($request->get('dropoff_time') !== null && $request->get('dropoff_time') !== '') ? tc_format_date($request->get('dropoff_time'), 'hours') : '' ?></td>
    </tr>

    <tr>
        <th><?php echo __('Contact name') ?></th>
        <?php if ($listing->get('owner_pickup_branch_id')): ?>
            <td><?php echo $listing->getPickup()->get('Contact')->get('name') ?></td>
        <?php else: ?>
            <td><?php echo $listing->get('Owner')->get('company') ?></td>
        <?php endif ?>

        <?php if ($listing->get('owner_dropoff_branch_id')): ?>
            <td><?php echo $listing->getDropoff()->get('Contact')->get('name') ?></td>
        <?php else: ?>
            <td><?php echo $listing->get('Owner')->get('company') ?></td>
        <?php endif ?>
    </tr>
    <tr>
        <th><?php echo __('Contact phone') ?></th>
        <?php if ($listing->get('owner_pickup_branch_id')): ?>
            <td><?php echo $listing->getPickup()->get('Contact')->get('phone') ?></td>
        <?php else: ?>
            <td><?php echo $listing->get('Owner')->get('contact_phone') ?></td>
        <?php endif ?>

        <?php if ($listing->get('owner_dropoff_branch_id')): ?>
            <td><?php echo $listing->getDropoff()->get('Contact')->get('phone') ?></td>
        <?php else: ?>
            <td><?php echo $listing->get('Owner')->get('contact_phone') ?></td>
        <?php endif ?>
    </tr>
    <tr>
        <th><?php echo __('Contact email') ?></th>
        <?php if ($listing->get('owner_pickup_branch_id')): ?>
            <td><?php echo $listing->getPickup()->get('Contact')->get('email') ?></td>
        <?php else: ?>
            <td><?php echo $listing->get('Owner')->get('email') ?></td>
        <?php endif ?>

        <?php if ($listing->get('owner_dropoff_branch_id')): ?>
            <td><?php echo $listing->getDropoff()->get('Contact')->get('email') ?></td>
        <?php else: ?>
            <td><?php echo $listing->get('Owner')->get('email') ?></td>
        <?php endif ?>
    </tr>
    <tr>
        <th><?php echo __('Comment') ?></th>
        <td><?php echo $listing->get('comment') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Fuel included') ?></th>
        <td colspan="2"><?php echo $listing->get('petrol_included') ? default_text($listing->get('petrol_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Ferry included') ?></th>
        <td colspan="2"><?php echo $listing->get('ferry_included') ? default_text($listing->get('ferry_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Expenses included') ?></th>
        <td colspan="2"><?php echo $listing->get('expenses_included') ? default_text($listing->get('expenses_included_text'), __('Yes')) : __('No') ?></td>
    </tr><?php if ($listing->get('InsurancePolicy')->getId()): ?>
        <tr>
            <th><?php echo __('Insurance') ?> <?php echo tooltip('insurance_included') ?></th>
            <td colspan="2">
              <ul style="list-style-type: none;padding:0;">
                <li>
                  <?php echo __('Bond') ?> 
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="A bond is an amount of money frozen on your credit card. Providing there are no additional charges at the end of your rental, the bond will be refunded to the same card."></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('bond') ?></li>
                <li>
                  <?php echo __('Excess') ?>
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="An excess is a contribution you are required to pay towards a claim you make on your car insurance policy"></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('excess') ?></li>
                <li>
                  <?php echo __('Insurance waivers') ?> 
                  <i class="fui-info-circle tip-top" data-toggle="tooltip" data-tooltip-style="light" title="A collision damage waiver (CDW) or loss damage waiver (LDW), is optional damage insurance coverage that is available to you when you rent a car."></i>:
                  <?php echo $listing->get('InsurancePolicy')->get('waiver') ?>
                  </li>
              </ul>
            </td>
        </tr>
    <?php else: ?>
    <tr>
        <th><?php echo __('Insurance') ?></th>
        <td colspan="2"><?php echo $listing->get('insurance_included') ? default_text($listing->get('insurance_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <?php endif ?>
    <tr>
        <th><?php echo __('Road tolls included') ?></th>
        <td colspan="2"><?php echo $listing->get('tolls_included') ? default_text($listing->get('tolls_included_text'), __('Yes')) : __('No') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Kms allowed') ?></th>
        <td colspan="2"><?php echo $listing->get('kms_allowed') ?>&nbsp;</td>
    </tr>
    <tr>
        <th><?php echo __('Nb free days') ?></th>
        <td colspan="2"><?php echo $request->get('nb_free_days') ?>&nbsp;</td>
    </tr>
    <tr>
        <th><?php echo __('Nb paid days') ?></th>
        <td colspan="2"><?php echo $request->get('nb_paid_days') ?>&nbsp;</td>
    </tr>
    <tr>
        <th><?php echo __('Price per paid day') ?></th>
        <td colspan="2">
            <?php if ($listing->get('price_per_day')): ?>
                $<?php echo $listing->get('price_per_day') ?> <?php echo strtoupper($listing->get('PickupLocation')->get('Category')->get('Country')->get('domain')) ?>D
            <?php endif ?>
        </td>
    </tr>
    <tr>
        <th><?php echo __('Request ID') ?></th>
        <td colspan="2"><?php echo $request->getId() ?></td>
    </tr>
    <tr>
        <th><?php echo __('Request date') ?></th>
        <td colspan="2"><?php echo $request->get('created_at') ?></td>
    </tr>
    <tr>
        <th><?php echo __('Request status') ?></th>
        <td colspan="2"><?php echo $request->get('status') ?></td>
    </tr>
</table>
<?php else: ?>
    Not booked yet!
<?php endif ?>