<?php use_helper('I18N', 'TransfercarRO') ?>
<h3>Vehicle details</h3>
<table class="table tables-tc">
    <?php if ($listing->get('owner_vehicle_type_id')): ?>
        <?php $vehicle = $listing->get('OwnerVehicleType') ?>
        <tr>
            <th><?php echo __('Name') ?></th>
            <td class="text-right"><?php echo $vehicle->get('name') ?></td>
        </tr>
        <tr>
            <th><?php echo __('Description') ?></th>
            <td class="text-right"><?php echo $vehicle->get('description') ?></td>
        </tr>
        <tr>
            <th><?php echo __('Type') ?></th>
            <td class="text-right"><?php echo __($vehicle->get('VehicleType')->get('description')) ?></td>
        </tr>
        <?php /* if ($vehicle->get('features')): ?>
        <tr>
            <th><?php echo __('Features') ?></th>
            <td class="text-right"><?php echo ($vehicle->get('features')) ?></td>
        </tr>
        <?php endif */?>
        <tr>
            <th><?php echo __('Transmission') ?> <?php echo tooltip('vehicle_transmission') ?></th>
            <td class="text-right"><?php echo __($vehicle->getTransmissionName()) ?></td>
        </tr>
        <tr>
            <th><?php echo __('Fuel type') ?></th>
            <td class="text-right"><?php echo __($vehicle->getFuelName()) ?></td>
        </tr>
        <?php if ($listing->getCountryDomain() == 'nz'): ?>
            <tr>
                <th><?php echo __('Road user charges') ?></th>
                <td class="text-right">
                    <a target="_blank" href="https://www.nzta.govt.nz/vehicles/licensing-rego/road-user-charges/ruc-rates-and-transaction-fees/">Road user charges may apply</a>
                </td>
            </tr>
        <?php endif ?>
        <tr>
            <th><?php echo __('Year') ?> <?php echo tooltip('vehicle_year') ?></th>
            <td class="text-right">
                <?php echo default_text($vehicle->get('year'), __('Unknown')) ?>
                <?php if ($vehicle->get('max_year')): ?>
                    - <?php echo default_text($vehicle->get('max_year')) ?>
                <?php endif ?>
            </td>
        </tr>

        <tr>
            <th><?php echo __('Max travellers') ?></th>
            <td class="text-right">
                <?php if (!$vehicle->get('number_adults') && !$vehicle->get('number_children')): ?>
                    <?php echo __('N/A') ?>
                <?php else: ?>
                    <?php if ($vehicle->get('number_adults')): ?>
                        <?php echo __('%nb% adults', ['%nb%' => $vehicle->get('number_adults')]) ?>
                    <?php endif ?>
                    <?php if ($vehicle->get('number_children')): ?>
                        , <?php echo format_number_choice('[1] 1 child (1, +Inf] %nb% children', array(
                            '%nb%' => $vehicle->get('number_children')
                        ), $vehicle->get('number_children')) ?>
                    <?php endif ?>
                <?php endif ?>
            </td>
        </tr>
        <tr>
            <th><?php echo __('Storage capacity') ?></th>
            <td class="text-right">
                <?php if (!$vehicle->get('number_large_luggage') && !$vehicle->get('number_small_luggage')): ?>
                <?php echo __('N/A') ?>
                <?php else: ?>
                    <?php if ($vehicle->get('number_large_luggage')): ?>
                        <?php echo __('%nb% suitcases', ['%nb%' => $vehicle->get('number_large_luggage')]) ?>
                    <?php endif ?>
                    <?php if ($vehicle->get('number_small_luggage')): ?>
                        <?php echo ', '.format_number_choice('[1] 1 bag (1, +Inf] %nb% bags', array(
                            '%nb%' => $vehicle->get('number_small_luggage')
                        ), $vehicle->get('number_small_luggage')) ?>
                    <?php endif ?>
                <?php endif ?>
            </td>
        </tr>
    <?php else: ?>
        <tr>
            <th><?php echo __('Type' )?></th>
            <td class="text-right"><?php echo $listing->get('VehicleType')->get('description') ?></td>
        </tr>
    <?php endif ?>
</table>