<?php

use Twilio\Rest\Client;
use Twilio\Exceptions\RestException;

class tcSmsEvent
{
    private static
        $twilio_sid,
        $twilio_token,
        $twilio_phone_number;

    private static function init()
    {
        self::$twilio_sid          = sfConfig::get('app_twilio_sid');
        self::$twilio_token        = sfConfig::get('app_twilio_token');
        self::$twilio_phone_number = sfConfig::get('app_twilio_phone_number');
    }

    public static function send($template_name, $template_data, $phone_number)
    {
        self::init();
        // Get data from template
        $template = Doctrine_Query::create()
            ->from('SmsTemplate')
            ->where('name = ?', $template_name)
            ->fetchOne();

        if (!$template)
        {
            return;
        }

        $msg = $template->content;
        foreach($template_data as $index => $value)
        {
            $msg = str_replace('###'.$index.'###', $value, $msg);
        }

        try {

            $client = new Client(self::$twilio_sid, self::$twilio_token);
            $message = $client->messages->create(preg_replace('/^00/', '+', $phone_number), array(
                'from' => self::$twilio_phone_number, // From a valid Twilio number
                'body' => $msg
            ));
        }
        catch (RestException $e)
        {
            // error while sending the sms
        }
    }
}