<?php

class tcSmsNotificationEvents
{
    public static function register(sfEventDispatcher $dispatcher)
    {
        $dispatcher->connect('user.updated', array('tcUserSmsEvent', 'listedToUserUpdated'));

        /*
            Note about relocation.accepted: it don't need to be connected here, as this event is already
            used by RelocationAcceptedEmail to push a message to Rabbitmq, and will be consumed by a task
            later on. This task will then trigger the sms
        */
        $dispatcher->connect('relocation.confirmed', array('tcRequestSmsEvents', 'listenToRelocationConfirmed'));
        // Cancellations triggered by users (RO or Driver)
        // $dispatcher->connect('request.cancelled', array('tcRequestSmsEvents', 'notify'));
        // Automatic cancellations: overlapping or rejected requests
        $dispatcher->connect('request.cancelled', array('tcRequestSmsEvents', 'listenToRequestCancelled'));
        $dispatcher->connect('request.rejected', array('tcRequestSmsEvents', 'listenToRequestRejected'));
        $dispatcher->connect('request.expired', array('tcRequestSmsEvents', 'listenToRequestExpired'));
#        $dispatcher->connect('request.rated', array('tcRequestSmsEvents', 'listenToRequestRated'));
    }
}
