<?php

class tcUserSmsEvent extends tcSmsEvent
{
    public static function listedToUserUpdated(sfEvent $event)
    {
        $user = $event->getSubject();

        self::sendSmsCode($user);
    }

    public static function sendSmsCode(User $user, $force = false)
    {
        /*
         * Sends an sms if the mobile number is not confirmed, and if the user has not been sent an
         * activation code yet.
         * The force option allows to regenerate and resend a code if the sms was not received or the mobile
         * phone number updated.
         */
        if (($user->get('sms_number_confirmed') === false && strlen($user->get('sms_number')) != 6) || $force)
        {
            $user->set('sms_number', mt_rand(100000, 999999)); // six digits number to be sent by sms
            $user->save();

            $template_data = array(
                'activation_number' => $user->get('sms_number'),
                'first_name'        => $user->get('firstname'),
                'last_name'         => $user->get('lastname'),
            );

            self::send('phone_confirmation', $template_data, $user->get('mobile_phone'));
        }
    }
}