<?php

abstract class BaseTcStatsActions extends sfActions
{
    public function executeIndex(sfWebRequest $request)
    {
        $type = $request->getParameter('type', TcStats::DAILY_QUERY);
        $this->user = $this->getTransfercarUser($request);

        $finder = new TcStats(Doctrine_Manager::connection());
        $stats = $finder->find($type, $this->user->getId());
        $pager = new tcStatsPager('TcStats', 30);
        $pager->setStats($stats);
        $pager->setPage($request->getParameter('page', 1));
        $pager->init();
        $this->stats = $stats;
        $this->pager = $pager;

        $this->type = $type;
    }

    public function executeExport(sfWebRequest $request)
    {
        $type = $request->getParameter('type', TcStats::DAILY_QUERY);
        $this->user = $this->getTransfercarUser($request);

        $finder = new TcStats(Doctrine_Manager::connection());
        $stats = $finder->find($type, $this->user->getId(), PDO::FETCH_ASSOC);


        $data = count($stats) ? array(implode(';', array_keys($stats[0]))) : array();

        foreach ($stats as $stat)
        {
            $data[] = '"'.implode('";"', $stat).'"';
        }

        $data = implode("\n", $data);

        $this->getResponse()->clearHttpHeaders();
        $this->getResponse()->setContentType('application/force-download');
        $this->getResponse()->setHttpHeader('Content-Disposition', 'attachment; filename="export.csv"');
        $this->getResponse()->setHttpHeader('Content-Transfer-Encoding', 'binary');
        $this->getResponse()->setHttpHeader('Content-Length', strlen($data));
        $this->getResponse()->setHttpHeader('Connection', 'close');

        $this->getResponse()->setContent($data);

        return sfView::NONE;
    }

    abstract protected function getTransfercarUser(sfWebRequest $request);
}