<?php

class tcStatsPager extends sfPager
{
    private $stats;

    public function setStats($stats)
    {
        $this->stats = $stats;
    }

    public function init()
    {
        $this->setNbResults(count($this->stats));

        $this->setLastPage(ceil($this->getNbResults() / $this->getMaxPerPage()));
    }

    public function getResults()
    {
        $offset = ($this->getPage() - 1) * $this->getMaxPerPage();

        return array_slice($this->stats, $offset, $this->getMaxPerPage());
    }

    protected function retrieveObject($offset)
    {
        return isset($this->stats[$offset]) ? $this->stats[$offset] : false;
    }
}