<?php


class UpdateStats
{
    private $conn;

    public function __construct($conn)
    {
        $this->conn = $conn;
    }

    public function update($lastUpdateTs)
    {
        $results = array();
        foreach ($this->getHandlers() as $handler)
        {
            $results[] = $handler->update($lastUpdateTs);
        }

        return $results;
    }

    private function getHandlers()
    {
        return array(
            new UpdateListingStats($this->conn),
            new UpdatePaymentStats($this->conn),
        );
    }


}