<?php

class transfercarUpdatestatsTask extends sfPropelBaseTask
{
  protected function configure()
  {
    $this->namespace        = 'transfercar';
    $this->name             = 'update-stats';
    $this->briefDescription = '';
    $this->detailedDescription = <<<EOF
The [transfercar:update-stats|INFO] task does things.
Call it with:

  [php symfony transfercar:update-stats|INFO]
EOF;

    $this->addArgument('date', sfCommandArgument::OPTIONAL, 'Date of the last update', date('Y-m-d', strtotime('-1 day')));
    $this->addArgument('application', sfCommandArgument::OPTIONAL, 'The application name', 'frontend');
    // add other arguments here
    $this->addOption('env', null, sfCommandOption::PARAMETER_REQUIRED, 'The environment', 'dev');
    $this->addOption('connection', null, sfCommandOption::PARAMETER_REQUIRED, 'The connection name', 'doctrine');
    // add other options here
  }

  protected function execute($arguments = array(), $options = array())
  {
    error_reporting(E_ALL|E_STRICT);
    ini_set('display_errors', true);

    $this->logSection('listing-stats', 'start update');
    // Database initialization
    $databaseManager = new sfDatabaseManager($this->configuration);

    $updateHandler = new UpdateStats(Doctrine_Manager::connection());
    $results = $updateHandler->update($arguments['date']);


    foreach ($results as $res) {
      $this->logSection('listing-stats', $res['name']. ': '.$res['inserted']. ' rows inserted');
    }

    $this->logSection('listing-stats', 'end update');
  }
}
