<?php if (!isset($urls)) return ?>
<?php use_javascript('admin/dashboard.js') ?>
<?php use_javascript('datepicker.js') ?>

<?php use_stylesheet('datepicker/base.css') ?>
<?php use_stylesheet('datepicker/clean.css') ?>
<?php $id = uniqid() ?>

<div id="datepicker-<?php echo $id ?>" class="date-range right">
    <div class="date-range-field">
      <span></span>
      <a href="#">&#9660;</a>
    </div>
    <div class="row datepicker-calendar">
        <div class="col-md-8 datepicker-calendar-container"></div>
        <div class="col-md-4">
            <div class="row">
                <select name="date[shortcut]" id="date_shortcut_<?php echo $id ?>">
                    <option value="last_week">Last week</option>
                    <option value="last_month">Last month</option>
                    <option value="last_year">Last year</option>
                </select>
            </div>
            <div class="row">
                <div class="col-md-3">
                    <label class="inline" for="date_from_<?php echo $id ?>">From</label>
                </div>
                <div class="col-md-9">
                    <input id="date_from_<?php echo $id ?>" type="text" placeholder="YYYY/MM/DD" class="small" name="date[from]" />
                </div>
                <div class="col-md-3">
                    <label class="inline" for="date_to_<?php echo $id ?>">To</label>
                </div>
                <div class="col-md-9">
                    <input id="date_to_<?php echo $id ?>" type="text" placeholder="YYYY/MM/DD" name="date[to]" />
                </div>
            </div>
            <button class="tiny button">OK</button>
        </div>
    </div>
</div>

<?php append_slot('javascripts') ?>
<script type="text/javascript">
(function($){
    $(function(){
        initDatePicker($, document.getElementById('<?php echo $context ?>'), <?php echo json_encode($urls instanceof sfOutputEscaper ? $urls->getRawValue() : $urls) ?>, <?php echo isset($callback) ? $callback : 'false' ?>);
    });
}(jQuery));
</script>
<?php end_slot() ?>