<?php use_javascript('highcharts/highcharts.js') ?>
<?php use_javascript('highcharts/modules/exporting.js') ?>
<div id="donut_chart_container" class="clearfix" style="width: 500px; height: 300px; margin: 0"></div>
<script type="text/javascript">
var donut_chart;

function buildDataArrays(data, categories, browserData, versionsData)
{
    var colors = Highcharts.getOptions().colors;
    data.each(function(d, i) {
        d.color = colors[i];
        d.drilldown.color = colors[i];
    });

    // Build the data arrays
    browserData = browserData || [];
    versionsData = versionsData || [];

    for (var i = 0; i < data.length; i++) {

        // add browser data
        browserData.push({
            name: categories[i],
            y: data[i].y,
            color: data[i].color
        });

        // add version data
        for (var j = 0; j < data[i].drilldown.data.length; j++) {
            var brightness = 0.2 - (j / data[i].drilldown.data.length) / 5 ;
            versionsData.push({
                name: data[i].drilldown.categories[j],
                y: data[i].drilldown.data[j],
                color: Highcharts.Color(data[i].color).brighten(brightness).get()
            });
        }
    }
}

(function() {
    var colors = Highcharts.getOptions().colors,
        categories = <?php echo $sf_data->getRaw('owners'); ?>,
        name = 'Browser brands',
        data = <?php echo $sf_data->getRaw('data'); ?>;



    // Build the data arrays
    var browserData = [];
    var versionsData = [];
    buildDataArrays(data, categories, browserData, versionsData);

    // Create the chart
    donut_chart = new Highcharts.Chart({
        chart: {
            renderTo: 'donut_chart_container',
            type: 'pie',
            backgroundColor: '#eeeeee'
        },
        title: {
            text: 'Top 5 owners stats'
        },
        yAxis: {
            title: {
                text: 'Total percent'
            }
        },
        plotOptions: {
            pie: {
                shadow: false
            }
        },
        tooltip: {
    	    valuePrefix: 'Total: '
        },
        series: [{
            name: 'Top5',
            data: browserData,
            size: '60%',
            dataLabels: {
                formatter: function() {
                    return this.y > 5 ? this.point.name : null;
                },
                color: 'white',
                distance: -30
            }
        }, {
            name: 'Versions',
            data: versionsData,
            innerSize: '60%',
            dataLabels: {
                formatter: function() {
                    // display only if larger than 1
                    return this.y > 1 ? '<b>'+ this.point.name +':</b> '+ this.y : null;
                }
            }
        }]
    });
})();
</script>