<?php

class userSettingsActions extends sfActions
{
   /**
    * Show current user account balance history.
    * Also show links for GST receipt for credit
    * card income transactions.
    *
    * @param sfWebRequest $request HTTP request object
    */
   protected function doExecuteAccountStatement($request, $user)
   {
       // $this->user = $this->getUser()->getAttribute('profile');
       // $this->user->refresh(); // account balance can be changed
       $this->user = $user;

       // Get pager info
       $items_per_page = intval(sfConfig::get('sf_payment_acc_stmnt_items_per_page'));
       $page = intval($request->getParameter('page', 1));

       // get information about payments
       $query = Doctrine_Query::create()
         ->from('Payments')
         ->where('user_id = ?', $this->user->id)
         ->orderBy('id DESC');

       $this->pager = new Doctrine_Pager($query, $page, $items_per_page);
       $this->pager->execute();

       // There is one more thing to do: we have to get all earlier
       // payment records in order to calculate opening account balance

       // Find the highest ID from fetched array
       $id = 0;
       $starting_balance = 0;

       foreach($this->pager->execute() as $item){
           $id = max($id, $item->id);
       }

       // get rest of payment records
       $rest = Doctrine_Query::create()
         ->from('Payments')
         ->where('user_id = ?', $this->user->id)
         ->addWhere('status != ?', Payments::STATUS_REJECTED)
         ->addWhere('id <= ?', $id)
         ->execute();

       foreach($rest as $item){
           $starting_balance += $item->amount;
       }

       $this->starting_balance = $starting_balance;

       return sfView::SUCCESS;
  }
}