<style type="text/css">
    .acc_statement, .acc_statement td, .acc_statement th {
        font-size: 11px;
    }
</style>

<h1><?php echo __('Account statement') ?></h1>
<div class="big_vertical_space"></div>
<h4><?php echo __('Balance:') ?> <?php echo $user->account_balance . " " . sfConfig::get("sf_currency_new") ?><?php echo tooltip('account_statement_balance') ?></h4>

<div class="big_vertical_space"></div>
<table class="acc_statement" cellpadding="0" cellspacing="0">
    <thead>
        <tr>
            <th><?php echo __('Date') ?><?php echo tooltip('account_statement_date') ?></th>
            <th><?php echo __('By') ?></th>
            <th><?php echo __('Description') ?><?php echo tooltip('account_statement_description') ?></th>
            <th><?php echo __('Driver') ?></th>
            <th><?php echo __('Credit') ?><?php echo tooltip('account_statement_debit') ?></th>
            <th><?php echo __('Debit') ?><?php echo tooltip('account_statement_credit') ?></th>
            <th><?php echo __('Balance') ?><?php echo tooltip('account_statement_transaction_balance') ?></th>
        </tr>
    </thead>
    <tbody>
        <?php if ($pager->getNumResults() == 0): ?>
            <tr><td colspan="6"><?php echo __('You do not have any account statement yet') ?></td></tr>
        <?php endif ?>
        <?php foreach($pager->execute() as $item): ?>
            <tr>
                <?php // Date column ?>
                <td><?php echo date('d/m/Y', strtotime($item->date)) ?></td>
                <td>
                    <?php if($item->amount < 0 && $item->type == 'manual'): ?>
                        <?php if ($listing = $item->getListing()): ?>
                            <?php echo $listing->rawGet('listed_by') ? $listing->get('Manager')->getFullName() : __('Unknown manager') ?>
                        <?php else: ?>
                            Transfercar
                        <?php endif ?>
                    <?php elseif ($item->amount > 0): ?>
                        <?php if ($item->type == 'cc'): ?>
                            <?php echo $item->get('User')->getFullName() ?>
                        <?php else: ?>
                            Transfercar
                        <?php endif ?>
                    <?php endif ?>
                </td>
                <?php
                // Description - if amount > 0, we have credit, if < 0,
                // user paid for request accept
                if($item->amount > 0):
                    // If we have credit card payment, add link for GST receipt

                    // Description column
                    if($item->type == 'manual' || $item->type == 'conversion'): ?>
                        <td>
                            <?php if ($item->description): ?>
                                <?php echo $item->description ?>
                            <?php else: ?>
                                Manual Income
                            <?php endif ?>
                        </td>
                    <?php elseif($item->type == 'xconversion'): ?>
                        <td><span style="color:red"><?php echo __('Balance conversion(dollar to credit)') ?></span></td>
                    <?php elseif($item->type == 'conversion_correct' && $item->getDomain()=='nz'): ?>
                        <td><span style="color:red"><?php echo __('Corrected credit values (credit / 4)') ?></span></td>
                    <?php else: ?>
                        <td><?php echo __('Credit Account') ?>

                            <?php

                            // We can have here 3 situations:
                            // a) payment is pending
                            // b) payment has been accepted
                            // c) payment has been rejected
                            switch($item->status){
                                case Payments::STATUS_ACCEPTED:
                                    echo "(" . $item->national_currency_amount . " ". strtoupper($item->Country->domain) . "D" . ") ";
                                    echo link_to('(print)', 'payment/receipt?id='.$item->id,
                                        array('target' => '_blank'));
                                    break;
                                case Payments::STATUS_NEW:
                                    echo '<i>('.__('pending').')</i>';
                                    break;
                                case Payments::STATUS_REJECTED:
                                    echo '<i>('.__('rejected').')</i>';
                                    break;
                            }
                            ?>
                        </td>
                    <?php endif ?>

                    <?php // driver columns ?>

                    <?php if ($item->assigned_record_id && $item->type == 'manual' && $listing = $item->getListing()): ?>
                            <td><?php echo $listing->getAcceptedRequest()->get('Driver')->getFullName() ?></td>
                    <?php else: ?>
                            <td>N/A</td>
                    <?php endif ?>

                    <?php // Credit column ?>
                    <?php if($item->type == 'manual'): ?>
                        <td><?php echo $item->getFormatAmount() ?></td>
                    <?php elseif ($item->getDomain() == 'nz'): ?>
                        <td><?php echo $item->getFormatAmount() ?></td>
                    <?php else: ?>
                        <td><?php echo $item->getFormatAmount() ?></td>
                    <?php endif ?>
                    <?php // Debit column ?>
                    <td>&nbsp;</td>

                <?php else: // amount < 0 ?>
                    <?php if ($item->type == 'conversionx'): ?>
                        <td><span style="color:red"><?php echo __('Balance conversion(dollar to credit)') ?></span></td>
                    <?php elseif($item->type == 'conversion_correct' && $item->getDomain() == 'nz'): ?>
                       <td><span style="color:red"><?php echo __('Corrected credit values (credit / 4)') ?></span></td>
                    <?php elseif ($item->type == 'charge_expire'): ?>
                        <td><span style="color:red"><?php echo __('Expired credits') ?></span></td>
                    <?php elseif ($item->assigned_record_id && $item->getListing()): ?>
                        <?php $request = $item->getListing()->getAcceptedRequest() ?>
                        <td><?php echo $item->assigned_record_id > 0 ? __('Refund relocation') :  __('Relocation') ?>
                            <?php echo link_to($request ? $request->getIncrementedId() : $item->assigned_record_id,
                                                    'listing/view?id='.abs($item->assigned_record_id))
                            ?>
                            (<?php echo $item->getRelocDetails() ?>)
                        </td>
                    <?php else: ?>
                        <td><?php echo $item->getDescription() ?></td>
                    <?php endif; ?>
                    <?php $listing = $item->getListing() ?>
                    <?php if($item->assigned_record_id && $item->type == 'manual' && $listing && $request = $listing->getAcceptedRequest()): ?>
                            <td><?php echo $request->get('Driver')->getFullName() ?></td>
                    <?php else: ?>
                            <td>N/A</td>
                    <?php endif ?>
                    <td>&nbsp;</td>
                    <td><?php echo $item->getFormatAmount(true) ?></td>
                <?php endif ?>

                <?php // Balance ?>
                <?php if($item->status == Payments::STATUS_ACCEPTED): ?>
                    <td> <?php echo $item->formatAmount($starting_balance) ?></td>
                    <?php $starting_balance -= $item->amount; ?>
                <?php else: ?>
                    <td>&nbsp;</td>
                <?php endif ?>

            </tr>
        <?php endforeach ?>
        <tr>
            <td colspan="1">&nbsp;</td>
            <td colspan="3"><?php echo __('(credit and debit sums are for the total number of results)') ?></td>
            <td><strong><?php echo abs($credits) ?> <?php echo __('credits') ?><?php echo tooltip('account_statement_total_credits') ?></strong></td>
            <td><strong><?php echo abs($debits) ?> <?php echo __('debits') ?><?php echo tooltip('account_statement_total_debits') ?><strong></td>
            <td>&nbsp;</td>
        </tr>
    </tbody>
    <tfoot>
    <tr>
        <th colspan="7">
            <div class="text-right">
            <?php if (sfConfig::get('sf_app') !== 'frontend'): ?>
                <label for="nb_per_page" style="display: inline"><?php echo __('Results per page') ?><?php echo tooltip('account_statement_nb_per_page') ?></label>
                <?php echo select_tag('nb_per_page', options_for_select(
                    array(20 => '20', 50 => '50', 100 => '100', 200 => '200'),
                    $sf_params->get('nb_per_page')
                ), array('style' => 'display:inline;width:65px;')) ?>
            <?php endif ?>
            <?php if ($pager->haveToPaginate()): ?>
                <?php $baseUrl = 'userSettings/accountStatement?'
                             . (($p = $sf_params->get('statement_manager')) ? '&statement_manager='.$p:'')
                             . (($p = $sf_params->get('statement_date')) ? '&statement_date='.$p:'')
                             . (($p = $sf_params->get('statement_country')) ? '&statement_country='.$p:'')
                             . (($p = $sf_params->get('id')) ? '&id='.$p:'');

                        $url = $baseUrl
                             . (($p = $sf_params->get('nb_per_page')) ? '&nb_per_page='.$p:'');
                ?>
              <?php echo link_to(image_tag(sfConfig::get('sf_admin_web_dir').'/images/first.png', array('align' => 'absmiddle', 'alt' => __('First'), 'title' => __('First'))), $url.'&page=1') ?>
              <?php echo link_to(image_tag(sfConfig::get('sf_admin_web_dir').'/images/previous.png', array('align' => 'absmiddle', 'alt' => __('Previous'), 'title' => __('Previous'))), $url.'&page='.$pager->getPreviousPage()) ?>

              <?php foreach ($pager->getRange('Sliding', array('chunk'=> 5)) as $page): ?>
                <?php echo link_to_unless($page == $pager->getPage(), $page, $url.'&page='.$page) ?>
              <?php endforeach; ?>

              <?php echo link_to(image_tag(sfConfig::get('sf_admin_web_dir').'/images/next.png', array('align' => 'absmiddle', 'alt' => __('Next'), 'title' => __('Next'))), $url.'&page='.$pager->getNextPage()) ?>
              <?php echo link_to(image_tag(sfConfig::get('sf_admin_web_dir').'/images/last.png', array('align' => 'absmiddle', 'alt' => __('Last'), 'title' => __('Last'))), $url.'&page='.$pager->getLastPage()) ?>
                <script type="text/javascript">
                jQuery('#nb_per_page').change(function() {
                    document.location.href = '<?php echo url_for($baseUrl) ?>?nb_per_page=' + $(this).val();
                });
                </script>
            <?php endif; ?>
            </div>
            <?php echo format_number_choice('[0] no result|[1] 1 result|(1,+Inf] %1% results', array('%1%' => $pager->getNumResults()), $pager->getNumResults()) ?>
        </th>
    </tr>
    </tfoot>
</table>

