<?php
    use_javascript('email_options.js');
    use_helper('Form');
    $countries = LocationCountry::getAll();
    $cities = LocationCategory::getAllIndexedById();
    $updated_div = isset($updated_div) ? $updated_div : 'main';
    $locations = [];
    foreach ($countries as $country) {
        $locations[$country['id']] = Doctrine::getTable('LocationNode')->findNestedByCountry($country['id']);
    }
?>
<script type="text/javascript">
    var show_routes = <?php if($user->email_notify_new_reloc == "routes"){ ?>true<?php }else{ ?>false<?php } ?>;
</script>

<form action="#" method="post" onsubmit="return false;" id="email_opt_form" name="email_opt_form">

    <div class="row">
        <div class="col-md-6">
            <div class="left mrs">
                <?php $radio = checkbox_tag('email_options[newsletter]', 1,
                        $user->email_newsletter, array('onclick' => 'update_newsletter(this);'));
                    echo label_for('email_options[newsletter]',
                        $radio.' Transfercar monthly newsletter')
                ?>
            </div>

            <?php echo label_for('email_options[country_newsletter]', 'for', array('class' => 'left mrs')) ?>
            <?php

            $countryById = array('none' => 'Please choose...', 'all' => 'Any country');
            foreach($countries as $country) { $countryById[$country['id']] = $country['name']; }
            echo select_tag('email_options[country_newsletter]',
                    options_for_select($countryById, $user->email_country_newsletter),
                    array(
                        'style' => 'margin-bottom:10px;',
                        'class' => 'notify_newsletter left four'
                    )
            );
            ?>
        </div>
    </div>

    <div>
        <?php
            if(!$user->email_notify_new_reloc){
                $user->email_notify_new_reloc = 'none';
            }

            $chkbx = checkbox_tag('email_options[new_reloc]', 1,
                $user->email_notify_new_reloc != 'none' ||
                $sf_user->hasAttribute('route_added') && $sf_user->getAttribute('route_added') == true, array(
                'onclick' => "toggleDisabled(this)"
            ));

            echo label_for('email_options[new_reloc]',
            $chkbx.' Notification of new relocations added')
        ?>
    </div>

    <?php $class = ($user->email_notify_new_reloc == 'disable' &&
        !$sf_user->hasAttribute('route_added')) ? 'disable' : '' ?>

    <div class="row">
        <div class="col-md-8 end plm" id="watching_formpart">
            Frequency to get information about new listings:
        </div>
    </div>
    <div class="row">
        <div class="col-md-6">

            <?php
                $radio = radiobutton_tag('email_options[type_freq]', 'daily',
                    !isset($user->email_notify_type_freq) || $user->email_notify_type_freq == 'daily', array('class' => 'select_type_notify', 'onchange' => 'changeTypeNotify(this)'));

                echo label_for('email_options[type_freq]', $radio.' Daily summary of new vehicles listed', array(
                    'style' => 'margin-top:10px;'
                ));
            ?>

            <?php

                $countryById = array('none' => 'Please choose country', 'all' => 'Any country');
                foreach($countries as $country) { $countryById[$country['id']] = $country['name']; }
                echo select_tag('email_options[country_daily_new_reloc]',
                        options_for_select($countryById, $user->email_country_new_reloc),
                        array(
                            'class' => 'eight',
                            'id' => 'source_daily_country_relocation',
                        )
                );
            ?>
        </div>
        <div class="col-md-6">

            <?php
                $radio = radiobutton_tag('email_options[type_freq]', 'instance',
                  $user->email_notify_type_freq == 'instance', array('class' => 'select_type_notify', 'onchange' => 'changeTypeNotify(this)'));
                echo label_for('email_options[type_freq]', $radio.' Instant notification of new vehicles on specified routes', array(
                    'style' => 'margin-top:10px;'
                ));
            ?>

            <div>
                <?php
                    $countryById = array('none' => 'Please choose country', 'all' => 'Any country');
                    foreach($countries as $country) { $countryById[$country['id']] = $country['name']; }
                    echo select_tag('email_options[country_instance_new_reloc]',
                            options_for_select($countryById, $user->email_country_new_reloc),
                            array(
                                'style' => 'width: 200px',
                                'onchange' => "countrySelect()",
                                'id' => 'source_instance_country_relocation',
                            )
                    );
                ?>
            </div>
            <div class="row">
                <?php $options = ''; foreach ($countries as $country): ?>
                        <?php $options .= options_for_select(Doctrine::getTable('LocationNode')->findNestedByCountry($country['id']), '', array('class' => 'departures departure_'.$country['id'])) ?>
                <?php endforeach ?>

                <label for="from" style="margin-top:10px;">From</label>
                <select id="from" class="eight notify_from" name="add_route[from]">
                    <?php echo $options ?>
                </select>

                <label for="to">To</label>
                <select id="to" class="eight notify_from" name="add_route[to]">
                    <option/>
                </select>

                <div style="margin-top:10px;">
                    <button data-tc-email-update="#<?php echo $updated_div ?>" rel="<?php echo url_for('userSettings/addWatchRoute?id='.$user->get('id')) ?>" class="email_option_button small radius button primary">Add route</button>
                </div>

             <!-- Current routes -->
            <?php if(isset($routes) and count($routes) > 0): ?>
            <div class="relocation_list" style="margin-top:10px;">
                <p><strong>Relocation watch routes</strong></p>

                <?php foreach($routes as $route): ?>
                    <div class="row" style="margin-top:10px">
                        <div class="col-md-12">
                        <label>
                            <?php echo checkbox_tag("del_route[{$route->id}]", 1, false);
                                  echo $route->LocationFrom->name . ' to ' . $route->LocationTo->name;
                            ?>
                        </label>
                        </div>
                    </div>
                <?php endforeach ?>

                <div class="form-row ptm">
                    <div class="del_route">
                        <?php echo input_hidden_tag('del_route[type]', 'email') ?>
                        <button data-tc-email-update="#<?php echo $updated_div ?>" class="email_option_button small radius button primary" rel="<?php echo url_for('userSettings/deleteWatchRoute') ?>">Delete routes</button>
                    </div>
                </div>
            </div>
            <?php endif ?>
        </div>
    </div>
    <div class="row text-right">
        <button data-tc-email-update="#<?php echo $updated_div ?>" class="email_option_button medium button success radius" rel="<?php echo url_for('userSettings/emailOptions') ?>">Save settings</button>
    </div>
</form>

<?php append_slot('javascripts') ?>

<script type="text/javascript">
<?php if ($user->email_notify_new_reloc !== 'none'): ?>
    <?php if ($user->email_notify_type_freq == "daily"): ?>
        changeTypeNotify($('#email_options_type_freq_daily'));
    <?php elseif ($user->email_notify_type_freq == "instance"): ?>
        changeTypeNotify($('#email_options_type_freq_instance'));
    <?php endif; ?>
<?php else: ?>
    jQuery('#email_options_type_freq_daily, #email_options_type_freq_instance')
        .attr('checked', false)
        .attr('disabled', 'disabled')
    ;
<?php endif ?>
</script>
<?php end_slot() ?>

<?php if ($sf_request->isXmlHttpRequest()): ?>
    <script type="text/javascript">
        initEmailsOptions();
    </script>
    <?php include_slot('javascripts') ?>
<?php endif ?>

