<?php

namespace Transfercar\Alert;

class Alert
{
    const NEW_LISTING = 1;

    const STATUS_EMAILED = 1;
    const STATUS_READ = 2;
    const STATUS_BOOKED = 4;

    public static $activities = [];
    public
        $user_id,       // (int)
        $activity_type, // (tinyint)
        $source_id,     // (int)
        $time,          // (datetime but a smaller type like int would be better)
        $status;        // activity status (email, read)

    public static function create($activity_type, $user_id, $source_id, $time)
    {
        $activity = new static();
        $activity->user_id = $user_id;
        $activity->activity_type = $activity_type;
        $activity->source_id = $source_id;
        $activity->time = $time;

        self::$activities[] = $activity;

        return $activity;
    }

    public function setEmailed()
    {
        $this->status |= self::STATUS_EMAILED;
    }

    public function isEmailed()
    {
        return (bool) ($this->status & self::STATUS_EMAILED);
    }

    public function setBooked()
    {
        $this->status |= self::STATUS_BOOKED;
    }

    public function isBooked()
    {
        return (bool) ($this->status & self::STATUS_BOOKED);
    }
}