<?php

namespace Transfercar\Alert;

class User
{
    public static $users = [];
    public
        $id,
        $subscriptions = [];

    public static function create($id)
    {
        $user = new User();
        $user->id = $id;

        self::$users[] = $user;

        return $user;
    }

    public function subscribe($from, $to)
    {
        $this->subscriptions[] = ['from' => $from, 'to' => $to];
    }

    public function isSubscribed($from, $to)
    {
        return
            array_search(['from' => $from, 'to' => $to], $this->subscriptions) !== false || // subscribe to a precise route
            array_search(['from' => $from, 'to' => ''], $this->subscriptions) !== false || // subscribe to a pickup location
            array_search(['from' => '', 'to' => $to], $this->subscriptions) !== false // subscribe to a dropoff location
        ;
    }
}