<?php

namespace Transfercar\Autocomplete;

use Doctrine;

class LocationAutocomplete
{
    public static function find($country, $q)
    {
        $results = Doctrine::getTable('LocationNode')->findNestedByCountry($country, 'slug', true);

        if ($q && strpos($q, ':') === false)
        {
            $results = self::filter($results, $q);
        }

        $autocompleteData = array();

        foreach ($results as $name => $locations)
        {
            $children = array();
            foreach ($locations as $key => $location)
            {
                $children[] = array(
                    'id' => $key,
                    'text' => $location
                );
            }

            $autocompleteData[] = array(
                'text'     => $name,
                'children' => $children
            );
        }

        return $autocompleteData;
    }

    private static function filter($results, $q)
    {
        $filtered = array();
        foreach ($results as $key => $value)
        {
            $filtered[$key] = array_filter($value, function($v) use ($q) {
                return stripos($v, $q) !== false;
            });
        }

        return array_filter($filtered);
    }
}
