<?php

namespace Transfercar\BinList;

use GuzzleHttp\Client as HttpClient;

class BinList
{
    public function getCountryCode($bin)
    {
        if ($data = $this->call($bin)) {
            return $data['country_code'];
        }

        return false;
    }

    private function call($bin)
    {
        $client = new HttpClient([
            'base_uri' => 'https://binlist.net/json/',
            'defaults' => [
                'headers' => [
                    'User-Agent' => 'Transfercar/1.0',
                    'Accept'     => 'application/json'
                ]
            ]
        ]);

        try {
            $response = $client->get($bin);

            if ($response->getStatusCode() !== 200) {
                return false;
            }

            return json_decode($response->getBody(), true);
        } catch (\Exception $e) {
            return false;
        }

        return json_decode($response->getBody(), true);
    }
}