<?php

namespace Transfercar\Bridge\Http;

use sfWebRequest;

class tcWebRequest extends sfWebRequest
{
  /**
   * Gets the request format.
   *
   * If no format is defined by the user, it defaults to the sf_format request parameter if available.
   *
   * @return string The request format
   */
  public function getRequestFormat()
  {
    if (is_null($this->format))
    {
      if ($this->getParameter('sf_format'))
      {
        $this->setRequestFormat($this->getParameter('sf_format'));
      }
    }

    return $this->format;
  }

  public function getClientIP()
  {
    return isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
  }

  public function isTransfercarClient()
  {
    $ip = $this->getClientIP();
    $ips = $this->getAttribute('transfercar_ips', []);

    return in_array($ip, $ips);
  }

  public function isSecure()
  {
    if (\sfConfig::get('app_tc_env') == 'prod') {
      return true;
    }

    return parent::isSecure();
  }
}