<?php

namespace Transfercar\Bridge\Http;

use sfWebResponse;
use sfEventDispatcher;

class tcWebResponse extends sfWebResponse
{
    public function getMetas()
    {
        $metas = parent::getMetas();
        unset($metas['title'], $metas['keywords']);

        return $metas;
    }

    public function getMeta($name)
    {
        return isset($this->metas[$name]) ? $this->metas[$name] : null;
    }

    public function initialize(sfEventDispatcher $dispatcher, $options = array())
    {
        parent::initialize($dispatcher, $options);

        $this->setHttpHeader('Cache-Control', 'no-store, no-cache, must-revalidate');
    }

    public function merge(sfWebResponse $response)
    {
        $jsSlot = isset($response->slots['javascripts']) ? $response->slots['javascripts'] : '';
        $jsSlot = (isset($this->slots['javascripts']) ? $this->slots['javascripts'] : '').$jsSlot;
        parent::merge($response);
        $this->slots['javascripts'] = $jsSlot;
    }

    public function getCharset()
    {
        return $this->options['charset'];
    }

}