<?php

namespace Transfercar\Bridge\Pager;

use Doctrine_Pager;
use Doctrine;

class tcDoctrinePager extends Doctrine_Pager
{
    /**
     * @var Doctrine_Query $_sumQuery      Doctrine_Query object related to the pager
     */
    protected $_numRelocations;

    protected function _initialize($params = array())
    {
        $sumQuery = clone $this->getCountQuery();
        $sumQuery
            ->select(sprintf('SUM(%s.nb_listings)', $sumQuery->getRootAlias()))
            ->removeDqlQueryPart('orderby')
            ->removeDqlQueryPart('groupby');

        $data = $sumQuery->execute($params, Doctrine::HYDRATE_NONE);

        $this->_numRelocations = $data[0][0];

        parent::_initialize($params);
    }

    public function getNumRelocations()
    {
        return $this->_numRelocations;
    }
}