<?php

namespace Transfercar\CurrencyRate;

use GuzzleHttp\Client as HttpClient;

class Converter
{
    public function convert($from, $to, $amount)
    {
        $client = new HttpClient([
            'base_uri' => 'http://api.fixer.io/latest',
            'defaults' => [
                'headers' => [
                    'User-Agent' => 'Transfercar/1.0',
                    'Accept'     => 'application/json'
                ]
            ]
        ]);

        $response = $client->get('', ['query' => ['symbols' => $from.','.$to, 'base' => $from]]);


        if ($response->getStatusCode() != 200) {
            throw new \RuntimeException("Unable to retrieve currency rate", 1);

        }

        $rates = json_decode($response->getBody(), true);

        return round($rates['rates']['NZD'] * $amount);
    }
}