<?php

namespace Transfercar\Database;

use Doctrine_EventListener;
use Doctrine_Event;
use DateTime;

class tcDoctrineConnectionListener extends Doctrine_EventListener
{
  private $connection;

  public function __construct($connection)
  {
    $this->connection = $connection;
  }

  public function postConnect(Doctrine_Event $event)
  {
    $query = 'SET time_zone=' . $this->connection->quote($this->getOffset());
    $this->connection->exec($query);
    $this->connection->exec('SET sql_mode = \'\'');
  }

  /**
   * Get mysql timezone from PHP configuration
   *
   * Code from http://www.sitepoint.com/synchronize-php-mysql-timezone-configuration/
   */
  private function getOffset()
  {
    $now = new DateTime();
    $mins = $now->getOffset() / 60;
    $sgn = ($mins < 0 ? -1 : 1);
    $mins = abs($mins);
    $hrs = floor($mins / 60);
    $mins -= $hrs * 60;

    return sprintf('%+d:%02d', $hrs*$sgn, $mins);
  }
}