<?php

namespace Transfercar\Doctrine;

use sfDoctrineRecord;
use sfEventDispatcher;

abstract class tcDoctrineRecord extends sfDoctrineRecord
{
  static protected $dispatcher = null;

  /**
   * Sets the EventDispatcher
   *
   * @param sfEventDispatcher $dispatcher
   */
  static public function setEventDispatcher(sfEventDispatcher $dispatcher)
  {
    self::$dispatcher = $dispatcher;
  }

  /**
   * Returns the EventDispatcher
   *
   * @return sfEventDispatcher
   */
  static public function getEventDispatcher()
  {
    return self::$dispatcher;
  }

  /**
   * Returns if EventDispatcher is available
   *
   * @return boolean
   */
  static public function hasDispatcher()
  {
    return (self::getEventDispatcher() instanceOf sfEventDispatcher);
  }
}