<?php

namespace Transfercar\Email;

// Symfony classes
use sfConfig;

// Doctrine
use Doctrine;
use Doctrine_Cache_Array;
use Doctrine_Query;

// Swift Mailer classes
use Swift_Mailer;
use Swift_Message;
use Swift_Image;
use Swift_SmtpTransport;
use Swift_FileSpool;
use Swift_SpoolTransport;
use Swift_LogContainer;
use Swift_Log_sfSwiftFileLog;

use Transfercar\SwiftMailer\TcMailerPlugin;
use Transfercar\Mandrill\TcMandrill;

/**
*  @author Sibers' Marsianin
*  @version
*
* Class ExternLib is interface to swift mailer system
*
*/
class ExternLib
{
	/*
	 * Send tickets to Transfercar Support
	 * @param $from - email address the author
	 * @param $msg  - message string
	 * @param $params - array with custom params(associative array)
	 */
    public static function sendToSupport($msg)
    {
        $from = array(sfConfig::get('app_mailer_from') =>
            sfConfig::get('app_mailer_from_name'));

        // Prepare 2 messages - one with HTML content, one without it
        $subject = "Request to support";

        $message = Swift_Message::newInstance($subject, $msg, sfConfig::get('app_mailer_mimetype'),
            sfConfig::get('app_mailer_charset'));
        $message->setFrom($from);

        $to = array(
			'email' => sfConfig::get('app_support_email'),
			'name'  => sfConfig::get('app_support_name')
        );

	    $to = array($to['email'] => $to['name']);

        $message->setTo($to);
        $message->getHeaders()->addTextHeader('X-recipient-ids', '');

        $mandrill = new TcMandrill();
        $mandrill->sendFromSwiftMessage($message);
	}

	/*
	 * Send email to Support about Error
	 * @param $msg  - message string
	 */
    public static function sendToSupportAboutError($msg)
    {
        $from = array(sfConfig::get('app_mailer_from') =>
            sfConfig::get('app_mailer_from_name'));

        // Prepare 2 messages - one with HTML content, one without it
        $subject = "Transfercar: site error notification";

        $body = $msg . "\n\n";

        $message = Swift_Message::newInstance($subject, $body, sfConfig::get('app_mailer_mimetype'), sfConfig::get('app_mailer_charset'));
        $message->setFrom($from);

        $to = array(
			'email' => 'noel@transfercar.co.nz',
			'name'  => 'Transfercar tech support'
        );


	    $to = array($to['email'] => $to['name']);
        $message->setTo($to);

        $mandrill = new TcMandrill();
        $mandrill->sendFromSwiftMessage($message);
	}
}