<?php

namespace Transfercar\Email\Sender;

use PhpAmqpLib\Message\AMQPMessage;
use Transfercar\PhpAmqpLib\tcRequestProducer;
use Transfercar\Mandrill\TcMandrill;
use sfEvent;


class RelocationAcceptedEmail extends RelocationEmail
{
    public static function queue(sfEvent $event)
    {
        $request = $event->getSubject();

        tcRequestProducer::publish($request, 'accepted_requests_delayed');
    }

    public static function notifyRo(sfEvent $event)
    {
        $request = $event->getSubject();
        $listing = $request->getListing();
        $domain  = $listing->getCountryDomain();

        if (!$listing->get('Owner')->get('accepted_request_notify')) {
            return;
        }

        $template_data = self::getTemplateData($request, $listing, $request->get('Driver'));

        $mandrill = new TcMandrill($domain);
        $mandrill->sendTemplate(
          'Transfercar Booking Details for {{DRIVER_FIRSTNAME}} {{DRIVER_LASTNAME}}',
          $listing->getNewRequestContact()->getEmailToParams(),
          $template_data,
          'request-booking-details'
        );
    }

    public static function notify($request)
    {
        $listing = $request->get('Listing');
        $driver  = $request->get('Driver');
        $domain = $listing->getCountryDomain();

        $template_data = self::getTemplateData($request, $listing, $driver);
        $template_data['firstname'] = $driver->get('firstname');

        $mandrill = new TcMandrill($domain);
        $mandrill->sendTemplate(
            'Your relocation request has been accepted',
            $request->Driver->getEmailToParams(),
            $template_data,
            'request-update'
        );
    }
}