<?php

namespace Transfercar\Email\Sender;

use Transfercar\Mandrill\TcMandrill;
use sfEvent;

class RelocationConfirmedEmail extends RelocationEmail
{
    public static function notify(sfEvent $event)
    {
        $listing = $event->getSubject();
        $request = $listing->getAcceptedRequest();
        $driver  = $request->get('Driver');

        $template_data = self::getTemplateData($request, $listing, $driver);
        $template_data['firstname'] = $driver->get('firstname');

        $template_name = isset($event['template_name']) ? $event['template_name'] : 'request-update';
        $subject = $template_name == 'request-update' ? 'Your relocation booking is confirmed' : 'Your relocation booking number';
        $mandrill = new TcMandrill($request->getCountryDomain());
        $mandrill->sendTemplate(
            $subject,
            $driver->getEmailToParams(),
            $template_data,
            $template_name
        );

        // send the booking number in another email as well
        if ($template_name == 'request-update') {

            $mandrill->sendTemplate(
                'Your relocation booking number',
                $driver->getEmailToParams(),
                $template_data,
                'booking-number-confirmed'
            );            
        }
    }
}