<?php

namespace Transfercar\Event;

use sfContext;
use sfEvent;

class ListingEvents
{
    public static function listenToListingCreated(sfEvent $event)
    {
        self::doListen($event, 'Created');
    }

    public static function listenToListingUpdated(sfEvent $event)
    {
        self::doListen($event, 'Updated');
    }

    private static function doListen($event, $action)
    {
        if (!sfContext::hasInstance()) {
            return;
        }

        $listing = $event->getSubject();
        $user    = sfContext::getInstance()->getUser();

        $user->pushFlash('ga_event', array(
            'event'           => 'gaTriggerEvent',
            'gaEventCategory' => 'Listing',
            'gaEventAction'   => $action,
            'gaEventLabel'    => $listing->getId()
        ));


	
        if ($action == 'Created' && $listing->isStatus(\Listing::STATUS_NEW) && $listing->get('nb_listings') > 10) {
          \Transfercar\Slack\SlackNotification::sendMessage('New listing created', [
            'Rental Operator' => $listing->get('Owner')->get('company'),
            'Route' => $listing->getTitle(),
            'Quantity' => $listing->get('nb_listings')
          ], 'new-listings');	
	}

    }
}
