<?php

namespace Transfercar\Event;

use sfConfig;
use sfEvent;
use DateTime;
use Mixpanel;
use User;

class MixpanelEvent
{
    public static function listenToDriverLoggedIn(sfEvent $event)
    {
        $user = $event->getSubject();
        self::identifyUser($user, 'driver', (new DateTime($user->get('when_registered')))->format('Y-m-d\TH:i:s'));
    }

    public static function listenToManagerLoggedIn(sfEvent $event)
    {
        $user = $event->getSubject();
        self::identifyUser($user, 'manager', null);
    }

    private static function identifyUser($user, $type, $created_at)
    {
        // log only on prod
        if (sfConfig::get('app_tc_env') != 'prod')
        {
            return;
        }

        $ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
        $mp = Mixpanel::getInstance(sfConfig::get('app_mixpanel_token'));
        $mp->people->set($type.'_'.$user->get('id'), array(
            '$first_name'       => $user->get('firstname'),
            '$last_name'        => $user->get('lastname'),
            '$username'         => $user->get('username'),
            '$email'            => $user->get('email'),
            '$created'          => $created_at,
            'last_login'        => (new DateTime())->format('Y-m-d\TH:i:s'),
            'type'              => $type,
            'date_of_birth'     => $user instanceof User && $user->get('date_of_birth') ? $user->get('date_of_birth') : null,
            'license'           => $user instanceof User && $user->get('license') ? $user->get('license') : null,
            'contact_phone'     => $user instanceof User && $user->get('contact_phone') ? $user->get('contact_phone') : null
        ), $ip);
    }
}