<?php

namespace Transfercar\Geoloc;

class ClusterNameFinder
{
    private $conn,
            $country;

    public function __construct($conn, $country)
    {
        $this->conn = $conn;
        $this->country = $country;
    }

    public function find($points)
    {
        $results = [];

        foreach ($points as $point)
        {
            list($lat, $long) = explode(',', $point);
            $stmt = $this->query($lat, $long);
            $place = $stmt->fetch();
            $results[$point] = $place['name'];
        }

        return $results;
    }

    private function query($lat, $long, $country)
    {
        $query = 'select p.name, sqrt(pow(110.56*(p.lat - :lat), 2) + pow(84.8*(p.lon - :lon), 2)) as distance
            from places p
            where p.country_id=:country
            order by distance asc
            limit 1';

        $stmt = $this->conn->prepare($query);

        $stmt->execute(array('lat' => $lat, 'lon' => $long, 'country' => $this->country));

        return $stmt;
    }
}