<?php

namespace Transfercar\Ranking;

use Listing;

class SearchScore
{
    public $debug;
    public $errors = [];

    public function getScore(Listing $listing)
    {
        $roVoter = new RoVoter();
        $listingVoter = new ListingVoter();

        $upvotes = 10 * ($roVoter->getUpVotes($listing->get('Owner')) + $listingVoter->getUpVotes($listing));
        $downvotes = $roVoter->getDownVotes($listing->get('Owner')) + $listingVoter->getDownVotes($listing);

        $this->debug = $roVoter->getDebug()."\n".$listingVoter->getDebug();
        $this->errors = array_merge($listingVoter->getErrors(), $roVoter->getErrors());

        $wilson = new WilsonConfidenceIntervalCalculator();

        $score = $wilson->getScore($upvotes, $upvotes+$downvotes);

        return is_nan($score) ? 0 : $score;
    }

    public function getErrors()
    {
        return $this->errors;
    }
}