<?php

namespace Transfercar\Search;

use Transfercar\ElasticSearch\BrowseQuery;
use Doctrine;

class ListingSearch
{
    private $filters,
            $action;

    public function setFilters($filters)
    {
        $this->filters = $filters;

        return $this;
    }

    public function setAction($action)
    {
        $this->action = $action;

        return $this;
    }

    public function getPager($page, $maxListingPerPage = 20, $maxSponsoredAdsPerPage = 4)
    {
        $pager = new tcListingPager($maxListingPerPage);

        $pager
            ->setListingQuery($this->getListingQuery())
            ->setSponsoredAdsQuery($this->getSponsoredAdsQuery())
            ->setPage($page)
            ->init();

        return $pager;
    }

    public function getListingQuery()
    {
        return BrowseQuery::buildElasticSearch($this->action, $this->filters);
    }

    public function getSponsoredAdsQuery()
    {
        return Doctrine::getTable('AdListing')->findForFiltersQuery($this->action->getUser()->getCountry(), $this->filters);
    }
}


