<?php

namespace Transfercar\Slack;

use GuzzleHttp\Client as HttpClient;

class SlackNotification
{
    public function sendMessage($message, $attachments = [], $channel = 'default')
    {
        $hooks = [
            'default' => 'https://hooks.slack.com/services/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',
            'driver-reviews' => 'https://hooks.slack.com/services/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',
	    'testing' => 'https://hooks.slack.com/services/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',
	    'new-listings' => 'https://hooks.slack.com/services/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'
        ];
        $client = new HttpClient([
            'base_uri' => isset($hooks[$channel]) ? $hooks[$channel] : $hooks['default'],
            'defaults' => [
                'headers' => [
                    'User-Agent' => 'Transfercar/1.0',
                    'Accept'     => 'application/json'
                ]
            ]
        ]);
        try {
            $response = $client->post('', ['json' => [
                'blocks' => [
                    [
                        'type' => 'header',
                        'text' => [
                            'type' => 'plain_text',
                            'text' => $message
                        ]
                    ],
                    [
                        'type' => 'section',
                        'fields' => self::formatFields($attachments)
                    ]

                ]
            ]]);   
        } catch (\Exception $e) {
            throw $e;
            
        }
    }

    private static function formatFields($attachments) {
        $fields = [];

        foreach ($attachments as $key => $value) {
            $fields[] = [
                'type' => 'plain_text',
                'text' => sprintf('%s: %s', $key, $value)
            ];
        }

        return $fields;
    }
}
