<?php

namespace Transfercar\Storage;

use sfSessionStorage;

class tcSessionStorage extends sfSessionStorage
{
    public function initialize($options = null)
    {
        $options['auto_start'] = false;

        return parent::initialize($options);
    }

    public function startSession($checkSession = false)
    {
        if ($checkSession && !isset($_COOKIE[$this->options['session_name']]))
        {
            return;
        }

        if (!self::$sessionStarted)
        {
            session_start();
            self::$sessionStarted = true;
        }
    }

    public function read($key)
    {
        $this->startSession(true);

        return parent::read($key);
    }

    public function remove($key)
    {
        $this->startSession();

        return parent::remove($key);
    }

    public function write($key, $data)
    {
        $this->startSession();

        return parent::write($key, $data);
    }
}