<?php

namespace Transfercar\Stripe;

class TcStripe
{
    public function __construct()
    {
        \Stripe\Stripe::setApiKey($_SERVER['stripe_private_key']);
    }

    public function createCustomer($email, $username, $tc_type, $token)
    {
        $customer = \Stripe\Customer::create([
            'source' => $token,
            'email' => $email,
            'description' => $username,
            'metadata' => [ 'tc_type' => $tc_type ]
        ]);

        return $customer;
    }

    public function addCard($user, $token)
    {
        $customer = \Stripe\Customer::retrieve($user);
        return $customer->sources->create(["source" => $token]);
    }

    public function retrieveCard($user, $card)
    {
        $customer = \Stripe\Customer::retrieve($user);
        return $customer->sources->retrieve($card);
    }

    public function updateCustomer($user)
    {
        if ($user->get('stripe_token')) {
            $cu = \Stripe\Customer::retrieve($user->get('stripe_token'));
            $cu->email = $user->get('email');
            $cu->save();
        }
    }

    public function chargeCreditCard($payload)
    {
        return \Stripe\Charge::create($payload);
    }
}
